Package: FELLA
Type: Package
Title: Interpretation and enrichment for metabolomics data
Version: 1.32.0
Date: 2019-10-19
Authors@R: c(
    person(
        "Sergio", "Picart-Armada", role = c("aut", "cre"),
        email = "sergi.picart@upc.edu"), 
    person(
        "Francesc", "Fernandez-Albert", role = c("aut"),
        email = "francesc.fernandez.albert@upc.edu"),
    person(
        "Alexandre", "Perera-Lluna", role = c("aut"),
        email = "alexandre.perera@upc.edu"))
Maintainer: Sergio Picart-Armada <sergi.picart@upc.edu>
Description: Enrichment of metabolomics data using KEGG entries. 
    Given a set of affected compounds, FELLA suggests affected
    reactions, enzymes, modules and pathways using label propagation 
    in a knowledge model network. The resulting subnetwork 
    can be visualised and exported. 
License: GPL-3
LazyLoad: yes
Imports: methods, igraph, Matrix, KEGGREST, plyr, stats, graphics,
        utils
Enhances:
Depends: R (>= 3.5.0)
Suggests: shiny, DT, magrittr, visNetwork, knitr, BiocStyle, rmarkdown,
        testthat, biomaRt, org.Hs.eg.db, org.Mm.eg.db, AnnotationDbi,
        GOSemSim
VignetteBuilder: knitr
RoxygenNote: 6.1.1
Encoding: UTF-8
biocViews: Software, Metabolomics, GraphAndNetwork, KEGG, GO, Pathways,
        Network, NetworkEnrichment
Collate: 'AllArguments.R' 'AllClasses.R' 'AllMethods.R'
        'generateResultsTable.R' 'generateEnzymesTable.R'
        'generateResultsGraph.R' 'exportResults.R' 'addGOToGraph.R'
        'buildGraphFromKEGGREST.R' 'buildDataFromGraph.R'
        'defineCompounds.R' 'doc-data.R' 'doc-package.R'
        'runHypergeom.R' 'runDiffusion.R' 'runPagerank.R' 'enrich.R'
        'get-.R' 'is-.R' 'launchApp.R' 'list-.R' 'loadKEGGdata.R'
        'plotBipartite.R' 'plotGraph.R' 'plotLegend.R'
git_url: https://git.bioconductor.org/packages/FELLA
git_branch: RELEASE_3_23
git_last_commit: ed22719
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 22:34:20 UTC; biocbuild
Author: Sergio Picart-Armada [aut, cre],
  Francesc Fernandez-Albert [aut],
  Alexandre Perera-Lluna [aut]

# Enriching metabolomics data through diffusion

[![Travis-CI Build Status](https://travis-ci.org/b2slab/FELLA.svg?branch=master)](https://travis-ci.org/b2slab/FELLA)
[![codecov.io](https://codecov.io/github/b2slab/FELLA/coverage.svg?branch=master)](https://codecov.io/github/b2slab/FELLA?branch=master)

This repository contains the `FELLA` package. `FELLA` is a metabolomics data enrichment tool that contextualises the experimental results using KEGG reactions, enzymes, modules and pathways. 

- The input for our package is a __list of affected metabolites__ between experimental conditions. 
- The layout of the analysis is in a __comprehensive human-readable layout__, exportable to several formats, containing a biological interpetation of the experiment. 

The subnetwork displayed to the user is found using diffusive processes on a graph that represents the known biological annotations at several molecular levels. To use this package type in your terminal: 

```bash
R CMD build FELLA
R CMD INSTALL FELLA
```

Alternatively, you can use `devtools` if you experience some trouble building the vignette. Working in the package directory, this should do the trick:

```r
devtools::install(build_vignettes = T)
```

Once `FELLA` is installed, you may load it by typing in your R terminal

```r
library("FELLA")
```

To get the global picture about `FELLA` usage, you may browse its __vignette__

```r
browseVignettes("FELLA")
```

All of the functions in `FELLA` have a (very basic) documentation, inclusive 
the package and the sample data `FELLA.sample` and `input.sample`.

In addition, there is a shiny app to facilitate the 
usage of the package. Before launching it, a 
database should be built. For example, for Homo sapiens 
excluding the hsa01100 pathway:

```r
g <- buildGraphFromKEGGREST(
  organism = "hsa", 
  filter.path = "hsa01100"
)
buildDataFromGraph(g)
```

Then we can launch the shiny app 

```r
FELLA:::launchApp(
  host = "127.0.0.1", 
  port = 8888
)
```

and leave the command active. Going to the direction 
http://127.0.0.1:8888 will start the analysis.

# server.R

shinyServer(function(input, output, session) {
  # Database of choice
  # This could be loaded in global.R to save memory, but 
  # this way each user can load a different database
  FELLA.DATA <- reactive({
    if (input$database != "") {
      withProgress(message = "Loading database", value = .5, {
        ans <- loadKEGGdata(
          databaseDir = input$database, 
          internalDir = FALSE, 
          loadMatrix = c("diffusion", "pagerank")
        )
        incProgress(amount = .5, message = "Done")
      })
      ans
    }
  })
  # database summary
  output$databaseInfo <- renderText({
    data <- FELLA.DATA()
    if (is.null(data)) {
      c(
        "Database directory is empty...", 
        "\nMake sure you executed the following", 
        "\nat least once after installing FELLA:", 
        "\nbuildGraphFromKEGGREST", 
        "\nbuildDataFromGraph")
    } else {
      comment(FELLA:::getGraph(data))
    }
  })
  
  # First step: create the USER variable
  createUser <- reactive({
    if (input$radioInput == 1) {
      read.comp <- readLines("examples/input_1_compounds.list")
    } else if (input$radioInput == 2) {
      read.comp <- readLines("examples/input_2_compounds.list")
    } else if (input$radioInput == 3) {
      read.comp <- readLines("examples/input_3_metaboanalyst.list")
    } else {
      if (!is.null(input$file)) {
        read.file <- read.table(
          input$file$datapath, 
          header = FALSE, 
          stringsAsFactors = FALSE)
        read.comp <- as.character(read.file[, 1])
        read.comp <- read.comp[complete.cases(read.comp)]
        if (is.null(read.comp)) {
          return(NULL)
        }
      }
      else {
        message("No compounds uploaded yet.")
        return(NULL)
      }
    }
    data <- FELLA.DATA()
    if (is.null(data)) return(NULL)
    
    withProgress(message = "Running enrichment", value = .5, {
      result <- enrich(
        compounds = read.comp, 
        method = input$method, 
        approx =input$approx, 
        niter = input$niter, 
        data = data)
      
      incProgress(amount = .5, message = "Done")
    })
    
    return(result)
  })
  
  # Show the user how the file looks like
  output$exampleInput <- renderText(
    paste(
      readLines("examples/input_2_compounds.list"), 
      collapse = "\n"
    )
  )
  
  # Second: the summary of the compounds in the input: 
  # read names, mapped and unmapped metabolites
  inputSummary <- reactive({
    data <- FELLA.DATA()
    if (!is.null(createUser()) & !is.null(data)) {
      input <- getInput(createUser())
      inputNames <- getName(data, input)
      inputNames <- sapply(inputNames, function(x) {
        if (length(x)) {
          return(x[[1]])}
        return(NULL)
      }) 
      excluded <- getExcluded(createUser())
      
      return(list("input" = input, 
                  "inputNames" = inputNames, 
                  "excluded" = excluded))
    }
  })
  
  # Downloadable example file 
  output$downloadExample <- downloadHandler(
    filename = function() {
      "example2.txt"
    }, 
    content = function(file) {
      con <- readLines("examples/input_2_compounds.list")
      write(con, file)
    }, 
    contentType = "text"
  )
  
  # Table showing current compounds
  output$tableCompounds <- renderTable({
    if (!is.null(inputSummary())) {
      outTable <- cbind(inputSummary()$inputNames)
      colnames(outTable) <- "KEGG name"
      return(outTable)
    }
  })
  
  # Table showing excluded compounds
  output$tableExcluded <- renderTable({
    if (!is.null(inputSummary())) {
      if (length(inputSummary()$excluded) > 0) {
        outTable <- data.frame(inputSummary()$excluded)
        names(outTable) <- "KEGG id"
        return(outTable)
      }
    }
  })
  
  # Generate the graph 
  # The current graph is extracted using another function, though,
  # because the current graph can vary with the user-selected 
  # GO term, if any
  generateGraph <- reactive({
    usr <- createUser()
    data <- FELLA.DATA()
    if (!is.null(usr) & !is.null(data)) {
      return(
        generateResultsGraph(
          object = usr,
          method = input$method, 
          threshold = input$threshold, 
          plimit = 15, 
          nlimit = input$nlimit, 
          thresholdConnectedComponent = input$thresholdConnectedComponent, 
          LabelLengthAtPlot = input$LabelLengthAtPlot, 
          data = data))
    }
  })
 
  # This function returns the currently chosen graph connected component
  currentGraph <- reactive({
    if (!is.null(createUser())) {
      g <- generateGraph()
      # GO tag?
      orgDb <- input$GOorgDb
      ont <- input$GOOntology
      biomart <- input$GObiomart
      dataset <- input$GOdataset
      if (input$GOTermInput != "" & 
          input$method != "hypergeom" &
          !is.null(orgDb) & 
          !is.null(ont) & 
          !is.null(biomart) & 
          !is.null(dataset)) {
        
        withProgress(message = "Adding GO term legend", value = .5, {
          g_go <- addGOToGraph(
            graph = g, 
            GOterm = input$GOTermInput, 
            godata.options = list(
              OrgDb = orgDb, 
              ont = ont
            ), 
            mart.options = list(
              biomart = biomart, 
              dataset = dataset
            )
          )
          
          incProgress(amount = .5, message = "Done")
        })
        
        return(g_go)
      }
      return(g)
    }
    return(NULL)
  })
  
  # Tooltip about the current graph size
  output$graphSize <- renderText({
    if (!is.null(createUser())) {
      g <- currentGraph()
      if (!is.null(g))  {
        txt <- paste0("Number of nodes: ", vcount(g))
        
        if (input$GOTermInput != "") {
          txt <- paste(
            txt, 
            "Legend for GO term similarity:", 
            "  (low) yellow < orange < red < purple (high)", 
            sep = "\n"
          )
        }
        return(txt)
      } else {
        return("Graph is NULL! No significant pathways have been found.")
      }
    }
  })
  # ---------------------------------------------------
  # Table of results
  output$tableSolution <- DT::renderDataTable({
    data <- FELLA.DATA()
    user <- createUser()
    g <- currentGraph()
    if (!is.null(data) & !is.null(g) & is.igraph(g)) {
      if (vcount(g) == 0) return(NULL)
      wholeTable <- generateResultsTable(
        object = user, 
        method = input$method, 
        threshold = input$threshold,
        plimit = 15, 
        nlimit = input$nlimit, 
        LabelLengthAtPlot = 100, 
        data = data)
      
      # Only nodes in graph
      plottedRows <- wholeTable$"KEGG.id" %in% V(g)$name
      outTable <- wholeTable[plottedRows, ]
      rownames(outTable) <- NULL
      
      # Add hyperlinks to KEGG
      outTable$"KEGG.id" <- paste0(
        "<a href=\"http://www.genome.jp/dbget-bin/www_bget?",
        outTable$"KEGG.id", "\"", "\ target=\"_blank", 
        "\">", outTable$"KEGG.id", "</a>")
      escape <- which(colnames(outTable) == "KEGG.id")
      
      DT::datatable(outTable, 
                    escape = escape, 
                    options = list(pageLength = 100)) %>%
        DT::formatSignif(columns = "p.score", digits = 2)
    }
  })
  
  # ---------------------------------------------------
  #  CC example: change default value for the updateTextInput!
  observe({
    if (input$exampleGOCC > 0) {
      updateTextInput(session, "GOTermInput", value = "GO:0005739")
      updateTextInput(session, "GOorgDb", value = "org.Hs.eg.db")
      updateSelectInput(session, "GOOntology", selected = "CC")
      updateTextInput(session, "GObiomart", value = "ensembl")
      updateTextInput(session, "GOdataset", value = "hsapiens_gene_ensembl")
    }
  })
  
  ###########################################################
  # network as a list with nodes and edges
  network <- reactive({
    g <- currentGraph()
    if (!is.null(g)) {
      id <- V(g)$name
      label <- V(g)$label
      nodes <- data.frame(id, label, stringsAsFactors = FALSE)
      
      # GO labels?
      if ("GO.simil" %in% list.vertex.attributes(g)) {
        GO.simil <- unlist(V(g)$GO.simil)
        GO.annot <- TRUE
      } else {
        GO.annot <- FALSE
      }
      
      map.com <- c("pathway", "module", "enzyme", "reaction", "compound")
      map.color <- c("#E6A3A3", "#E2D3E2", "#DFC1A3", "#D0E5F2", "#A4D4A4")
      map.labelcolor <- c("#CD0000", "#CD96CD", "#CE6700", 
                          "#8DB6CD", "#548B54")
      map.nodeWidth <- c(40, 30, 25, 22, 22)

      nodeShape <- ifelse(
        V(g)$name %in% getInput(createUser()),
        "box",
        "ellipse"
      )
      nodes$group <- map.com[V(g)$com]
      nodes$color <- map.color[V(g)$com]

      # width
      nodes$value <- map.nodeWidth[V(g)$com]
      nodes$shape <- nodeShape
      
      # Change color and label if GO annotations are present
      if (GO.annot) {
        ids <- !is.na(GO.simil)
        GO.semsim <- GO.simil[ids]
        GO.hits <- names(GO.semsim)
        if (!is.null(GO.hits)) {
          newColor <- sapply(
            GO.semsim, 
            function(x) {
              if (x < 0.5) return("#FFD500")
              else if (x < 0.7) return("#FF5500")
              else if (x < 0.9) return("#FF0000")
              return("#B300FF")
            }
          )
          newName <- paste0(nodes$label[ids], "[", GO.hits, "]")
          newShape <- "triangle"
          
          # modify name and color
          nodes$label[ids] <- newName
          nodes$color[ids] <- newColor
          nodes$shape[ids] <- newShape
        }
      }
      
      # tooltip
      nodeLink <- paste0(
        "<a href=\"http://www.genome.jp/dbget-bin/www_bget?",
        V(g)$name, "\"", "\ target=\"_blank", "\">", V(g)$name, "</a>")
      if(vcount(g) == 0) nodeLink <- character(0)

      nodes$title <- nodeLink
      
      source <- V(g)[get.edgelist(g)[, 1]]$name
      target <- V(g)[get.edgelist(g)[, 2]]$name
      edges <- data.frame(source, target, stringsAsFactors = FALSE)
      
      names(edges) <- c("from", "to")

      network <- list(
        nodes = nodes,
        edges = edges)
      
      return(network)
    }
    return(NULL)
  })
  
  output$cytoscapePlot <- renderVisNetwork({
      net <- network()
      if (!is.null(net)) {
          visNetwork(nodes = net$nodes, edges = net$edges) %>%
              visIgraphLayout() %>%
              visEdges(smooth = FALSE) %>% 
              visOptions(
                  selectedBy = "group", 
                  nodesIdSelection = TRUE,
                  highlightNearest = TRUE)
      }
  })
  ###########################################################
  
  output$exportResults_csv <- downloadHandler(
    filename = function() {
      "resultsTable.csv"
    }, 
    content = function(file) {
      data <- FELLA.DATA()
      if (!is.null(data)) {
        exportResults(
          format = "csv", 
          file = file, 
          object = createUser(), 
          method = input$method, 
          threshold = input$threshold,
          nlimit = input$nlimit, 
          plimit = 15, 
          data = data)
      }
      
    }, 
    contentType = "text/csv"
  )
  
  tableEnzymes <- reactive({
    user <- createUser()
    data <- FELLA.DATA()
    if (!is.null(user) & !is.null(data)) {
      generateEnzymesTable(
        object = user, 
        method = input$method, 
        threshold = input$threshold,
        nlimit = input$nlimit, 
        data = data, 
        mart.options = NULL)
    }
  })
  output$exportEnzymes_csv <- downloadHandler(
    filename = function() {
      "enzymesTable.csv"
    }, 
    content = function(file) {
      tab <- tableEnzymes()
      if (!is.null(tab)) {
        write.csv(
          x = tab, 
          file = file, 
          row.names = FALSE
        )
      }
    }, 
    contentType = "text/csv"
  )
  
  output$exportEnzymes_genelist <- downloadHandler(
    filename = function() {
      "genesFromEnzymes.txt"
    }, 
    content = function(file) {
      tab <- tableEnzymes()
      if (!is.null(tab)) {
        writeLines(
          text = unique(unlist(strsplit(tab$Genes, split = ";"))), 
          con = file
        )
      }
    }, 
    contentType = "text"
  )
  
  output$exportigraph <- downloadHandler(
    filename = function() {
      "resultsSubgraph.RData"
    }, 
    content = function(file) {
      data <- FELLA.DATA()
      if (!is.null(data)) {
        exportResults(
          format = "igraph", 
          file = file, 
          object = createUser(), 
          method = input$method, 
          threshold = input$threshold,
          thresholdConnectedComponent = input$thresholdConnectedComponent, 
          nlimit = input$nlimit, 
          plimit = 15, 
          data = data)
      }
    } 
  )
})

library(igraph)

# path <- "~/Datasets/FELLAdataslim/"
matrices <- c("hypergeom")

# Only the graph is needed, then using FELLA's functions we will
# generate the data from a toy graph
db <- loadKEGGdata()
keggdata.graph <- getGraph(db)
metadata <- comment(keggdata.graph)
# keggdata.graph <- buildGraphFromKEGGREST()
# load(paste0(path, "keggdata.graph.RData"))

#############################################
# Code from Sam Steingold at list.nongnu.org
graph.reverse <- function (graph) {
  if (!is.directed(graph))
    return(graph)
  e <- get.data.frame(graph, what="edges")
  ## swap "from" & "to"
  neworder <- 1:length(e)
  neworder[1:2] <- c(2,1)
  e <- e[neworder]
  names(e) <- names(e)[neworder]
  graph.data.frame(e, vertices = get.data.frame(graph, what="vertices"))
}
#############################################

keggdata.graph <- graph.reverse(keggdata.graph)

# First, let's build a toy graph with two close pathways
pathway <- c("hsa00640", "hsa00010")

# all the nodes under the umbrella of those two guys
d <- distances(keggdata.graph, mode = "out", v = pathway)
any <- apply(d, 2, function(col) any(col < 5))
newnodes <- colnames(d)[any]

# sample input
id.compounds <- V(keggdata.graph)[V(keggdata.graph)$com == 5]$name
any.firstpath <- intersect(colnames(d)[d[1, ] < 5], id.compounds)

set.seed(1)
input.sample <- sample(any.firstpath, 30)

# Leave original weights
graph.sample <- graph.reverse(induced.subgraph(keggdata.graph, newnodes))
comment(graph.sample) <- metadata

# Use a temporary directory to save the data and reload it later
tmpdir <- paste0(tempdir(), "/databuild/")
# FELLA::buildDataFromGraph(graph.toy, outputDir = tmpdir, niter = 11)

# Generate the data without diffusion/pagerank matrices
FELLA::buildDataFromGraph(
    graph.sample, 
    databaseDir = tmpdir, 
    internalDir = FALSE, 
    matrices = matrices, 
    niter = 100)

list.files(tmpdir)
e.temp <- new.env(parent = globalenv())
sapply(
    list.files(tmpdir, full.names = T), 
    function(link) load(link, envir = e.temp))
# save(list = ls(e), file = "data-raw/test.RData", envir = e.temp)

FELLA.sample <- FELLA::loadKEGGdata(tmpdir, internalDir = FALSE)

# test it...
k <- enrich(
    compounds = input.sample, 
    method = "diffusion", 
    approx = "normality", 
    data = FELLA.sample)
plot(k, data = FELLA.sample, 
     method = "diffusion", 
     threshold = .1)


# it seems to work! 
# save them as loadable data examples
save(FELLA.sample, file = "data/FELLA.sample.RData")
save(input.sample, file = "data/input.sample.RData")

#' @description 
#' Function \code{defineCompounds} creates a 
#' \code{\link{FELLA.USER}} object from a list of 
#' compounds and a \code{\link{FELLA.DATA}} object.
#' 
#' @details
#' Function \code{defineCompounds} maps the 
#' specficied list of KEGG compounds [Kanehisa, 2017], usually from an 
#' experimental metabolomics study, to the graph contained in the
#' \code{\link{FELLA.DATA}} object. 
#' Importantly, the names must be KEGG ids, so other formats 
#' (common names, HMDB ids, etc) must be mapped to KEGG first. 
#' For example, through the "Compound ID Conversion" 
#' tool in MetaboAnalyst [Xia, 2015].
#' The user can also define a personalised background as a 
#' list of KEGG compound ids, which should be more extensive than 
#' the list of input metabolites. 
#' Once the compounds are mapped, the enrichment 
#' can be performed through \code{runHypergeom}, 
#' \code{runDiffusion} and \code{runPagerank}.
#'
#' @inheritParams .params
#'
#' @return \code{defineCompounds} returns 
#' the \code{\link{FELLA.USER}} object 
#' with the mapped metabolites, ready to be enriched.
#' 
#' @name enrich-funs
#' @rdname enrich-funs 
#' 
#' @export
defineCompounds <- function(
    compounds = NULL, 
    compoundsBackground = NULL, 
    data = NULL) {
    
    FELLA.USER <- new("FELLA.USER")
    
    # Checking the input
    ################################
    # Load the FELLA.DATA object (required right now)
    if (!is.FELLA.DATA(data)) {
        stop("'data' is not a FELLA.DATA object")
    } else if (getStatus(data) != "loaded"){
        stop("'data' points to an empty FELLA.DATA object")
    }
    ################################
    
    # Optional: load the background of compounds for permutation calculation
    if (length(compoundsBackground) == 0) {
        message(
            "No background compounds specified. ", 
            "Default background will be used.")
        compoundsBackground <- getCom(data, "compound")
    } else {
        compoundsBackground <- as.character(compoundsBackground)
        compoundsBackground <- intersect(
            compoundsBackground, 
            getCom(data, "compound"))
        
        if (length(compoundsBackground) < 10) {
            warning(
                "Less than ten of the specified background compounds", 
                "appear in the available KEGG data. ", 
                "Default background will be used instead.")
            compoundsBackground <- getCom(data, "compound")
        } else {
            FELLA.USER@userinput@metabolitesbackground <- compoundsBackground
        }
    }
    
    # Load affected metabolites for the enrichment
    if (length(compounds) == 0) stop("Argument 'compounds' cannot be empty.")
    # Repeated compounds will be accounted once only
    compounds <- unique(as.character(compounds))
    compoundsOld <- compounds
    
    # Check whether any of the compounds 
    # in the input are not in the background...
    
    compoundsInBackground <- intersect(compoundsBackground, compounds)
    if (length(compoundsInBackground) < length(compounds)) {
        warning(
            "Some compounds were introduced as affected ", 
            "but they do not belong to the background. ", 
            "These compounds will be excluded from the analysis. ", 
            "Use 'getExcluded' to see them.")
        compounds <- compoundsInBackground
    }
    
    if (length(compounds) == 0) {
        stop(
            "None of the specified compounds ", 
            "appear in the available KEGG data.")
    } else {
        FELLA.USER@userinput@metabolites <- compounds
    }
    
    FELLA.USER@userinput@excluded <- setdiff(compoundsOld, compounds)
    
    return(FELLA.USER)
}

# library(shiny)

shinyUI(fluidPage(
  titlePanel(
    title = h1(
      a(href = "http://b2slab.upc.edu/", 
        img(src='b2slab_small.png', align = "center", height = "50px")), 
      "FELLA: pathway analysis for metabolomics data", 
      a(href = "http://www.creb.upc.edu/", 
        img(src='creb_upc.png', align = "center", height = "50px"), 
        align = "center")),  
    windowTitle = "FELLA: enriching metabolomics data"
  ),
  
  fluidRow(
    tabsetPanel(
      tabPanel(
        "1. Upload compounds", 
        column(
          12, 
          column(
            3, 
            h2("Overview"), 
            h4("FELLA allows the user to perform 
               a pathway enrichment on metabolomics data 
               using the KEGG database."), 
            h3("1. Upload compounds"), 
            h5("The user can upload a list of metabolites as a text file 
               containing KEGG ids.  
               Three sample lists show the app functionalities. 
               Once the metabolites are defined,  
               the matches and the mismatches are displayed."), 
            h3("2. Advanced options"), 
            h5("This tab lets the user adjust methodological and 
               graphical parameters. For instance, 
               the algorithm to prioritise the nodes, 
               the thresholds and the maximum amount of nodes 
               to display. Furthermore, the enzymes in the solution can 
               be overlaid with their similarity to a user-defined 
               GO label."), 
            h3("3. Interactive results"), 
            h5("This tab draws the solution and lets the user zoom, move, 
               search and highlight nodes in the solution graph. 
               Below, a table describes the depicted nodes 
               and links to their KEGG entries in their website."), 
            h3("4. Export results"), 
            h5("A variety of output formats are available 
               for downloading the results.")
            ), 
          column(
            3,
            h2("Upload compounds"), 
            radioButtons(
              "radioInput", 
              label = h4("List of metabolites to enrich:"),
              choices = list("Example 1" = 1, 
                             "Example 2" = 2, 
                             "Example MetaboAnalyst" = 3, 
                             "I will upload my compounds" = 4),
              selected = 1),
            
            fileInput("file", label = ""),
            
            br(), 
            h2("Example file"), 
            h5("Here is a sample of the format understood by FELLA.
               This is the content of the data for 'Example 2'. 
               KEGG identifiers can be quoted as well, but this is not 
               necessary. The file extension is irrelevant (.txt, .csv) 
               as long as the format is correct."), 
            h6("Make sure the KEGG compounds are parsed as expected 
               in the right column. For instance, seek mismatches due to 
               whitespaces."), 
            downloadButton("downloadExample", "Download Example 2"), 
            h5("Contents of the file:"), 
            verbatimTextOutput("exampleInput")
            ),
          
          column(
            5,
            h2("Check the uploaded compounds"), 
            h5("Successfully mapped KEGG ids:"), 
            tableOutput("tableCompounds"), 
            h5("Mismatching compounds:"),
            h6("Note: due to the graph curation, 
               not every KEGG compound is within the FELLA database,
               Even if the KEGG id exists, 
               a mismatch can take place."), 
            tableOutput("tableExcluded") 
          )
        )
      ), 
      tabPanel(
        "2. Advanced options", 
        column(
          12, 
          h2("Adjust arguments (optional)"), 
          column(
            4,
            h3("The database"), 
            selectInput(
              "database", 
              label = h4("Local databases choice"),
              choices = pathData), 
            verbatimTextOutput("databaseInfo"), 
            h3("The method"), 
            #################################
            selectInput(
              "method", 
              label = h4("Method choice"),
              choices = list("Hypergeometric test" = "hypergeom", 
                             "Heat diffusion" = "diffusion", 
                             "PageRank" = "pagerank"),
              selected = "diffusion"), 
            
            #################################
            selectInput(
              "approx", 
              label = h4("P-values approximation"),
              choices = list("Normality" = "normality", 
                             "Simulation (slower)" = "simulation"),
              selected = "normality"), 
            sliderInput(
              "niter", 
              label = h4(
                "Number of iterations (if simulation)"), 
              min = 5000, 
              max = 15000, 
              step = 1000,
              value = 10000)
          ), 
          column(
            4,
            h3("Graphical parameters"), 
            #################################
            sliderInput(
              "threshold", 
              label = h4(
                "Threshold (p-score) for the nodes in the solution graph"), 
              min = 0.005, 
              max = 0.2, 
              step = 0.005,
              value = 0.05), 
            #################################
            sliderInput(
              "nlimit", 
              label = h4(
                "Limit for the number of nodes in the solution graph"), 
              min = 40, 
              max = 300, 
              step = 5, 
              value = 250), 
            #################################
            sliderInput(
              "thresholdConnectedComponent", 
              label = h4(
                "Threshold for the size of a connected component to be shown"), 
              min = 0.01, 
              max = 1, 
              step = 0.001,
              value = 0.05), 
            #################################
            sliderInput(
              "LabelLengthAtPlot", 
              label = h4("Limit for the label length in the plot"), 
              min = 10, 
              max = 100, 
              step = 1, 
              value = 50)
            #################################
          ), 
          column(
            4,
            h3("GO labels for enzymes"), 
            h4("Adding a GO term takes some time, please be patient"),
            h5("The user can add a GO label visual filter for the 
               enzymes in the output. For example, we can decide 
               to filter by 'mitochondrion' by clicking the following button:"),
            actionButton("exampleGOCC", label = "GO: mitochondrion example"), 
            h6("The GO term for each enzyme family is determined by 
               the best semantic similarity using the genes in it.  
               The GO term of the best hit is appended 
               to the node label and the node shape becomes triangular. 
               If GO annotations are unavailable for an enzyme, it is 
               left with a circular shape."),
            #################################
            textInput(
              "GOTermInput", 
              label = h4(
                "Specify a GO term"), 
              value = NULL), 
            h3("GO data options"), 
            textInput(
              "GOorgDb", 
              label = h4("GO orgDb"), 
              value = NULL
            ),
            selectInput(
              "GOOntology", 
              label = h4("GO ontology"), 
              choices = c("CC", "MF", "BP")
            ),
            h3("biomaRt options"), 
            textInput(
              "GObiomart", 
              label = h4(
                "Specify a biomaRt"), 
              value = NULL), 
            textInput(
              "GOdataset", 
              label = h4(
                "Specify a dataset"), 
              value = NULL), 
            
            #################################
            selectInput(
              "GONamesAsLabels", 
              label = h4(
                  "Should GO names used as labels, instead of GO id's?"),
              choices = list("Yes" = TRUE, "No" = FALSE),
              selected = TRUE)
            )
          )
        
      ), 
      #################################
      tabPanel(
        "3. Interactive results", 
        column(
          12,
          shiny::br(), 
          column(6, verbatimTextOutput("graphSize")), 
          visNetworkOutput(
              "cytoscapePlot", 
              height = "800px"
              # width = "1200px"
              ), 
          DT::dataTableOutput("tableSolution")
        )
        
      ), 
      #################################
      tabPanel(
        "4. Export results", 
        column(
          12, 
          h2("Export tables"),
          h4("Export the whole results table as csv"),
          downloadButton("exportResults_csv", "Download table with results"), 
          h4("Export the enzymes in the solution 
             with related genes and GO terms as csv"), 
          downloadButton(
            "exportEnzymes_csv", "Download table with enzymes"),
          h4("Export the genes (entrez) that belong to 
             the enzyme EC numbers as a text file"), 
          downloadButton(
            "exportEnzymes_genelist", "Download text file with genes"),
          h2("Export graph solution to R igraph"), 
          downloadButton("exportigraph", "Download R igraph solution")
        )
      )
    )
  )
))

#' @include runDiffusion.R
#' 
#' @details
#' Function \code{runPagerank} performs the random walk 
#' based enrichment on a 
#' \code{\link{FELLA.USER}} object with mapped metabolites 
#' and a \code{\link{FELLA.DATA}} object.
#' If a custom background was specified, it will be used. 
#' PageRank was originally conceived as a scoring system for websites 
#' [Page, 1999]. 
#' Intuitively, PageRank favours nodes that 
#' (1) have a large amount of nodes pointing 
#' at them, and (2) whose pointing nodes also have high scores. 
#' Classical PageRank is formulated in terms of a random walker -  
#' the PageRank of a given node is the stationary probability 
#' of the walker visiting it. 
#' 
#' The walker chooses, in each step, 
#' whether to continue the random walk with probability 
#' \code{dampingFactor} or to restart it with probability 
#' \code{1 - dampingFactor}. 
#' In the original publication, \code{dampingFactor = 0.85}, 
#' which is the value used in \code{FELLA} by default. 
#' If he or she continues, an edge is picked from the outgoing edges 
#' in the current node with a probability proportional to its weight. 
#' If he or she restarts it, a node is uniformly picked from the 
#' whole graph. 
#' The "personalised PageRank" variant allows a user-defined 
#' distribution as the source of new random walks. 
#' The R package \code{igraph} contains such variant in its 
#' \code{\link[igraph:page_rank]{page.rank}} function [Csardi, 2006].
#' 
#' As described in the supplement S3 from [Picart-Armada, 2017], 
#' the PageRank \code{PR} can be computed as 
#' a column vector by imposing a stationary 
#' state in the probability.
#' With a damping factor \code{d} and the user-defined 
#' distribution \code{p} as a column vector:
#' 
#' \deqn{
#' \textrm{PR} = d\cdot M\cdot \textrm{PR} + (1 - d)\cdot p
#' }{
#' PR = d*M*PR + (1 - d)*p
#' }
#' 
#' \code{M} is the matrix whose element \code{M[i,j]} is the 
#' probability of transitioning from \code{j} to \code{i}. 
#' If node \code{j} has outgoing edges, their probability is proportional 
#' to their weight - all weights must be positive. 
#' If node \code{j} has no outgoing edges, the probability is 
#' uniform over all the nodes, i.e. \code{M[i,j] = 1/nrow(M)} 
#' for every \code{i}. 
#' Note that all the columns from \code{M} sum up exactly \code{1}.
#' This leads to an expression to compute PageRank:
#' 
#' \deqn{
#' \textrm{PR} = (1 - d)p \cdot(I - dM)^{-1}
#' }{
#' PR = (1 - d)*p*(I - d*M)^(-1)
#' }
#' 
#' The idea behind the method \code{"pagerank"} is closely related 
#' to \code{"diffusion"}. 
#' Relevant metabolites are the sources of new random walks and 
#' nodes are scored through their PageRank. 
#' Specifically, \code{p} is set to a uniform probability on the 
#' input metabolites. 
#' More details on the setup can be found in 
#' the supplementary file S3 from [Picart-Armada, 2017].
#' 
# ' @template approxTemplate
#'
#' @inheritParams .params
#'
#' @return \code{runPagerank} returns a 
#' \code{\link[FELLA]{FELLA.USER}} object 
#' updated with the PageRank enrichment results
#' 
#' @rdname enrich-funs
#' 
#' @importFrom stats ecdf pnorm pgamma pt
#' @import Matrix
#' @import igraph
#' @export
runPagerank <- function(
    object = NULL, 
    data = NULL, 
    approx = "normality", 
    dampingFactor = 0.85, 
    t.df = 10, 
    niter = 1000) {
    
    # Checking the input
    ###########################
    checkArgs <- checkArguments(
        approx = approx, 
        dampingFactor = dampingFactor, 
        t.df = t.df, 
        niter = niter,
        object = object, 
        data = data)
    if (!checkArgs$valid)
        stop("Bad argument when calling function 'runPagerank'.")
    
    if (getStatus(data) != "loaded"){
        message(
            "'data' points to an empty FELLA.DATA object! ", 
            "Returning original 'object'...")
        return(object)
    }
    #####################
    
    message("Running PageRank...")
    
    d <- dampingFactor
    
    # The metabolites in the input
    comp.input <- getInput(object)
    n.input <- length(comp.input)
    
    if (n.input == 0) {
        message(
            "PageRank failed because ", 
            "there are no compounds in the input.")
        return(object)
    }
    
    ###### First case: simulation
    if (approx == "simulation") {
        message("Estimating p-values by simulation.")
        
        # The background
        if (length(getBackground(object)) == 0) {
            comp.background <- getCom(data, "compound")
        } else {
            comp.background <- getBackground(object)
        }
        
        if (prod(dim(getMatrix(data, "pagerank"))) == 1) {
            message(
                "PageRank matrix not loaded. ", 
                "Simulations may be a bit slower...", 
                "Using provided damping factor")
            
            # Load the graph 
            graph <- getGraph(data)
            n.nodes <- vcount(graph)
            
            # Prior for personalized PageRank
            prior <- numeric(n.nodes)
            names(prior) <- V(graph)$name
            
            # Current scores
            prior[comp.input] <- 1
            current.score <- page.rank(
                graph = graph, 
                directed = TRUE, 
                damping = d, 
                personalized = prior)$vector
            prior[comp.input] <- 0
            
            # Null model
            null.score <- vapply(seq_len(niter), function(dummy) {
                if (dummy %% round(.1*niter) == 0) 
                    message(round(dummy*100/niter),"%")
                
                prior[sample(comp.background, n.input)] <- 1
                page.rank(
                    graph = graph, 
                    directed = TRUE, 
                    damping = d, 
                    personalized = prior)$vector
            }, FUN.VALUE = double(n.nodes))
            
            pscores <- vapply(seq_len(n.nodes), function(row) {
                ((1 - stats::ecdf(null.score[row, ])(current.score[row]))*
                    n.nodes + 1)/(n.nodes + 1)
            }, FUN.VALUE = double(1))
            names(pscores) <- V(graph)$name
            
        } else {
            # Calculate current scores.
            # Warning: each score vector should be divided by n.input 
            # to be consistent with the rest of this function.
            # This is not done, because it just rescales all the scores 
            # and becomes irrelevant when computing the empirical p-value.
            message(
                "Using pagerank matrix. ", 
                "Damping factor will be the one with which the database ",
                "was built")
            
            pagerank.matrix <- getMatrix(data, "pagerank")
            
            current.score <- rowSums(
                pagerank.matrix[, comp.input, drop = FALSE])
            
            null.score <- vapply(seq_len(niter), function(dummy) {
                if (dummy %% round(.1*niter) == 0) 
                    message(round(dummy*100/niter),"%")
                
                rowSums(pagerank.matrix[, sample(comp.background, n.input)])
            }, FUN.VALUE = double(n.nodes))
            
            n.nodes <- length(current.score)
            pscores <- vapply(seq_len(n.nodes), function(row) {
                ((1 - stats::ecdf(null.score[row, ])(current.score[row]))*
                    n.nodes + 1)/(n.nodes + 1)
            }, FUN.VALUE = double(1))
            names(pscores) <- rownames(pagerank.matrix)
        }
    ###### Second case: moments   
    } else {
        message("Computing p-scores through the specified distribution.")
        
        # The background
        if (length(getBackground(object)) > 0) {
            if (prod(dim(getMatrix(data, "pagerank"))) == 1) {
                # Custom background, no matrix...
                message(
                    "PageRank matrix not loaded. ", 
                    "Normality is not available yet for custom background.")
                return(object)
            } else {
                # Custom background, matrix available
                background.matrix <- 
                    getMatrix(data, "pagerank")[, getBackground(object)]
                RowSums <- rowSums(background.matrix)
                squaredRowSums <- apply(
                    X = background.matrix, 
                    MARGIN = 1, 
                    FUN = function(row) sum(row*row))
                
                n.comp <- ncol(background.matrix)
            }
        } else {# Default background
            n.comp <- length(getCom(data, "compound"))
            
            # RowSums
            if (length(getSums(data, "pagerank", squared = FALSE)) == 0) {
                message(
                    "RowSums not available. ", 
                    "The normal approximation cannot be done.")
                return(object)
            } else {
                RowSums <- getSums(data, "pagerank", squared = FALSE)
            }
            
            # Squared RowSums
            if (length(getSums(data, "pagerank", squared = TRUE)) == 0) {
                message(
                    "squaredRowSums not available. ", 
                    "The normal approximation cannot be done.")
                return(object)
            } else {
                squaredRowSums <- getSums(data, "pagerank", squared = TRUE)
            }
        }
        
        # Compute current score
        # Load the graph 
        graph <- getGraph(data)
        
        # Prior for personalized PageRank
        prior <- numeric(vcount(graph))
        names(prior) <- V(graph)$name
        
        message("Using provided damping factor...")
        
        # Current scores
        prior[comp.input] <- 1
        current.score <- page.rank(
            graph = graph, 
            directed = TRUE, 
            damping = d, 
            personalized = prior)$vector
        
        # p-scores
        # statistical moments
        # note that, compared to runDiffusion, these 
        # moments are divided by n.input (means) 
        # and by n.input**2 (vars)
        # This is becasue igraph takes as input the indicator
        # vector divided by its sum, which is indeed n.input
        score.means <- RowSums/n.comp
        score.vars <- (n.comp - n.input)/(n.input*n.comp*(n.comp - 1))*
            (squaredRowSums - (RowSums^2)/n.comp)
        
        if (approx == "normality") {
            pscores <- stats::pnorm(
                q = current.score, 
                mean = score.means, 
                sd = sqrt(score.vars), 
                lower.tail = FALSE)
        }
        if (approx == "gamma") {
            pscores <- stats::pgamma(
                q = current.score, 
                shape = score.means^2/score.vars, 
                scale = score.vars/score.means, 
                lower.tail = FALSE)
        }
        if (approx == "t") {
            pscores <- stats::pt(
                q = (current.score - score.means)/sqrt(score.vars), 
                df = t.df, 
                lower.tail = FALSE)
        }
        
        names(pscores) <- names(RowSums)
        
    } 
    
    object@pagerank@pscores <- pscores
    object@pagerank@approx <- approx
    object@pagerank@niter <- niter  
    
    message("Done.")
    object@pagerank@valid <- TRUE
    return(object)
}

#' @include buildGraphFromKEGGREST.R
#' 
#' @description  
#' Function \code{buildDataFromGraph} takes as input the KEGG graph 
#' generated by \code{buildGraphFromKEGGREST} 
#' and writes the KEGG knowledge model in the desired permanent directory. 
#' 
#' @details
#' Using \code{buildDataFromGraph} is the second step 
#' to use the \code{\link[=FELLA]{FELLA}} package. 
#' The knoledge graph is used to compute other internal variables that are 
#' required to run any enrichment. 
#' The main point behind the enrichment is to provide a small 
#' part of the knowledge graph relevant to the supplied metabolites. 
#' This is accomplished through diffusion processes and random walks, 
#' followed by a statistical normalisation, 
#' as described in [Picart-Armada, 2017].
#' When building the internal files, 
#' the user can choose whether to store (i) matrices for each 
#' provided method, and (ii) vectors derived from such matrices 
#' to use the parametric approaches. 
#' These are optional but enable (i) faster permutations and custom 
#' metabolite backgrounds, and (ii) parametric approaches. 
#' WARNING: diffusion and PageRank matrices in (i) 
#' can allocate up to 250MB each. 
#' On the other hand, the \code{niter} parameter 
#' controls the amount of trials to approximate the 
#' distribution of the connected component size under 
#' uniform node sampling. 
#' For further info, see the option \code{thresholdConnectedComponent} 
#' in the details from \code{?generateResultsGraph}. 
#' Regarding the destination, the user can specify 
#' the name of the directory. 
#' Otherwise a name containing the creation date, the organism 
#' and the KEGG release will be used. 
#' The database can be stored within the library path or in a 
#' custom location. 
#' 
#'
#' @inheritParams .params
#' @param keggdata.graph An \pkg{igraph} 
#' object generated by the function 
#' \code{buildGraphFromKEGGREST}
#' @param databaseDir Character containing the directory to save KEGG files. 
#' It is a relative directory inside the library location
#' if \code{internalDir = TRUE}. If left to \code{NULL}, 
#' an automatic name containing the date, organism and 
#' the KEGG release is generated.
#' @param internalDir Logical, should the directory be internal 
#' in the package directory?
#' @param matrices A character vector, containing any of these: 
#' \code{"hypergeom"}, \code{"diffusion"}, \code{"pagerank"}
#' @param normality A character vector, containing any of these: 
#' \code{"diffusion"}, \code{"pagerank"}
#' @param niter Numeric value, number of iterations to estimate the p-values 
#' for the CC size. Between 10 and 1e3.
#'
#' @return \code{buildDataFromGraph} returns 
#' \code{invisible(TRUE)} if successful. 
#' As a side effect, the
#' directory \code{outdir} is created, containing 
#' the internal data.
#' 
#' @rdname data-funs 
#' 
#' @import igraph
#' @import Matrix
#' @export
buildDataFromGraph <- function(
    keggdata.graph = NULL, 
    databaseDir = NULL, 
    internalDir = TRUE, 
    matrices = c("hypergeom", "diffusion", "pagerank"), 
    normality = c("diffusion", "pagerank"), 
    dampingFactor = 0.85, 
    niter = 1e2) {
    
    # Checking the input #
    ######################
    checkArgs <- checkArguments(
        dampingFactor = dampingFactor, 
        databaseDir = databaseDir, 
        internalDir = internalDir)
    if (!checkArgs$valid)
        stop("Bad argument when calling function 'buildDataFromGraph'.")  
    
    # Check the graph
    graph <- keggdata.graph
    
    if (!is.igraph(graph)) 
        stop("'keggdata.graph' is not a valid igraph object.")
    
    if (!is.connected(graph)) 
        stop("'keggdata.graph' is not connected!")
    
    if (!("com" %in% list.vertex.attributes(graph))) 
        stop(
            "'keggdata.graph' is not a valid graph: ",
            "'com' attribute is missing.")
    
    # Check other arguments
    if (!is.null(matrices) & !is.character(matrices))
        stop(
            "'matrices' should be a character vector containing one or more: ", 
            "'hypergeom', 'diffusion', 'pagerank'.")
    
    if (!is.null(normality) & !is.character(normality))
        stop(
            "'normality' should be a character vector containing one or more: ",
            "'diffusion', 'pagerank'.")
    
    if (!is.numeric(niter)) 
        stop("'niter' must be an integer greater than 10 and smaller than 1e4.")
    niter <- round(niter)
    
    if (niter < 10 | niter > 1e3) 
        stop("'niter' must be an integer between 10 and 1e4.")
    
    ###################
    # Database directory 
    if (is.null(databaseDir)) {
        # create a meaningful name for the database containing 
        # creation date, organism and kegg release
        prefix <- as.Date(Sys.Date(), "%Y/%m/%d")
        suffix <- gsub(
            "[^0-9a-zA-Z.]+", "_", 
            strsplit(comment(keggdata.graph), split = "\n")[[1]][2]
        )
        
        databaseDir <- paste0(
            "created__", prefix, ";meta__", suffix
        )
    }
    # Further sanity of databaseDir is not checked at the moment
    
    if (internalDir) {
        # Save the database in an internal directory, given by
        # the package installation
        internal <- paste0(system.file(package = "FELLA"), "/database/")
        
        if (!dir.exists(paste0(internal))) {
            message("Creating internal databases directory: ", internal)
            dir.create(internal)
        }
        outputDir <- paste0(internal, databaseDir)
        
    } else {
        # User-defined directory
        outputDir <- databaseDir
    }
    
    if (dir.exists(outputDir)) {
        stop(
            "Directory ", databaseDir, 
            " already exists. Please use another directory.")
    }
    
    # See the probs of getting at least 
    # a connected component with a given size
    subgraph.size <- seq(250)
    component.size <- seq(250)
    
    message(
        "Computing probabilities for random subgraphs... ", 
        "(this may take a while)")
    
    # Run as many trials as specified
    array.null <- plyr::laply(
        seq(niter), 
        function(dummy) {
            # Sample the maximum amount of nodes 
            select <- sample(
                vcount(keggdata.graph), 
                tail(subgraph.size, 1))
            
            # For each k.sub <= subgraph.size, see the distribution of CCs
            plyr::laply(
                subgraph.size, 
                function(k.sub) {
                    # sample a subgraph every time
                    # it is important to use the head of the sampled values
                    # without any further sorting to avoid introducing biases
                    sel.g <- induced.subgraph(
                        graph = keggdata.graph, 
                        vids = head(select, k.sub))
                    # largest cc
                    csize.max <- max(clusters(sel.g)$csize)
                    
                    # sizes for which the random trial reported any 
                    # cc as large as them
                    component.size <= csize.max
                }
            )
        }, 
        .progress = "text"
    )
    keggdata.pvalues.size <- apply(
        array.null, 
        MARGIN = c(3, 2), # This ensures rows are component sizes
        function(run) {
            # empirical pvalue-like quantity
            (sum(run) + 1)/(length(run) + 1)
        }
    )
    colnames(keggdata.pvalues.size) <- subgraph.size
    rownames(keggdata.pvalues.size) <- component.size
    
    if (!dir.exists(outputDir)) {
        message(
            paste0(
                "Directory ", 
                outputDir, 
                " does not exist. Creating it..."))
        dir.create(path = outputDir, recursive = TRUE)
        message("Done.")
    }
    
    save(
        keggdata.graph, keggdata.pvalues.size, 
        file = paste0(outputDir, "/keggdata.graph.RData"))
    
    message("Done.")
    
    id.pathway <- which(V(graph)$com == 1)
    id.compound <- which(V(graph)$com == 5)
    
    
    ####################
    # Hypergeom matrix #
    ####################
    
    if ("hypergeom" %in% matrices) {
        message("Computing hypergeom.matrix...")
        
        graph <- keggdata.graph
        E(graph)$weight <- 1/E(graph)$weight
        
        hypergeom.matrix <- shortest.paths(
            graph = graph, 
            v = id.compound, 
            to = id.pathway, 
            mode = "out") == 4
        hypergeom.matrix <- Matrix(data = hypergeom.matrix, sparse = TRUE)
        
        save(
            hypergeom.matrix, 
            file = paste0(outputDir, "/hypergeom.matrix.RData"))
        
        message("Done.")
    }
    
    ###################
    # Diffusion files #
    ###################
    
    if ("diffusion" %in% c(matrices, normality)) {
        message(
            "Computing diffusion.matrix... ", 
            "(this may take a while and use some memory)")
        
        graph <- as.undirected(keggdata.graph)
        
        # Laplacian matrix
        K <- graph.laplacian(graph, normalized = FALSE, sparse = TRUE)
        
        # Boundary conditions
        Matrix::diag(K)[id.pathway] <- Matrix::diag(K)[id.pathway] + 1.0
        
        # The inverse (WARNING: it uses a large amount of memory)
        R <- as.matrix(solve(K))
        rownames(R) <- V(graph)$name
        colnames(R) <- V(graph)$name
        
        # Row sums
        diffusion.matrix <- R[, id.compound]
        
        if ("diffusion" %in% matrices) {
            save(
                diffusion.matrix, 
                file = paste0(outputDir, "/diffusion.matrix.RData"))
            
            message("Done")
        }
        
        if ("diffusion" %in% normality) {
            message("Computing diffusion.rowSums...")
            
            diffusion.rowSums <- rowSums(diffusion.matrix)
            diffusion.squaredRowSums <- rowSums(diffusion.matrix ^ 2)
            
            save(
                diffusion.rowSums, diffusion.squaredRowSums, 
                file = paste0(outputDir, "/diffusion.rowSums.RData"))
            
            message("Done.")
        }
    }
    
    
    
    ##################
    # Pagerank files #
    ##################
    
    if ("pagerank" %in% c(matrices, normality)) {
        message(
            "Computing pagerank.matrix... ", 
            "(this may take a while and use some memory)")
        
        graph <- keggdata.graph
        
        # Damping factor
        d <- dampingFactor
        
        # Laplacian matrix
        K <- -t(graph.laplacian(graph, normalized = FALSE, sparse = TRUE))
        Matrix::diag(K) <- 0.0
        
        K <- apply(K, 2, function(x) {
            if (sum(x) != 0) return(x/sum(x))
            else return(rep(1/dim(K)[1], dim(K)[1]))}
        )
        
        # The inverse (WARNING: it uses a large amount of memory)
        R <- (1 - d) * solve(diag(nrow(K)) - d * K)
        rownames(R) <- V(graph)$name
        colnames(R) <- V(graph)$name
        pagerank.matrix <- R[, id.compound]
        
        if ("pagerank" %in% matrices) {
            save(
                pagerank.matrix, 
                file = paste0(outputDir, "/pagerank.matrix.RData"))
            
            message("Done.")
        }
        
        if ("pagerank" %in% normality) {
            message("Computing pagerank.rowSums...")
            
            pagerank.rowSums <- rowSums(pagerank.matrix)
            pagerank.squaredRowSums <- rowSums(pagerank.matrix ^ 2)
            
            save(
                pagerank.rowSums, 
                pagerank.squaredRowSums, 
                file = paste0(outputDir, "/pagerank.rowSums.RData"))
            message("Done.")
        }
    }
    invisible(TRUE)
}

context("FELLA.DATA database creation from graph")

test.env <- environment()
data("FELLA.sample", package = "FELLA", envir = test.env)

graph.db <- try(FELLA:::getGraph(FELLA.sample))
dir.tmp <- tempdir()
dir.append <- paste(sample(letters, 40, replace = T), collapse = "")

# make sure KEGGREST tests are not run in a windows i386 R installation 
# (memory usage exceeds the 3GB limit)
# check if pointer size is 4 bytes (32 bit)
check_win32 <- function() {
    if (.Machine$sizeof.pointer == 4L & .Platform$OS.type == "windows") {
        msg <- paste0(
            "32-bit Windows installations may hit ", 
            "the allocation limit when using buildGraphFromKEGGREST"
        )
        skip(msg)
    }
}

# Takes some time
test_that("The graph can be parsed from KEGGREST", {
    check_win32()
    
    expect_error({
        g.full <- buildGraphFromKEGGREST(organism = "gla")
    }, NA)

    expect_is(g.full, "igraph")
})

# Use the small graph here
test_that("The database can be built (external)", {
    db_dir <- paste0(tempdir(), "/", dir.append)
  
    # First time: success (dir does not exist)
    expect_error({
        FELLA.test.external <- buildDataFromGraph(
            keggdata.graph = graph.db, 
            databaseDir = db_dir, 
            internalDir = FALSE, 
            matrices = c("hypergeom", "diffusion", "pagerank"), 
            normality = c("diffusion", "pagerank"), 
            dampingFactor = 0.7,
            niter = 10
        )
    }, NA)
    
    # Second time: fails (not to overwrite db)
    expect_error({
        FELLA.test.external.bis <- buildDataFromGraph(
            keggdata.graph = graph.db, 
            databaseDir = db_dir, 
            internalDir = FALSE, 
            matrices = c("hypergeom", "diffusion", "pagerank"), 
            normality = c("diffusion", "pagerank"), 
            dampingFactor = 0.7,
            niter = 10
        )
    }, "exists")
    
    expect_error({
        read.test.external <- 
            loadKEGGdata(
                databaseDir = db_dir, 
                internalDir = FALSE, 
                loadMatrix = c("diffusion", "pagerank")
            )
    }, NA)
  
    expect_true(FELLA.test.external)
    expect_true(is.FELLA.DATA(read.test.external))
})

test_that("The database can be built and listed (internal)", {
    expect_error({
        FELLA.test.internal <- buildDataFromGraph(
            keggdata.graph = graph.db, 
            databaseDir = dir.append, 
            internalDir = TRUE, 
            matrices = c("hypergeom", "diffusion", "pagerank"), 
            normality = c("diffusion", "pagerank"), 
            dampingFactor = 0.7,
            niter = 10
        )
    }, NA)
    
    expect_error({
        read.test.internal <- loadKEGGdata(
            databaseDir = dir.append, 
            internalDir = TRUE, 
            loadMatrix = c("diffusion", "pagerank")
        )
    }, NA)

    expect_error({
        db.name <- listInternalDatabases(full.names = FALSE)
        db.path <- listInternalDatabases(full.names = TRUE)
    }, NA)
    
    expect_true(FELLA.test.internal)
    expect_true(is.FELLA.DATA(read.test.internal))
    
    expect_true(dir.append %in% db.name)
    unlink(db.path[grepl(dir.append, db.path)], recursive = TRUE)
})

#' @include runHypergeom.R
#' 
#' @details
#' Function \code{runDiffusion} performs 
#' the diffusion-based enrichment on a 
#' \code{\link{FELLA.USER}} object with mapped metabolites 
#' and a \code{\link{FELLA.DATA}} object [Picart-Armada, 2017]. 
#' If a custom background was specified, it will be used. 
#' The idea behind the heat diffusion is the usage of the 
#' finite difference formulation of the heat equation to 
#' propagate labels from the metabolites to the rest of the graph.
#' 
#' Following the notation in [Picart-Armada, 2017], 
#' the temperatures (diffusion scores) 
#' are computed as:
#' 
#' \deqn{
#' T = -KI^{-1} \cdot G 
#' }{
#' T = -KI^(-1)*G 
#' }
#' 
#' \code{G} is an indicator vector of the input metabolites 
#' (\code{1} if input metabolite, \code{0} otherwise).
#' \code{KI} is the matrix \code{-KI = L + B}, being 
#' \code{L} the unnormalised graph Laplacian and 
#' \code{B} the diagonal matrix with \code{B[i,i] = 1} if 
#' node \code{i} is a pathway and \code{B[i,i] = 0} otherwise.
#' 
#' Equivalently, with the notation in the HotNet approach [Vandin, 2011], 
#' the stationary temperature is named \code{fs}:
#' 
#' \deqn{
#' f^s = L_{\gamma}^{-1} \cdot b^s 
#' }{
#' fs = Lgamma^(-1)*bs 
#' }
#'
#' \code{bs} is the indicator vector \code{G} from above. 
#' \code{Lgamma}, on the other hand, is found as 
#' \code{Lgamma = L + gamma*I}, where \code{L} is the unnormalised 
#' graph Laplacian, \code{gamma} is the first order leaking rate 
#' and \code{I} is the identity matrix. 
#' In our formulation, only the pathway nodes are allowed to leak, 
#' therefore \code{I} is switched to \code{B}. 
#' The parameter \code{gamma} is set to \code{gamma = 1}.
#'
#' The input metabolites are forced to stay warm, 
#' propagating flow to all the nodes in the network. 
#' However, only pathway nodes are allowed to evacuate 
#' this flow, so that its directionality is bottom-up. 
#' Further details on the setup of the diffusion process can be 
#' found in the supplementary file S2 from [Picart-Armada, 2017].
#' 
#' Finally, the warmest nodes in the graph are reported as 
#' the relevant sub-network. 
#' This will probably include some input metabolites and 
#' also reactions, enzymes, modules and pathways. 
#' Other metabolites can be suggested as well. 
#'
#' @inheritParams .params
#'
#' @return \code{runDiffusion} returns a 
#' \code{\link{FELLA.USER}} object 
#' updated with the diffusion enrichment results
#' 
#' @rdname enrich-funs 
#' 
#' @importFrom stats ecdf pnorm pgamma pt
#' @import Matrix
#' @import igraph
#' @export
runDiffusion <- function(
    object = NULL, 
    data = NULL, 
    approx = "normality", 
    t.df = 10, 
    niter = 1000) {
    
    # Checking the input
    ###########################
    checkArgs <- checkArguments(
        approx = approx, 
        t.df = t.df, 
        niter = niter,
        object = object, 
        data = data)
    if (!checkArgs$valid)
        stop("Bad argument when calling function 'runDiffusion'.")
    
    if (getStatus(data) != "loaded"){
        message(
            "'data' points to an empty FELLA.DATA object! ", 
            "Returning original 'object'...")
        return(object)
    }
    #####################
    
    message("Running diffusion...")
    
    # The metabolites in the input
    comp.input <- getInput(object)
    n.input <- length(comp.input)
    
    if (n.input == 0) {
        message(
            "Diffusion failed because ", 
            "there are no compounds in the input.")
        return(object)
    }
    
    ###### First case: simulation
    if (approx == "simulation") {
        message("Estimating p-values by simulation.")
        
        # The background
        if (length(getBackground(object)) == 0) {
            comp.background <- getCom(data, "compound")
        } else {
            comp.background <- getBackground(object)
        }
        
        if (prod(dim(getMatrix(data, "diffusion"))) == 1) {
            message(
                "Diffusion matrix not loaded. ", 
                "Simulations will be slower...")
            
            # Load the graph as undirected and its Laplacian
            graph <- as.undirected(getGraph(data))
            n.nodes <- vcount(graph)
            
            minusKI <- graph.laplacian(
                graph = graph, 
                normalized = FALSE, 
                sparse = TRUE)
            # Connect pathways to boundary
            Matrix::diag(minusKI)[getCom(data, "pathway", "id")] <- 
                Matrix::diag(minusKI)[getCom(data, "pathway", "id")] + 1.0
            
            # Heat generation vector
            generation <- numeric(dim(minusKI)[1])
            names(generation) <- V(graph)$name
            
            # Current temperatures
            generation[comp.input] <- 1
            current.temp <- as.vector(solve(minusKI, generation))
            generation[comp.input] <- 0
            
            # Null model
            null.temp <- vapply(seq_len(niter), function(dummy) {
                if (dummy %% round(.1*niter) == 0) 
                    message(round(dummy*100/niter),"%")
                
                generation[sample(comp.background, n.input)] <- 1
                as.vector(solve(minusKI, generation)) 
            }, FUN.VALUE = double(n.nodes))
            
            pscores <- vapply(seq_len(n.nodes), function(row) {
                ((1 - stats::ecdf(null.temp[row, ])(current.temp[row]))*
                    n.nodes + 1)/(n.nodes + 1)
            }, FUN.VALUE = double(1))
            names(pscores) <- V(graph)$name
        } else {
            # Calculate current temperature
            diffusion.matrix <- getMatrix(data, "diffusion")
            n.nodes <- nrow(diffusion.matrix)
            
            current.temp <- rowSums(
                diffusion.matrix[, comp.input, drop = FALSE])
            
            null.temp <- vapply(seq_len(niter), function(dummy) {
                if (dummy %% round(.1*niter) == 0) 
                    message(round(dummy*100/niter),"%")
                
                rowSums(
                    diffusion.matrix[, sample(comp.background, n.input)])
            }, FUN.VALUE = double(n.nodes))
            
            pscores <- vapply(seq_len(n.nodes), function(row) {
                ((1 - stats::ecdf(null.temp[row, ])(current.temp[row]))*
                    n.nodes + 1)/(n.nodes + 1)
            }, FUN.VALUE = double(1))
            names(pscores) <- rownames(diffusion.matrix)
        }
        
    ###### Second case: moments
    } else if (approx %in% c("normality", "gamma", "t")) {
        message("Computing p-scores through the specified distribution.")
        if (length(getBackground(object)) > 0) {
            if (prod(dim(getMatrix(data, "diffusion"))) == 1) {
                # Custom background, no matrix...
                message(
                    "Diffusion matrix not loaded. ", 
                    "Normality is not available for custom background ", 
                    "without it.")
                return(object)
            } else {# Custom background, matrix available
                background.matrix <- 
                    getMatrix(data, "diffusion")[, getBackground(object)]
                RowSums <- rowSums(background.matrix)
                squaredRowSums <- apply(
                    X = background.matrix, 
                    MARGIN = 1, 
                    FUN = function(row) sum(row*row))
                
                n.comp <- ncol(background.matrix)
            }
        } else {# Default background
            n.comp <- length(getCom(data, "compound"))
            
            # RowSums
            if (length(getSums(data, "diffusion", squared = FALSE)) == 0) {
                message(
                    "RowSums not available. ", 
                    "The normal approximation cannot be done.")
                return(object)
            } else {
                RowSums <- getSums(data, "diffusion", squared = FALSE)
            }
            
            # Squared RowSums
            if (length(getSums(data, "diffusion", squared = TRUE)) == 0) {
                message(
                    "squaredRowSums not available. ", 
                    "The normal approximation cannot be done.")
                return(object)
            } else {
                squaredRowSums <- getSums(data, "diffusion", squared = TRUE)
            }
        }
        
        # Compute current temperature
        # Load the graph as undirected and its Laplacian
        graph <- as.undirected(getGraph(data))
        minusKI <- graph.laplacian(
            graph = graph, 
            normalized = FALSE, 
            sparse = TRUE)
        # Connect pathways to boundary
        Matrix::diag(minusKI)[getCom(data, "pathway", "id")] <- 
            Matrix::diag(minusKI)[getCom(data, "pathway", "id")] + 1.0
        
        # Heat generation vector
        generation <- numeric(nrow(minusKI))
        names(generation) <- V(graph)$name
        
        # Current temperatures
        generation[comp.input] <- 1
        current.temp <- as.vector(solve(minusKI, generation))
        
        # Statistical moments
        temp.means <- RowSums*n.input/n.comp
        temp.vars <- n.input*(n.comp - n.input)/(n.comp*(n.comp - 1))*
            (squaredRowSums - (RowSums^2)/n.comp)
        
        # Statistical approximations
        if (approx == "normality") {
            pscores <- stats::pnorm(
                q = current.temp, 
                mean = temp.means, 
                sd = sqrt(temp.vars), 
                lower.tail = FALSE)
        }
        if (approx == "gamma") {
            pscores <- stats::pgamma(
                q = current.temp, 
                shape = temp.means^2/temp.vars, 
                scale = temp.vars/temp.means, 
                lower.tail = FALSE)
        }
        if (approx == "t") {
            pscores <- stats::pt(
                q = (current.temp - temp.means)/sqrt(temp.vars), 
                df = t.df, 
                lower.tail = FALSE)
        }
        
        names(pscores) <- names(RowSums)
    } 
    
    object@diffusion@pscores <- pscores
    object@diffusion@approx <- approx
    object@diffusion@niter <- niter
    
    message("Done.")
    object@diffusion@valid <- TRUE
    return(object)
}

#' @title Launch a shiny app with FELLA 
#' 
#' @description 
#' \code{\link[FELLA]{launchApp}} deploys a shiny application 
#' to perform the metabolomics data enrichment. 
#' Although this app does not provide all the options available in 
#' \code{\link[FELLA]{FELLA}}, it is easily accessible for the lay user. 
#' 
#' @details 
#' The graphical interface allows to: (1) upload the data and 
#' check if the KEGG ids have successfully mapped, 
#' (2) select database, set analysis and graphical parameters, 
#' (3) interactively browse the resulting sub-network as a graph or 
#' as a table, and (4) export such results as a table or a network. 
#' At least one database is needed before deploying the app. 
#' See \code{?buildDataFromGraph} for further details.  
#'
#' @param ... Parameters passed to \code{\link[shiny]{runApp}}
#'
#' @return \code{invisible()}, but as a side effect the app will be launched
#' 
#' @examples 
#' \dontrun{
#' r <- try(launchApp())
#' }
#' 
#' @export
launchApp <- function(...) {
    if (!requireNamespace("shiny", quietly = TRUE)) {
        stop(
            "The 'shiny' package must be installed ", 
            "to run the interactive app", 
            call. = FALSE)
    }
    
    dir.app <- system.file("shiny", package = "FELLA")
    
    if (dir.app == "") {
        warning(
            "Something went wrong and the shiny app is not in the ", 
            "application directory. Try reinstalling FELLA...")
        return(invisible())
    }
    
    shiny::runApp(appDir = dir.app, ...)
    
    invisible()
}

#' @name FELLA.sample
#' @title FELLA.DATA sample data
#' @description This \code{\link[FELLA]{FELLA.DATA}} object is 
#' a small KEGG graph object. 
#' Despite being a small database that only contains 
#' the two metabolic pathways 
#' hsa00010 - Glycolysis / Gluconeogenesis, and hsa00640 - 
#' Propanoate metabolism, 
#' it is useful to play around with \code{FELLA}'s 
#' functions. It is also used for internal testing of this package. 
#' @docType data
#' @usage data(FELLA.sample)
#' @examples data(FELLA.sample)
#' @return A \code{\link[FELLA]{FELLA.DATA}} object
#' @source Generated from a mid-2017 KEGG release 
#' (\url{http://www.genome.jp/kegg/})
"FELLA.sample"

#' @name input.sample
#' @title A randomly generated list of affected metabolites
#' @description This \code{character} vector object has been 
#' generated using the 
#' sample data in the object \code{FELLA.sample}. 
#' The KEGG compounds have been chosen 
#' with preference for the hsa00640 pathway, 
#' so that the enrichment results choose 
#' pathway hsa00640 over hsa00010. 
#' @docType data
#' @usage data(input.sample)
#' @examples data(input.sample)
#' @return A \code{character} vector containing 30 KEGG IDs
#' @source Generated from a mid-2017 KEGG release 
#' (\url{http://www.genome.jp/kegg/})
"input.sample"

#' Check FELLA.DATA class
#' 
#' Is \code{x} a \code{\link[FELLA]{FELLA.DATA}} object?
#'
#' @param x Object to check
#'
#' @return Logical value stating if \code{x} 
#' is a \code{\link[FELLA]{FELLA.DATA}} object
#' 
#' @export
#' @examples 
#' data(FELLA.sample)
#' is.FELLA.DATA(FELLA.sample)
#' is.FELLA.DATA(42)
is.FELLA.DATA <- function(x = NULL) {
    return(inherits(x, "FELLA.DATA"))
}

#' Check FELLA.USER class
#' 
#' Is \code{x} a \code{\link[FELLA]{FELLA.USER}} object?
#'
#' @param x Object to check
#'
#' @return Logical value stating if \code{x} 
#' is a \code{\link[FELLA]{FELLA.USER}} object
#' 
#' @examples 
#' is.FELLA.USER(new("FELLA.USER"))
#' is.FELLA.USER(42)
#' 
#' data(FELLA.sample)
#' data(input.sample)
#' obj <- enrich(
#' compounds = input.sample, 
#' method = "diffusion", 
#' data = FELLA.sample)
#' is.FELLA.USER(obj)
#' 
#' @export
is.FELLA.USER <- function(x = NULL) {
    return(inherits(x, "FELLA.USER"))
}

#' Add triangular shape to igraph plot
#' 
#' This function enables the usage of triangles as shape in 
#' the function \code{\link[igraph]{plot.igraph}}. 
#' 
#' @param coords,v,params clipping arguments, see 
#' \code{\link[igraph]{shapes}}
#' 
#' @return Plot symbols
#' 
#' @examples 
#' ## This function is internal
#' library(igraph)
#' 
#' add.vertex.shape(
#' "triangle", clip = shapes("circle")$clip,
#' plot = FELLA:::mytriangle)
#' 
#' g <- barabasi.game(10)
#' plot(
#' g, vertex.shape = "triangle", 
#' vertex.color = rainbow(vcount(g)),
#' vertex.size = seq(10, 20, length = vcount(g)))
#' 
#' @importFrom graphics symbols
#' 
#' @keywords internal
mytriangle <- function(coords, v=NULL, params) {
    vertex.color <- params("vertex", "color")
    if (length(vertex.color) != 1 && !is.null(v)) {
        vertex.color <- vertex.color[v]
    }
    vertex.size <- 1/200 * params("vertex", "size")
    if (length(vertex.size) != 1 && !is.null(v)) {
        vertex.size <- vertex.size[v]
    }
    
    graphics::symbols(
        x = coords[, 1], y = coords[, 2], bg = vertex.color,
        stars = cbind(vertex.size, vertex.size, vertex.size),
        add = TRUE, inches = FALSE)
}


#' @details
#' Function \code{plotGraph} 
#' plots a solution graph from the diffusion and pagerank analysis. 
#' For plotting hypergeom results, please use \code{plot} instead. 
#' Specific colors and shapes for each KEGG category are used: 
#' pathways are maroon, modules are violet, enzymes are orange, 
#' reactions are blue and compounds are green. 
#' If the graph contains the similarity to a GO term, enzymes will 
#' be displayed as triangles whose color depicts the strength of 
#' such measure (yellow: weak, purple: strong). 
#' At the moment, \code{plotGraph} allows plotting 
#' throug the static \code{\link[igraph]{plot.igraph}} and the 
#' interactive \code{\link[igraph]{tkplot}}. 
#'
#' @inheritParams .params
#' @param graph.layout Two-column numeric matrix, 
#' if this argument is not null 
#' then it is used as graph layout
#' @param plotLegend Logical, should the legend be plotted as well?
#' @param plot.fun Character, can be either 
#' \code{plot.igraph} or \code{tkplot}
#' 
#' @return \code{plotGraph} returns 
#' \code{invisible()} if \code{layout = F} and 
#' the plotting layout as a data.frame otherwise.
#' 
#' @rdname export-funs
#' 
#' @import igraph
#' @export
plotGraph <- function(
    graph = NULL, 
    layout = FALSE,
    graph.layout = NULL, 
    plotLegend = TRUE, 
    plot.fun = "plot.igraph", 
    NamesAsLabels = TRUE, 
    ...) {
    
    if (vcount(graph) == 0) {
        warning("The graph is empty and won't be plotted.")
        return(invisible())
    }
    
    # If there is GO cellular component data available, plot it..!
    if ("GO.simil" %in% list.vertex.attributes(graph)) {
        GO.simil <- V(graph)$GO.simil
        GO.annot <- TRUE
    } else {
        GO.annot <- FALSE
    }
    
    # triangle vertex shape
    add.vertex.shape(
        "triangle", clip = vertex.shapes("circle")$clip, plot = mytriangle)
    #########################################################
    
    # Nodes in the input are in V(graph)$input
    graph.input <- V(graph)$input
    graph.com <- as.character(V(graph)$com)
    
    # Vertex shape
    vertex.shape <- rep("circle", vcount(graph))
    vertex.shape[graph.input] <- "square"
    
    vertex.number <- vcount(graph)
    
    graph.asp <- 1
    if (is.null(graph.layout)) graph.layout <- layout.auto(graph)
    
    graph.layout <- layout.norm(
        graph.layout, 
        xmin = -1, 
        xmax = 1, 
        ymin = -1, 
        ymax = 1)
    
    ## Define vertex colour
    mapSolidColor <- c(
        "1" = "#CD0000",
        "2" = "#CD96CD",
        "3" = "#FFA200",
        "4" = "#8DB6CD",
        "5" = "#548B54"
    )
    vertex.color <- vapply(V(graph), function(y) {
        solidColor <- mapSolidColor[graph.com[y]]
        if (!GO.annot) return(solidColor)
        
        GO.y <- GO.simil[y]
        if (!is.na(GO.y)) {
            if (GO.y < 0.5) solidColor <- "#FFD500"
            else if (GO.y < 0.7) solidColor <- "#FF5500"
            else if (GO.y < 0.9) solidColor <- "#FF0000"
            else solidColor <- "#B300FF"
        }
        
        solidColor
    }, FUN.VALUE = character(1))
    
    # Vertex frame color
    vertex.frame.color <- rep("black", vcount(graph))
    if (GO.annot) {
        vertex.frame.color[!is.na(GO.simil)] <- "#CD0000"
        vertex.shape[!is.na(GO.simil)] <- "triangle"
    }
    
    # Vertex size
    mapSize <- c(
        "1" = 7,
        "2" = 5.5,
        "3" = 4.25,
        "4" = 3.5,
        "5" = 3
    )
    vertex.size <- mapSize[graph.com]
    vertex.size[graph.input] <- 4
    vertex.size <- vertex.size*(300/vcount(graph))^(1/3)
    
    # Labels
    vertex.label.dist <- 0.1*(300/vcount(graph))^(1/3)
    vertex.label.degree <- -pi/2
    
    if (NamesAsLabels) {
        vertex.label <- V(graph)$label
    } else {
        vertex.label <- V(graph)$name
    }
    
    options <- as.list(substitute(list(...)))[-1L]
    args.shared <- list(
        layout = graph.layout, 
        vertex.size = vertex.size, 
        vertex.label = vertex.label, 
        vertex.label.dist = vertex.label.dist, 
        vertex.label.color = vertex.color, 
        vertex.label.degree = vertex.label.degree, 
        vertex.frame.color = vertex.frame.color, 
        vertex.color = vertex.color, 
        vertex.shape = vertex.shape,
        edge.color = "#000000AA", 
        edge.arrow.size = 0.25,
        asp = graph.asp)
    
    if (plot.fun == "plot.igraph") {
        do.call(
            plot.fun, 
            c(list(x = graph), args.shared, options)
        )
    } 
    if (plot.fun == "tkplot") {
        do.call(
            plot.fun, 
            c(list(graph = graph), args.shared, options)
        )
    }
    
    # Plot the legend
    if (plotLegend) plotLegend(GO.annot = GO.annot, cex = 0.5)
    
    mapPrefix <- c(
        "1" = "",
        "2" = "md:",
        "3" = "ec:",
        "4" = "rn:",
        "5" = "cpd:"
    )
    if (!layout) {
        return(invisible(NULL))
    } else  {
        out.complete <- data.frame(
            x = graph.layout[, 1], 
            y = graph.layout[, 2], 
            out.id = paste0(mapPrefix[V(graph)$com], V(graph)$name), 
            out.name = V(graph)$label, 
            stringsAsFactors = FALSE)

        return(invisible(out.complete))
    }
}

# find bad indentation in manual files when running roxygenise
# hacked from BiocCheck:::checkFormatting
tellLines <- function (pkgdir)
{
  files <- c(file.path(pkgdir, "NAMESPACE"), dir(file.path(pkgdir,
                                                           "man"), pattern = "\\.Rd$", ignore.case = TRUE, full.names = TRUE),
             dir(file.path(pkgdir, "vignettes"), full.names = TRUE,
                 pattern = "\\.Rnw$|\\.Rmd$|\\.Rrst$|\\.Rhtml$|\\.Rtex$",
                 ignore.case = TRUE), dir(file.path(pkgdir, "R"),
                                          pattern = "\\.R$", ignore.case = TRUE, full.names = TRUE))
  longlines <- 0L
  totallines <- 0L
  tablines <- 0L
  badindentlines <- 0L
  ok <- TRUE
  for (file in files) {
    if (file.exists(file) && file.info(file)$size == 0) {
      pkgname <- getPkgNameFromPkgDir(pkgdir)
      handleNote(sprintf("Add content to the empty file %s.",
                         mungeName(file, pkgname)))
    }
    if (file.exists(file) && file.info(file)$size > 0) {
      lines <- readLines(file, warn = FALSE)
      totallines <- totallines + length(lines)
      n <- nchar(lines, allowNA = TRUE)
      n <- n[!is.na(n)]
      names(n) <- seq_along(1:length(n))
      long <- n[n > 80]
      if (length(long)) {
        message(
          "Lines in file ",
          file,
          " with >80 characters: ",
          paste(long, collapse = " ")
        )
        
        longlines <- longlines + length(long)
      }
      tabs <- grepl("\t", lines)
      if (any(tabs)) {
        tablines <- tablines + length(which(tabs))
      }
      res <- regexpr("^([ ]+)", lines)
      if (any(res > -1)) {
        match.length <- attr(res, "match.length")
        indents <- match.length[match.length > -1]
        
        lines <- which(indents%%4 != 0)
        if (length(lines))
          message(
            "Lines in file ",
            file,
            " with bad indentation: ",
            paste(lines, collapse = " ")
          )
        
        badindentlinesinthisfile <- length(which(indents%%4 !=
                                                   0))
        badindentlines <- badindentlines + badindentlinesinthisfile
      }
    }
  }
  if (longlines > 0) {
    ok <- FALSE
    handleNote(sprintf("Consider shorter lines; %s lines (%i%%) are > 80 characters long.",
                       longlines, as.integer((longlines/totallines) * 100)))
  }
  if (tablines > 0) {
    ok <- FALSE
    handleNote(sprintf("Consider 4 spaces instead of tabs; %s lines (%i%%) contain tabs.",
                       tablines, as.integer((tablines/totallines) * (100/1))))
  }
  if (badindentlines > 0) {
    ok <- FALSE
    handleNote(sprintf(paste("Consider indenting lines with a multiple of 4 spaces;",
                             "%s lines (%i%%) are not."), badindentlines, as.integer((badindentlines/totallines) *
                                                                                       100)))
  }
  if (!ok) {
    message("  See http://bioconductor.org/developers/how-to/coding-style/")
  }
}

# replace bad indentation in RD files
# if indent is two spaces, place four
reindentRd <- function(rdpath = "man") {
  rd_files <- list.files(rdpath, full.names = TRUE)
  
  plyr::l_ply(
    rd_files,
    function(filename) {
      f <- readLines(filename)
      
      # indents starting with 2 spaces
      f_fix <- grepl(pattern = "^([ ]{2}[^ ])", f)
      f_prefix <- ifelse(f_fix, "  ", "")
      
      writeLines(paste0(f_prefix, f), con = filename)
    }
  )
}

#' @import methods
#' @import igraph
methods::setClass("igraph")

#' An internal S4 class to represent the KEGG graph and related files
#'
#' @slot graph KEGG graph
#' @slot id2name Mapping list: KEGG ID to KEGG name 
#' (can contain multiple hits)
#' @slot pvalues.size Numeric matrix for the 
#' evaluation of CC through their size
#' @slot id List with character vectors for KEGG categories
#' @slot status Character that specifies the 
#' current status of this S4 class
#' 
#' @rdname D.keggdata
setClass(
    "D.keggdata",
    representation(
        graph = "igraph", 
        id2name = "list", 
        pvalues.size = "matrix", 
        id = "list", 
        status = "character"
    ),
    prototype(
        graph = igraph::graph.empty(), 
        id2name = list(), 
        pvalues.size = matrix(), 
        id = list(), 
        status = "empty"
    )
)

#' An internal S4 class for the binary matrix (hypergeometric test)
#'
#' @slot matrix Binary sparse matrix
#' 
#' @rdname D.hypergeom
setClass(
    "D.hypergeom",
    representation(
        matrix = "Matrix"
    ),
    prototype(
        matrix = Matrix::Matrix()
    )
)

#' An internal S4 class for the diffusion data
#'
#' @slot matrix Numeric (dense) matrix [optional]
#' @slot rowSums Numeric named vector with rowSums internal data
#' @slot squaredRowSums Numeric named vector with 
#' squaredRowSums internal data
#' 
#' @rdname D.diffusion
setClass(
    "D.diffusion",
    representation(
        matrix = "matrix", 
        rowSums = "vector", 
        squaredRowSums = "vector"
    ),
    prototype(
        matrix = matrix(), 
        rowSums = vector(), 
        squaredRowSums = vector()
    )
)

#' An internal S4 class for the PageRank data
#'
#' @slot matrix Numeric (dense) matrix [optional]
#' @slot rowSums Numeric named vector with rowSums internal data
#' @slot squaredRowSums Numeric named vector with 
#' squaredRowSums internal data
#' 
#' @rdname D.pagerank
setClass(
    "D.pagerank",
    representation(
        matrix = "matrix", 
        rowSums = "vector", 
        squaredRowSums = "vector"
    ),
    prototype(
        matrix = matrix(), 
        rowSums = vector(), 
        squaredRowSums = vector()
    )
)

#' An S4 class to represent all the necessary KEGG data
#'
#' @slot keggdata A \code{D.keggdata} S4 object
#' @slot hypergeom A \code{D.hypergeom} S4 object
#' @slot diffusion A \code{D.diffusion} S4 object
#' @slot pagerank A \code{D.pagerank} S4 object
#' 
#' @aliases FELLA.DATA
#' @rdname FELLA.DATA
#' @exportClass FELLA.DATA
setClass(
    "FELLA.DATA",
    representation(
        keggdata = "D.keggdata",
        hypergeom = "D.hypergeom",
        diffusion = "D.diffusion",
        pagerank = "D.pagerank"
    ),
    prototype(
        keggdata = new("D.keggdata"),
        hypergeom = new("D.hypergeom"),
        diffusion = new("D.diffusion"),
        pagerank = new("D.pagerank")
    )
)

#' An internal S4 class for the user input data
#'
#' @slot metabolites Character vector containing 
#' the affected compounds
#' @slot metabolitesbackground Character vector containing 
#' the compounds for the personalised background. 
#' Optionally, can be \code{NULL} for default background
#' @slot excluded Character vector containing 
#' the compounds that have been 
#' excluded because they cannot be mapped to KEGG graph compounds
#' 
#' @rdname U.userinput
setClass(
    "U.userinput",
    representation(
        metabolites = "vector",
        metabolitesbackground = "vector", 
        excluded = "vector"
    ),
    prototype(
        metabolites = vector(),
        metabolitesbackground = vector(), 
        excluded = vector()
    )
)

#' An internal S4 class for the user data 
#' of the hypergeometric over representation 
#' analysis
#'
#' @slot valid Logical value; is the analysis valid?
#' @slot pvalues Named numeric vector with p-values
#' @slot pathhits Numeric named vector with 
#' the quantities "sample_success" 
#' for the hypergeometric distribution (#affected in path)
#' @slot pathbackground Numeric named vector with 
#' the quantities "total_success" 
#' for the hypergeometric distribution (total in path)
#' @slot nbackground Numeric value, number of compoudns in the background. 
#' Equivalently, number of rows for the hypergeometric binary matrix
#' @slot ninput Numeric value, number of affected compounds matched to the 
#' rownames
#' 
#' @rdname U.hypergeom
setClass(
    "U.hypergeom",
    representation(
        valid = "logical",
        pvalues = "vector",
        pathhits = "vector", 
        pathbackground = "vector", 
        nbackground = "numeric", 
        ninput = "numeric"
    ),
    prototype(
        valid = NA, 
        pvalues = vector(), 
        pathhits = vector(), 
        pathbackground = vector(), 
        nbackground = numeric(), 
        ninput = numeric()
    )
)

#' An internal S4 class for the user data 
#' of the diffusion enrichment analysis
#'
#' @slot valid Logical value; is the analysis valid?
#' @slot pscores Named numeric vector with p-scores
#' @slot approx Character; which approximation was used? 
#' Can be "simulation" for Monte Carlo; 
#' "normality", "gamma" or "t" for parametric approaches
#' @slot niter Numeric value, number of iterations 
#' for the simulated approach
#' 
#' @rdname U.diffusion
setClass(
    "U.diffusion",
    representation(
        valid = "logical",
        pscores = "vector",
        approx = "character", 
        niter = "numeric"
    ),
    prototype(
        valid = NA, 
        pscores = vector(),
        approx = character(), 
        niter = numeric()
    )
)

#' An internal S4 class for the user data 
#' of the PageRank enrichment analysis
#'
#' @slot valid Logical value; is the analysis valid?
#' @slot pscores Named numeric vector with p-scores
#' @slot approx Character; which approximation was used? 
#' Can be "simulation" for Monte Carlo; 
#' "normality", "gamma" or "t" for parametric approaches
#' @slot niter Numeric value, number of iterations 
#' for the simulated approach
#' 
#' @rdname U.pagerank
setClass(
    "U.pagerank",
    representation(
        valid = "logical", 
        pscores = "vector",
        approx = "character", 
        niter = "numeric"
    ),
    prototype(
        valid = NA, 
        pscores = vector(),
        approx = character(), 
        niter = numeric()
    )
)

#' An S4 class to save all the user analysis data
#'
#' @slot userinput A \code{U.userinput} S4 object
#' @slot hypergeom A \code{U.hypergeom} S4 object
#' @slot diffusion A \code{U.diffusion} S4 object
#' @slot pagerank A \code{U.pagerank} S4 object
#' 
#' @aliases FELLA.USER
#' @rdname FELLA.USER
#' @exportClass FELLA.USER
setClass(
    "FELLA.USER",
    representation(
        userinput = "U.userinput",
        hypergeom = "U.hypergeom",
        diffusion = "U.diffusion",
        pagerank = "U.pagerank"
    ),
    prototype(
        userinput = new("U.userinput"),
        hypergeom = new("U.hypergeom"),
        diffusion = new("U.diffusion"),
        pagerank = new("U.pagerank")
    )
)

#' @title The FELLA package
#' 
#' @description 
#' \code{FELLA} is a metabolomics data enrichment tool that contextualises 
#' a list of metabolites using KEGG reactions, 
#' enzymes, modules and pathways [Picart-Armada, 2017]. 
#' 
#' @details
#' \code{FELLA} can build knowledge models for the desired organism 
#' from the KEGG database [Kanehisa, 2017]. 
#' Once a model is ready, the input for the enrichment is introduced 
#' as a list of affected metabolites (as KEGG IDs). 
#' The output contains a comprehensive biological network layout 
#' that relates relevant pathways to the affected metabolites. 
#' Results are available in network and tabular format. 
#' 
#' \code{FELLA} is equipped with a simple graphical interface 
#' for the lay user, deployed through \link{launchApp}.
#' 
#' \code{FELLA} relies mainly on the following packages: 
#' KEGGREST for the queries 
#' to the KEGG server [Tenenbaum, 2013], 
#' \pkg{igraph} for the 
#' network support [Csardi, 2006] and 
#' \pkg{shiny} for the 
#' graphical user interface [Chang, 2017].
#' 
#' @examples 
#' ## Walkthrough
#' browseVignettes("FELLA")
#' ## I: create database
#' ?buildGraphFromKEGGREST
#' ## II: enrich data
#' ?enrich
#' ## III: export results
#' ?exportResults
#' 
#' @references 
#' Methodology:
#' 
#' Picart-Armada, S., Fernandez-Albert, F., Vinaixa, 
#' M., Rodriguez, M. A., Aivio, S., Stracker, 
#' T. H., Yanes, O., & Perera-Lluna, A. (2017). 
#' Null diffusion-based enrichment for metabolomics data. 
#' PLOS ONE, 12(12), e0189012.
#' 
#' 
#' Database: 
#' 
#' Kanehisa, M., Furumichi, M., Tanabe,
#' M., Sato, Y., & Morishima, K. (2017).
#' KEGG: new perspectives on genomes, pathways, diseases and drugs.
#' Nucleic acids research, 45(D1), D353-D361.
#' 
#' 
#' Main dependencies:
#' 
#' Tenenbaum, D. (2013). KEGGREST: Client-side REST access 
#' to KEGG. R package version, 1(1).
#' 
#' Csardi, G., & Nepusz, T. (2006). The igraph software package 
#' for complex network research. 
#' InterJournal, Complex Systems, 1695(5), 1-9.
#' 
#' Chang, W., Cheng, J., Allaire, JJ., 
#' Xie, Y., & McPherson, J. (2017).
#' shiny: Web Application Framework for R. R package version 1.0.5.
#' https://CRAN.R-project.org/package=shiny
#' 
#' 
#' @docType package
#' @name FELLA
NULL

#' Internal function to plot a bipartite graph
#' 
#' This function plots a bipartite graph, tailored for the hypergeometric 
#' over representation analysis. As the nodes can only be compounds and 
#' pathways, the layout is simple and bipartite.
#'
#' @inheritParams .params
#' @param graph Graph result that must come from the 
#' hypergeometric test analysis
#' @param ... Additional parameters passed to 
#' \code{\link[igraph]{plot.igraph}}
#' 
#' @return If \code{layout = F} then the value 
#' returned is \code{invisible()}. 
#' Otherwise, the layout is returned, also in an invisible fashion.
#' 
#' @examples 
#' ## This function is internal
#' data(FELLA.sample)
#' data(input.sample)
#' ## Enrich input
#' obj <- enrich(
#' compounds = input.sample, 
#' data = FELLA.sample, 
#' method = "hypergeom")
#' ## Generate the bipartite graph (only in the hypergeometric test)
#' g <- generateResultsGraph(
#' method = "hypergeom", 
#' threshold = 1, 
#' object = obj, 
#' data = FELLA.sample)
#' ## Plot it
#' FELLA:::plotBipartite(g)
#' 
#' @import igraph
#' 
#' @keywords internal
plotBipartite <- function(
    graph = NULL, 
    layout = FALSE, 
    ...) {
    
    graph.com <- as.character(V(graph)$com)
    
    # Generate a pretty layout
    graph.asp <- 4/3
    graph.layout <- layout.bipartite(
        graph, 
        types = (V(graph)$com == 5), 
        hgap = .5, 
        vgap = 2.5)
    graph.layout <- layout.norm(
        graph.layout[, c(2, 1)], 
        xmin = -1, 
        xmax = 1, 
        ymin = -1, 
        ymax = 1)
    
    # Vertex shape & color
    mp.shape <- c("1" = "circle", "5" = "square")
    mp.color <- c("1" = "red3", "5" = "palegreen4")
    mp.deg <- c("1" = 0, "5" = -pi)
    
    vertex.shape <- mp.shape[graph.com]
    vertex.color <- mp.color[graph.com]
    
    # Labels and sizes
    vertex.size <- 3
    vertex.label.dist <- 0.7
    vertex.label.degree <- mp.deg[graph.com]

    # Actual plot
    plot.igraph(
        x = graph, 
        layout = graph.layout, 
        vertex.size = vertex.size, 
        vertex.label = V(graph)$name, 
        vertex.label.dist = vertex.label.dist, 
        vertex.label.color = vertex.color, 
        vertex.label.degree = vertex.label.degree, 
        vertex.color = vertex.color, 
        vertex.shape = vertex.shape,
        edge.color = "#000000AA", 
        edge.arrow.size = 0.25,
        asp = graph.asp, 
        ...)
    
    if (!layout) {
        return(invisible(NULL))
    } else  {
        x <- graph.layout[, 1]
        y <- graph.layout[, 2]
        
        mp.prefix <- c("1" = "", "5" = "cpd:")
        out.id <- paste0(
            mp.prefix[as.character(V(graph)[vertex]$com)], 
            V(graph)[vertex]$name
        )
        
        out.complete <- data.frame(x, y, out.id, stringsAsFactors = FALSE)
        
        return(invisible(out.complete))
    }
}

# global.R
library(shiny)

# Core pacakges
library(FELLA)
library(igraph)

# Report generation
library(knitr)
library(xtable)

# Cytoscape tool
library(visNetwork)
library(DT)

# Find internal directory
pathDBs <- paste0(
  system.file(package = "FELLA"), 
  "/database/"
)
# Find all local databases
pathData <- setNames(
  list.dirs(pathDBs, full.names = TRUE, recursive = FALSE), 
  list.dirs(pathDBs, full.names = FALSE, recursive = FALSE)
)

# The database could be loaded here to save memory
# Instead, we want to let the user choose the database
# Then it has to be loaded in server.R, once for each user. 

#' Dummy function with function arguments
#' 
#' This function eases parameter inheritance to centralise the 
#' documentation
#' 
#' @param databaseDir Path for the KEGG RData files
#' @param internalDir Logical, is the directory located 
#' in the package directory?
#' @param object FELLA.USER object
#' @param data FELLA.DATA object
#' @param type Character vector, containing entries in
#' "hypergeom", "diffusion" or "pagerank"
#' @param level Desired level, can be coded as a number or a character: 
#' 1 or "pathway"; 2 or "module"; 3 or "enzyme"; 
#' 4 or "reaction"; 5 or "compound".
#' @param method Character, exactly one of: 
#' \code{"hypergeom"}, \code{"diffusion"}, \code{"pagerank"}
#' @param methods Character vector, containing some of: 
#' \code{"hypergeom"}, \code{"diffusion"}, \code{"pagerank"}
#' @param approx Character: "simulation" for Monte Carlo, "normality", 
#' "gamma" or "t" for parametric approaches
#' @param loadMatrix Character vector to choose if 
#' heavy matrices should be loaded. 
#' Can contain: \code{"diffusion"}, \code{"pagerank"}
#' @param threshold Numeric value between 0 and 1. 
#' \code{p.score} threshold applied when filtering KEGG nodes. 
#' Lower thresholds are more stringent. 
#' @param thresholdConnectedComponent Numeric value between 0 and 1. 
#' Connected components that are below the threshold are kept, 
#' while the ones exceeding it (because they are too small) are discarded. 
#' @param plimit Pathway limit, must be a numeric value between 1 and 50. 
#' Limits the amount of pathways in \code{method = "hypergeom"}
#' @param nlimit Node limit, must be a numeric value between 1 and 1000. 
#' Limits the order of the solution sub-graph when 
#' in \code{method = "diffusion"} and \code{method = "pagerank"}
#' @param niter Number of iterations (permutations) 
#' for Monte Carlo ("simulation"), 
#' must be a numeric value between 1e2 and 1e5
#' @param layout Logical, should the plot be returned as a layout?
#' @param graph An \pkg{igraph} object, 
#' typically a small one, 
#' coming from an enrichment through \code{"diffusion"} or \code{"pagerank"}.
#' @param GOterm Character, GO entry to draw 
#' semantic similarity in the solution graph. 
#' If \code{NULL}, the GO labels will be appended without similarities.
#' @param GONamesAsLabels Logical, should GO names 
#' be displayed as labels instead of GO identifiers?
#' @param LabelLengthAtPlot Numeric value between 10 and 50. 
#' Maximum length that a label can reach when plotting the graph. 
#' The remaining characters will be truncated using "..."
#' @param godata.options List, options for the database creator 
#' \code{\link[GOSemSim]{godata}}
#' @param mart.options List, options for the \code{biomaRt} function
#' \code{\link[biomaRt]{getBM}}. Importantly, this defines the organism, 
#' see \code{\link[biomaRt]{listDatasets}} for possibilities. 
#' If calling \code{generateEnzymesTable}, the user can set 
#' \code{mart.options = NULL} to avoid adding GO labels to enzymes.
# Other
#' @param p.adjust Character passed to the 
#' \code{\link[stats]{p.adjust}} method
#' @param dampingFactor Numeric value between 0 and 1 (none inclusive), 
#' damping factor \code{d} for 
#' PageRank (\code{\link[igraph:page_rank]{page.rank}})
#' @param t.df Numeric value; number of degrees of freedom 
#' of the t distribution 
#' if the approximation \code{approx = "t"} is used
#' @param compounds Character vector containing the 
#' KEGG IDs of the compounds considered as affected
#' @param compoundsBackground Character vector containing the KEGG IDs of 
#' the compounds that belong to the background. Can be \code{NULL} for the 
#' default background (all compounds)
#' @param NamesAsLabels Logical, should KEGG names be displayed 
#' as labels instead of KEGG identifiers?
#' @param capPscores Numeric value, minimum p-score 
#' admitted for the readable 
#' formatting. Smaller p-scores will be displayed 
#' as \code{< capPscores} 
#' 
#' @return \code{NULL}
#' 
#' @keywords internal
.params <- function() {}

#' Internal function to check arguments and give personalised errors
#' 
#' This function checks if the arguments are of the desired type, length 
#' and range. If it fails, it gives an error explaining why the argument 
#' is invalid. 
#'
#' @inheritParams .params
#' @param ... ignored arguments
#' 
#' @return A list with values. Currently only a 
#' logical value named \code{valid} 
#' if the process runs smoothly. If the checking fails, 
#' it also returns an 
#' object called \code{ans}, which depends on 
#' the situation (can be the original object, 
#' \code{NULL}, et cetera). 
#' 
#' @examples 
#' ## This function is internal
#' arg1 <- FELLA:::checkArguments(method = "hello")
#' arg1$valid
#' arg2 <- FELLA:::checkArguments(method = "diffusion")
#' arg2$valid
#' 
#' @keywords internal
checkArguments <- function(
    databaseDir = "myDatabase", 
    internalDir = TRUE, 
    method = "diffusion", 
    methods = "diffusion", 
    approx = "normality", 
    loadMatrix = NULL, 
    threshold = 0.05,
    plimit = 15, 
    nlimit = 250, 
    niter = 1e3, 
    t.df = 10, 
    dampingFactor = 0.85, 
    layout = FALSE, 
    thresholdConnectedComponent = 0.05, 
    GOterm = NULL,
    GONamesAsLabels = TRUE, 
    LabelLengthAtPlot = 22, 
    object = new("FELLA.USER"), 
    data = new("FELLA.DATA"), 
    ...) {
    
    # DIRECTORIES
    ###########################
    
    if ((!is.character(databaseDir) & !is.null(databaseDir))  | 
        length(databaseDir) > 1) {
        message(
            "'databaseDir' must be a length 1 character ", 
            " or NULL.")
        return(list(ans = NULL, valid = FALSE))
    }
    
    if (!is.logical(internalDir) | is.na(internalDir)) {
        message("'internalDir' must be a non-NA logical value")
        return(list(ans = NULL, valid = FALSE))
    }
    
    # METHOD
    ###########################
    
    # version with length restriction
    if (!is.character(method)) {
        message(
            "'method' must be of character type and must be one of: ", 
            "'hypergeom', 'diffusion' and 'pagerank'. ", 
            "Returning original 'object'...")
        return(list(ans = object, valid = FALSE))
    }
    if (length(method) > 1) {
        message(
            "'method' must be a length 1 character. ", 
            "Returning original 'object'...")
        return(list(ans = object, valid = FALSE))
    }
    if (!(method %in% listMethods())) {
        message(
            "'method' must contain exactly one of: ", 
            "'hypergeom', 'diffusion' or 'pagerank'. ", 
            "Returning original 'object'...")
        return(list(ans = object, valid = FALSE))
    }
    ## method (several allowed)
    if (!is.character(methods)) {
        message(
            "'methods' must be a character containing some of: ", 
            "'hypergeom', 'diffusion' or 'pagerank'. ", 
            "Returning original 'object'...")
        return(list(ans = object, valid = FALSE))
    }
    if (!any(methods %in% listMethods())) {
        message(
            "'methods' must be a character vector ", "
            containing at least one of: ", 
            "'hypergeom', 'diffusion' or 'pagerank'. ", 
            "Returning original 'object'...")
        return(list(ans = object, valid = FALSE))
    }
    
    # approx
    ###########################
    
    if (!is.character(approx)) {
        message(
            "'approx' must be a character: ", 
            "'simulation',  'normality', 'gamma' or 't'. ", 
            "Returning NULL...")
        return(list(ans = NULL, valid = FALSE))
    }
    
    if (length(approx) > 1) {
        message(
            "'approx' must be a length 1 character. ", 
            "Returning NULL...")
        return(list(ans = NULL, valid = FALSE))
    }
    
    if (!(approx %in% listApprox())) {
        message(
            "'approx' must be a character: ", 
            "'simulation',  'normality', 'gamma' or 't'. ", 
            "Returning NULL...")
        return(list(ans = NULL, valid = FALSE))
    }
    
    # loadMatrix
    #################
    if (!is.null(loadMatrix) & !is.character(loadMatrix)) {
        message(
            "'loadMatrix' can only be a character vector containing some in: ", 
            "'diffusion', 'pagerank', or NULL.")
        return(list(ans = NULL, valid = FALSE))
    }
    
    
    # threshold
    #################
    if (!is.numeric(threshold)) {
        message(
            "'threshold' must be numeric between 0 and 1. ", 
            "Returning NULL...")
        return(list(ans = NULL, valid = FALSE))
    }
    
    if (length(threshold) > 1) {
        message(
            "'threshold' must be a length 1 numeric. ", 
            "Returning NULL...")
        return(list(ans = NULL, valid = FALSE))
    }
    
    if (threshold <= 0 | threshold > 1) {
        message(
            "'threshold' must be numeric between 0 and 1. ", 
            "Returning NULL...")
        return(list(ans = NULL, valid = FALSE))
    }
    
    # plimit
    ##########################
    if (!is.numeric(plimit)) {
        message(
            "'plimit' must be numeric between 1 and 50. ", 
            "Returning NULL...")
        return(list(ans = NULL, valid = FALSE))
    }
    
    if (length(plimit) > 1) {
        message(
            "'plimit' must be a length 1 numeric. ", 
            "Returning NULL...")
        return(list(ans = NULL, valid = FALSE))
    }
    
    if (plimit <= 0 | plimit >= 50) {
        message(
            "'plimit' must be numeric between 1 and 50. ", 
            "Returning NULL...")
        return(list(ans = NULL, valid = FALSE))
    }
    
    # nlimit
    ##########################
    if (!is.numeric(nlimit)) {
        message(
            "'nlimit' must be numeric between 1 and 1000. ", 
            "Returning NULL...")
        return(list(ans = NULL, valid = FALSE))
    }
    
    if (length(nlimit) > 1) {
        message(
            "'nlimit' must be a length 1 numeric. ", 
            "Returning NULL...")
        return(list(ans = NULL, valid = FALSE))
    }
    
    if (nlimit <= 0 | nlimit > 1000) {
        message(
            "'nlimit' must be numeric between 1 and 1000. ", 
            "Returning NULL...")
        return(list(ans = NULL, valid = FALSE))
    }
    
    # niter
    ##########################
    if (!is.numeric(niter)) {
        message(
            "'niter' must be numeric between 1e2 and 1e5. ", 
            "Returning NULL...")
        return(list(ans = NULL, valid = FALSE))
    }
    
    if (length(niter) > 1) {
        message(
            "'niter' must be a length 1 numeric. ", 
            "Returning NULL...")
        return(list(ans = NULL, valid = FALSE))
    }
    
    if (niter < 1e2 | niter > 1e5) {
        message(
            "'niter' must be numeric between 1e2 and 1e5. ", 
            "Returning NULL...")
        return(list(ans = NULL, valid = FALSE))
    }
    
    # t.df
    ##########################
    if (!is.numeric(t.df)) {
        message(
            "'t.df' must be a positive numeric value. ", 
            "Returning NULL...")
        return(list(ans = NULL, valid = FALSE))
    }
    
    if (length(t.df) > 1) {
        message(
            "'t.df' must be a length 1 numeric. ", 
            "Returning NULL...")
        return(list(ans = NULL, valid = FALSE))
    }
    
    if (t.df <= 0) {
        message(
            "'t.df' must be a positive numeric value. ", 
            "Returning NULL...")
        return(list(ans = NULL, valid = FALSE))
    }
    
    # dampingFactor
    #################
    if (!is.numeric(dampingFactor)) {
        message(
            "'dampingFactor' must be numeric between 0 and 1, none included. ", 
            "Returning NULL...")
        return(list(ans = NULL, valid = FALSE))
    }
    
    if (length(dampingFactor) > 1) {
        message(
            "'dampingFactor' must be a length 1 numeric. ", 
            "Returning NULL...")
        return(list(ans = NULL, valid = FALSE))
    }
    
    if (dampingFactor <= 0 | dampingFactor >= 1) {
        message(
            "'dampingFactor' must be numeric between 0 and 1, none included. ", 
            "Returning NULL...")
        return(list(ans = NULL, valid = FALSE))
    }
    
    # layout
    ###########################
    if (!is.logical(layout)) {
        message(
            "'layout' must be logical. ", 
            "Returning NULL...")
        return(list(ans = NULL, valid = FALSE))
    }
    
    if (length(layout) > 1) {
        message(
            "'layout' must be a length 1 logical. ", 
            "Returning NULL...")
        return(list(ans = NULL, valid = FALSE))
    }
    
    # thresholdConnectedComponent
    ###################################
    if (!is.numeric(thresholdConnectedComponent)) {
        message(
            "'thresholdConnectedComponent' must be ", 
            "numeric between 0 and 1. ", 
            "Returning NULL...")
        return(list(ans = NULL, valid = FALSE))
    }
    
    if (length(thresholdConnectedComponent) > 1) {
        message(
            "'thresholdConnectedComponent' must be a length 1 numeric. ", 
            "Returning NULL...")
        return(list(ans = NULL, valid = FALSE))
    }
    
    if (thresholdConnectedComponent < 0 | 
        thresholdConnectedComponent > 1) {
        message(
            "'thresholdConnectedComponent' must be numeric between 0 and 1.", 
            " Returning NULL...")
        return(list(ans = NULL, valid = FALSE))
    }
    
    # GOterm
    ##################################
    if (!is.null(GOterm) & 
        !is.character(GOterm)) {
        message(
            "'GOterm' must be NULL or a GO entry. ", 
            "Returning NULL...")
        return(list(ans = NULL, valid = FALSE))
    }
    
    if (length(GOterm) > 1) {
        message(
            "'GOterm' must be a length 1 character. ", 
            "Returning NULL...")
        return(list(ans = NULL, valid = FALSE))
    }
    
    # GONamesAsLabels
    ################################
    if (!is.logical(GONamesAsLabels)) {
        message(
            "'GONamesAsLabels' must be logical. ", 
            "Returning NULL...")
        return(list(ans = NULL, valid = FALSE))
    }
    
    if (length(GONamesAsLabels) > 1) {
        message(
            "'GONamesAsLabels' must be a length 1 logical. ", 
            "Returning NULL...")
        return(list(ans = NULL, valid = FALSE))
    }
    
    # LabelLengthAtPlot
    ##################################
    if (!is.numeric(LabelLengthAtPlot)) {
        message(
            "'LabelLengthAtPlot' must be numeric between 10 and 50. ", 
            "Returning NULL...")
        return(list(ans = NULL, valid = FALSE))
    }
    
    if (length(LabelLengthAtPlot) > 1) {
        message(
            "'LabelLengthAtPlot' must be a length 1 numeric. ", 
            "Returning NULL...")
        return(list(ans = NULL, valid = FALSE))
    }
    
    if (LabelLengthAtPlot < 10 | LabelLengthAtPlot > 100) {
        message(
            "'LabelLengthAtPlot' must be numeric between 10 and 100. ", 
            "Returning NULL...")
        return(list(ans = NULL, valid = FALSE))
    }
    
    # object
    ##################################
    if (!is.FELLA.USER(object)) {
        message(
            "'object' is not a FELLA.USER object. ", 
            "Returning NULL...")
        return(list(ans = NULL, valid = FALSE))
    } 
    
    # data
    ##################################
    if (!is.FELLA.DATA(data)) {
        message(
            "'data' is not a FELLA.DATA object. ", 
            "Returning NULL...")
        return(list(ans = NULL, valid = FALSE))
    }
    
    return(list(valid = TRUE))
}

#' Get compounds in the defined background
#' 
#' Extractor function for the compounds defined as background
#'
#' @inheritParams .params
#'
#' @return Vector of compounds in the background. 
#' If this vector is empty, all 
#' the compounds are used as background by default.
#' 
#' @examples
#' data(FELLA.sample)
#' data(input.sample)
#' input <- head(input.sample, 12)
#' 
#' ## If the background is default, we see an empty vector 
#' ## Note that the number of iterations is really small in the example
#' obj <- enrich(
#' compounds = input, 
#' method = "diffusion", 
#' approx = "simulation", 
#' niter = 100, 
#' data = FELLA.sample)
#' 
#' getBackground(obj)
#' 
#' ## Otherwise we see the background compounds that mapped to the graph
#' obj <- enrich(
#' compounds = input, 
#' compoundsBackground = input.sample, 
#' method = "diffusion", 
#' approx = "simulation", 
#' niter = 100, 
#' data = FELLA.sample)
#' getBackground(obj)
#' 
#' @export
getBackground <- function(object) {
    return(object@userinput@metabolitesbackground)
}

#' Get community
#' 
#' Extractor function for all the nodes from a level/community of KEGG graph
#'
#' @inheritParams .params
#' @param format Format of the output, "name" returns KEGG IDs whereas 
#' "id" returns vertices IDs
#'
#' @return Vector of the names/ids of the desired KEGG graph community
#' 
#' @examples 
#' data(FELLA.sample)
#' ## Pathways
#' getCom(FELLA.sample, 1, format = "name")
#' getCom(FELLA.sample, 1, format = "id")
#' ## Modules
#' getCom(FELLA.sample, 2)
#' ## Enzymes
#' head(getCom(FELLA.sample, 3))
#' ## Reactions
#' head(getCom(FELLA.sample, 4))
#' ## Compounds
#' head(getCom(FELLA.sample, 5))
#' @export
getCom <- function(data, level, format = "name") {
    if (format == "name")
        return(names(data@keggdata@id[[level]]))
    
    if (format == "id")
        return(data@keggdata@id[[level]]) 
    
    stop("'format' must be 'name' or 'id'.")
}

#' Get excluded compounds
#' 
#' Extractor function for the compounds in the input 
#' that were not mapped to the KEGG graph
#'
#' @inheritParams .params
#'
#' @return Vector of the excluded compounds
#' 
#' @examples 
#' data(FELLA.sample)
#' data(input.sample)
#' 
#' ## No excluded compounds
#' obj <- defineCompounds(
#' compounds = input.sample, 
#' data = FELLA.sample)
#' getExcluded(obj)
#' 
#' ## One compound does not map
#' ## The user gets a warning as well
#' obj <- defineCompounds(
#' compounds = c(input.sample, "intruder"), 
#' data = FELLA.sample)
#' getExcluded(obj)
#' @export
getExcluded <- function(object) {
    return(object@userinput@excluded)
}

#' Get KEGG graph
#' 
#' Extractor function for the KEGG graph from the FELLA.DATA object
#'
#' @inheritParams .params
#'
#' @return KEGG graph as an \pkg{igraph} object
#' @examples 
#' data(FELLA.sample)
#' g <- getGraph(FELLA.sample)
#' class(g)
#' @export
getGraph <- function(data) {
    return(data@keggdata@graph)
}

#' Get KEGG version info
#' 
#' Extractor function for the info about the KEGG version used to 
#' build the FELLA.DATA object
#'
#' @inheritParams .params
#'
#' @return Character containing the KEGG release details
#' @examples 
#' data(FELLA.sample)
#' getInfo(FELLA.sample)
#' 
#' @export
getInfo <- function(data) {
    return(comment(getGraph(data)))
}

#' Get metabolites in the input
#' 
#' Extractor function for the metabolites 
#' specified by the user in the input
#'
#' @inheritParams .params
#'
#' @return Vector of metabolites in the input
#' 
#' @examples
#' data(FELLA.sample)
#' data(input.sample)
#' 
#' ## No excluded compounds: the input is recovered as is
#' obj <- defineCompounds(
#' compounds = input.sample, 
#' data = FELLA.sample)
#' i1 <- getInput(obj)
#' 
#' ## One compound does not map: the input contains only the mapped entities
#' obj <- defineCompounds(
#' compounds = c(input.sample, "intruder"), 
#' data = FELLA.sample)
#' i2 <- getInput(obj)
#' 
#' identical(sort(i1), sort(i2))
#' @export
getInput <- function(object) {
    return(object@userinput@metabolites)
}

#' Get matrix for the desired methodology
#' 
#' Extractor function for the matrices of 
#' hypergeometric, diffusion and PageRank methodologies
#'
#' @inheritParams .params
#'
#' @return Matrix for the desired methodology (internal usage)
#' @examples 
#' ## This function is internal
#' attach(environment(FELLA:::getMatrix))
#' data(FELLA.sample)
#' # When a matrix is loaded:
#' x <- getMatrix(FELLA.sample, "hypergeom")
#' dim(x)
#' # When it is not:
#' y <- getMatrix(FELLA.sample, "diffusion")
#' dim(y)
#' y
getMatrix <- function(data, method) {
    return(slot(data, method)@matrix)
}

#' Map KEGG identifiers to KEGG names
#' 
#' Map KEGG identifiers to KEGG names, multiple names 
#' for an ID are reported if annotated. 
#' The KEGG identifiers may have mixed levels.
#'
#' @inheritParams .params
#' @param id KEGG IDs whose name is desired
#'
#' @return List whose names are KEGG IDs and 
#' whose entries are the vectors of matches
#' @examples 
#' data(FELLA.sample)
#' getName(FELLA.sample, c("C00002", "C00040"))
#' 
#' @export
getName <- function(data, id) {
    ans <- id
    names(ans) <- id
    
    names.intersect <- id %in% names(data@keggdata@id2name)
    ans[names.intersect] <- data@keggdata@id2name[ans[names.intersect]]
    return(ans)
}

#' Get p-scores from the desired methodology
#' 
#' Extractor function for the p-scores using the desired methodology
#'
#' @inheritParams .params
#'
#' @return Named vector of p-scores
#' 
#' @examples
#' data(FELLA.sample)
#' data(input.sample)
#' obj <- enrich(
#' compounds = input.sample, 
#' data = FELLA.sample)
#' p <- getPscores(obj, "diffusion")
#' sum(p < 0.1)
#' 
#' @export
getPscores <- function(object, method) {
    if (method == "hypergeom") return(slot(object, method)@pvalues)
    return(slot(object, method)@pscores)
}

#' Get matrix for the p-value regarding CC size
#' 
#' Extractor function for the matrix containing p-value by CC size
#' that compares to a random selection of nodes in the KEGG graph
#'
#' @inheritParams .params
#'
#' @return Matrix with p-values for CC size (internal usage)
#' 
#' @examples 
#' ## This function is internal
#' attach(environment(FELLA:::getPvaluesSize))
#' data(FELLA.sample)
#' M <- getPvaluesSize(FELLA.sample)
#' dim(M)
#' summary(as.vector(M))
#' @keywords internal
getPvaluesSize <- function(data) {
    return(data@keggdata@pvalues.size)
}

#' Get rowSums/squaredRowSums
#' 
#' Extractor function for rowSums/squaredRowSums
#'
#' @inheritParams .params
#' @param squared Logical, whether to return 
#' \code{rowSums} (\code{F}) or \code{squaredRowSums} (\code{T})
#'
#' @return Named vector with rowSums/squaredRowSums (internal usage)
#' @examples 
#' ## This function is internal
#' attach(environment(FELLA:::getSums))
#' data(FELLA.sample)
#' rowsums <- getSums(FELLA.sample, "diffusion", squared = FALSE)
#' hist(rowsums)
getSums <- function(data, method, squared) {
    if (squared) 
        return(slot(data, method)@squaredRowSums)
    
    if (!squared) 
        return(slot(data, method)@rowSums)
    
    invisible()
}

#' Get the slot "valid"
#' 
#' Extractor function for the slot "valid"
#'
#' @inheritParams .params
#'
#' @return Slot "valid" (internal usage)
#' 
#' @examples 
#' ## This function is internal
#' 
#' data(FELLA.sample)
#' data(input.sample)
#' 
#' obj <- enrich(
#' compounds = input.sample, 
#' method = "diffusion", 
#' data = FELLA.sample)
#' 
#' ## If the analysis is valid
#' FELLA:::getValid(obj, "diffusion")
#' 
#' ## Otherwise
#' FELLA:::getValid(new("FELLA.USER"), "diffusion")
#' FELLA:::getValid(obj, "pagerank")
#' 
getValid <- function(object, method) {
    return(slot(object, method)@valid)
}

#' Get the slot "status" 
#' 
#' Extractor function for the slot "status" for the KEGG data
#'
#' @inheritParams .params
#'
#' @return Slot "status" (internal usage)
#' 
#' @examples 
#' ## This function is internal
#' 
#' data(FELLA.sample)
#' 
#' ## Is the object loade?
#' FELLA:::getStatus(FELLA.sample)
#' FELLA:::getStatus(new("FELLA.DATA"))
getStatus <- function(data) {
    return(data@keggdata@status)
}

context("Enrichment analysis (wrapper enrich)")

# Load data to test
# test.env <- new.env(parent = environment())
test.env <- environment()

test_that("Sample data can be loaded", {
    expect_error({
        data("FELLA.sample", package = "FELLA", envir = test.env)
        data("input.sample", package = "FELLA", envir = test.env)
    }, NA)
})

test_that("Enrichment wrapper", {
    nnodes <- igraph::vcount(getGraph(FELLA.sample))
    npaths <- length(getCom(FELLA.sample, "pathway"))
    
    plyr::l_ply(
        c("hypergeom", "diffusion", "pagerank"), 
        function(method) {
            plyr::l_ply(
                c("normality", "simulation", "t", "gamma"), 
                function(approx) {
                    FELLA.test <- enrich(
                        compounds = input.sample, 
                        methods = method, 
                        approx = approx, 
                        niter = 100, 
                        data = FELLA.sample)
                    
                    expect_s4_class(FELLA.test, "FELLA.USER")
                    
                    pval <- getPscores(FELLA.test, method = method)
                    
                    expect_named(pval)
                    expect_is(pval, "numeric")
                    if (method == "hypergeom") {
                        expect_length(pval, npaths)
                    } else {
                        expect_length(pval, nnodes)
                    }
                    expect_true(all(pval >= 0 & pval <= 1))
                }
            )
        }
    )
})

context("Extractor functions")

# Load data to test
# test.env <- new.env(parent = environment())
test.env <- environment()
data("FELLA.sample", package = "FELLA", envir = test.env)
data("input.sample", package = "FELLA", envir = test.env)

test_that("getCom extractor", {
    categories <- c(as.list(1:5), listCategories())
    
    plyr::l_ply(categories, function(categ) {
        temporary <- try(FELLA:::getCom(
            data = FELLA.sample, 
            level = categ, 
            format = "name"))
        
        expect_is(temporary, "character")
        expect_gt(length(temporary), 0)
        
        temporary <- try(FELLA:::getCom(
            data = FELLA.sample, 
            level = categ, 
            format = "id"))
        
        expect_is(temporary, "integer")
        expect_named(temporary)
        expect_gt(length(temporary), 0)
        
        invisible()
    })
})

test_that("getGraph extractor", {
    expect_is(FELLA:::getGraph(FELLA.sample), "igraph")
    expect_is(FELLA:::getInfo(FELLA.sample), "character")
})

test_that("getMatrix extractor", {
    expect_is(FELLA:::getMatrix(FELLA.sample, "hypergeom"), "lgCMatrix")
    expect_is(FELLA:::getMatrix(FELLA.sample, "diffusion"), "matrix")
    expect_is(FELLA:::getMatrix(FELLA.sample, "pagerank"), "matrix")
})

test_that("getName extractor", {
    temp <- FELLA:::getCom(FELLA.sample, level = 3)
    ans_temp <- FELLA::getName(FELLA.sample, id = temp)
    
    expect_is(ans_temp, "list")
    expect_gt(length(ans_temp), 0)
    expect_is(ans_temp[[1]], "character")
    expect_gt(length(ans_temp[[1]]), 0)
})

test_that("getSums extractor", {
    plyr::l_ply(
        c("diffusion", "pagerank"), 
        function(method) {
            plyr::l_ply(
                c(TRUE, FALSE), 
                function(squared) {
                    sums <- FELLA:::getSums(
                        data = FELLA.sample, 
                        method = "diffusion", 
                        squared = FALSE)
                    
                    expect_named(sums)
                    expect_is(sums, "numeric")
                    expect_gt(length(sums), 0)
                    expect_true(all(sums > 0))
                }
            )
        }
    )
})

context("FELLA.USER creation from compounds in lists")

# Load data to test
# test.env <- new.env(parent = environment())
test.env <- environment()
data("FELLA.sample", package = "FELLA", envir = test.env)
data("input.sample", package = "FELLA", envir = test.env)


background.sample <- try(FELLA:::getCom(FELLA.sample, 5))


test_that("All compounds map, personalised background", {
  FELLA.test <- try(
    defineCompounds(
      compounds = input.sample, 
      compoundsBackground = background.sample, 
      data = FELLA.sample))
  
  expect_s4_class(FELLA.test, "FELLA.USER")
  expect_equivalent(getInput(object = FELLA.test), 
                    input.sample)
  expect_equivalent(getBackground(object = FELLA.test), 
                    background.sample)
  expect_length(getExcluded(object = FELLA.test), 
                0)
})

test_that("All compounds map, no background", {
  expect_message(FELLA.test <- try(
    defineCompounds(
      compounds = input.sample, 
      compoundsBackground = NULL, 
      data = FELLA.sample)), 
    "No background compounds specified")
  
  expect_s4_class(FELLA.test, "FELLA.USER")
  expect_equivalent(getInput(object = FELLA.test), 
                    input.sample)
  expect_length(getBackground(object = FELLA.test), 
                0)
  expect_length(getExcluded(object = FELLA.test), 
                0)
})

test_that("Not all compounds map, no background", {
  intruder.sample <- paste0("intruder", 1:10)
  expect_warning(FELLA.test <- try(
    defineCompounds(
      compounds = c(input.sample, intruder.sample), 
      compoundsBackground = NULL, 
      data = FELLA.sample)), 
    "excluded")
  
  expect_s4_class(FELLA.test, "FELLA.USER")
  expect_equivalent(sort(getInput(object = FELLA.test)), 
                    sort(input.sample))
  expect_length(getBackground(object = FELLA.test), 
                0)
  expect_equivalent(sort(getExcluded(object = FELLA.test)), 
                    sort(intruder.sample))
})

test_that("Not all compounds map, background with mapping issues too", {
  intruder1.sample <- paste0("intruder", 1:5)
  intruder2.sample <- paste0("intruder", 1:10)
  expect_warning(FELLA.test <- try(
    defineCompounds(
      compounds = c(input.sample, intruder1.sample), 
      compoundsBackground = c(background.sample, intruder2.sample), 
      data = FELLA.sample)), 
    "excluded")
  
  expect_s4_class(FELLA.test, "FELLA.USER")
  expect_equivalent(sort(getInput(object = FELLA.test)), 
                    sort(input.sample))
  expect_equivalent(sort(getBackground(object = FELLA.test)), 
                    sort(background.sample))
  expect_equivalent(sort(getExcluded(object = FELLA.test)), 
                    sort(intruder1.sample))
})

# method <- "diffusion"
# approx <- "normality"
# FELLA.object <- FELLA::enrich(compounds = input.sample,
#                               method = method, 
#                               approx = approx, 
#                               data = FELLA.sample)
# 
# 
# 
# getCom(data = FELLA.sample, level = "compound")
# summary(getPscores(object = FELLA.object, type = "diffusion"))

## ----warning=FALSE, message=FALSE---------------------------------------------
library(FELLA)

data("FELLA.sample")
class(FELLA.sample)
show(FELLA.sample)

## ----warning=FALSE, message=FALSE---------------------------------------------
data("input.sample")
input.full <- c(input.sample, paste0("intruder", 1:10))

show(input.full)

## ----warning=TRUE, message=TRUE-----------------------------------------------
myAnalysis <- defineCompounds(
    compounds = input.full, 
    data = FELLA.sample)

## ----warning=TRUE, message=TRUE-----------------------------------------------
getInput(myAnalysis)

## ----warning=TRUE, message=TRUE-----------------------------------------------
getExcluded(myAnalysis)

## ----warning=FALSE, message=FALSE, error=TRUE---------------------------------
try({
input.fail <- paste0(" ", input.full)
defineCompounds(
    compounds = input.fail, 
    data = FELLA.sample)
})

## ----warning=TRUE, message=TRUE-----------------------------------------------
myAnalysis <- enrich(
    compounds = input.full, 
    method = "diffusion", 
    approx = "normality", 
    data = FELLA.sample)

## ----warning=TRUE, message=TRUE-----------------------------------------------
show(new("FELLA.USER"))

## ----warning=TRUE, message=TRUE-----------------------------------------------
show(myAnalysis)

## ----warning=FALSE, message=FALSE---------------------------------------------
myAnalysis <- enrich(
    compounds = input.full, 
    method = listMethods(), 
    approx = "normality", 
    data = FELLA.sample)

show(myAnalysis)

## ----warning=FALSE, message=TRUE----------------------------------------------
myAnalysis_bis <- runDiffusion(
    object = myAnalysis, 
    approx = "normality", 
    data = FELLA.sample)
show(myAnalysis_bis)

## ----warning=FALSE, message=TRUE, fig.width=8, fig.height=8-------------------
plot(
    x = myAnalysis, 
    method = "hypergeom", 
    main = "My first enrichment using the hypergeometric test in FELLA", 
    threshold = 1, 
    data = FELLA.sample)

## ----warning=FALSE, message=TRUE, fig.width=8, fig.height=8-------------------
plot(
    x = myAnalysis, 
    method = "diffusion", 
    main = "My first enrichment using the diffusion analysis in FELLA", 
    threshold = 0.1, 
    data = FELLA.sample)

## ----warning=FALSE, message=TRUE, fig.width=8, fig.height=8-------------------
plot(
    x = myAnalysis, 
    method = "pagerank", 
    main = "My first enrichment using the PageRank analysis in FELLA", 
    threshold = 0.1, 
    data = FELLA.sample)

## ----warning=FALSE, message=TRUE, results='asis'------------------------------
myTable <- generateResultsTable(
    object = myAnalysis, 
    method = "diffusion", 
    threshold = 0.1, 
    data = FELLA.sample)

knitr::kable(head(myTable, 20))

## ----warning=FALSE, message=TRUE----------------------------------------------
myGraph <- generateResultsGraph(
    object = myAnalysis, 
    method = "diffusion", 
    threshold = 0.1, 
    data = FELLA.sample)

show(myGraph)

## ----warning=FALSE, message=TRUE, results='asis'------------------------------
myTempDir <- tempdir()
myExp_csv <- paste0(myTempDir, "/table.csv")
exportResults(
    format = "csv", 
    file = myExp_csv, 
    method = "pagerank", 
    threshold = 0.1, 
    object = myAnalysis, 
    data = FELLA.sample)

test <- read.csv(file = myExp_csv)
knitr::kable(head(test))

## ----warning=FALSE, message=TRUE, results='asis'------------------------------
myExp_graph <- paste0(myTempDir, "/graph.RData")
exportResults(
    format = "igraph", 
    file = myExp_graph, 
    method = "pagerank", 
    threshold = 0.1, 
    object = myAnalysis, 
    data = FELLA.sample)

stopifnot("graph.RData" %in% list.files(myTempDir))

## ----warning=FALSE, message=TRUE, results='asis'------------------------------
myExp_pajek <- paste0(myTempDir, "/graph.pajek")
exportResults(
    format = "pajek", 
    file = myExp_pajek, 
    method = "diffusion", 
    threshold = 0.1, 
    object = myAnalysis, 
    data = FELLA.sample)

stopifnot("graph.pajek" %in% list.files(myTempDir))

## -----------------------------------------------------------------------------
sessionInfo()

#' @include generateResultsGraph.R
#' 
#' @title Generate and manipulate tables and sub-networks from an enrichment
#' 
#' @description 
#' Function \code{exportResults} 
#' is a wrapper around \code{generateResultsTable}, 
#' \code{generateEnzymesTable} and \code{generateResultsGraph} 
#' to write the results to files.
#' 
#' @details
#' Function \code{exportResults} writes the enrichment results 
#' as the specified filetype.
#' Options are: a csv table (\code{"csv"}), 
#' an enzyme csv table (\code{"enzyme"}) 
#' an \pkg{igraph}
#' object as an \code{RData} file, 
#' or any format supported by igraph's 
#' \code{\link[igraph]{write_graph}}.
#' 
#' @param format Character, one of: \code{"csv"} for regular 
#' results table, \code{"enzyme"} for table with enzyme data, 
#' \code{"igraph"} for igraph format. 
#' Alternatively, any format supported by igraph, 
#' see \code{\link[igraph]{write_graph}}
#' @param file Character specifying the output file name
#' @param ... Optional arguments for the plotting function 
#' in \code{plotGraph}. Arguments passed to the exporting function 
#' in \code{exportResults}. Ignored otherwise.
#' @inheritParams .params
#'
#' @return \code{exportResults} returns \code{invisible()}, 
#' but as a side effect the specified \code{file} is created.
#' 
#' @rdname export-funs
#' 
#' @template refs_gene_ontology
#' 
#' @examples 
#' ## First generate a toy enrichment
#' library(igraph)
#' data(FELLA.sample)
#' data(input.sample)
#' ## Enrich input
#' obj <- enrich(
#' compounds = input.sample, 
#' data = FELLA.sample)
#' 
#' ######################
#' ## Results table
#' tab.res <- generateResultsTable(
#' method = "hypergeom",
#' threshold = 0.1, 
#' object = obj, 
#' data = FELLA.sample)
#' head(tab.res)
#' 
#' tab.res <- generateResultsTable(
#' method = "diffusion",
#' threshold = 0.1, 
#' object = obj, 
#' data = FELLA.sample)
#' head(tab.res)
#' 
#' ######################
#' ## Use wrapper to write the table to a file
#' out.file <- tempfile()
#' exportResults(
#' format = "csv", 
#' threshold = 0.1, 
#' file = out.file, 
#' object = obj, 
#' data = FELLA.sample)
#' tab.wrap <- read.csv(out.file)
#' head(tab.wrap)
#' 
#' ######################
#' ## Enzymes table
#' tab.ec <- generateEnzymesTable(
#' threshold = 0.1, 
#' object = obj, 
#' data = FELLA.sample, 
#' mart.options = NULL)
#' head(tab.ec)
#' 
#' ######################
#' ## Generate graph
#' g.res <- generateResultsGraph(
#' method = "pagerank", 
#' threshold = 0.1, 
#' object = obj, 
#' data = FELLA.sample)
#' g.res
#' 
#' ## Plot graph (without GO terms)
#' plotGraph(g.res)
#' 
#' ## Add similarity to the GO CC term "mitochondrion"
#' \dontrun{
#' g.cc <- FELLA:::addGOToGraph(
#' graph = g.res, 
#' GOterm = "GO:0005739")
#' 
#' ## Plot graph (with GO terms)
#' plotGraph(g.cc)
#' 
#' ## Without the CC
#' any(V(g.res)$GO.simil >= 0)
#' ## With the CC
#' v.cc <- unlist(V(g.cc)$GO.simil)
#' sum(v.cc >= 0, na.rm = TRUE)
#' ## Similarity values
#' table(v.cc)
#' }
#' 
#' @import igraph
#' @export
exportResults <- function(
    format = "csv", 
    file = "myOutput", 
    method = "diffusion", 
    object = NULL, 
    data = NULL, 
    ...) {
    
    if (!is.FELLA.DATA(data)) {
        stop("'data' is not a FELLA.DATA object")
    } else if (getStatus(data) != "loaded"){
        stop("'data' points to an empty FELLA.DATA object")
    }
    
    # Writing tables that summarise the results
    if (format == "csv") {
        message("Exporting to a csv file...")
        df <- generateResultsTable(
                method = method, 
                object = object, 
                data = data, 
                ...)
        utils::write.table(
            df, 
            file = file, 
            sep = ",", 
            row.names = FALSE)
    } else if (format == "enzyme") {
        # Option to export enzymes with genes and GO annotations
        if (method %in% c("diffusion", "pagerank")) {
            df <- generateEnzymesTable(
                method = method, 
                object = object, 
                data = data, 
                ...)
            utils::write.table(
                df, 
                file = file, 
                sep = ",", 
                row.names = FALSE)
        } else {
            stop(
                "Enzymes are only reported in diffusion and pagerank, ",
                "but not in method ", method)
        }
    } else {
        # Exporting the graph 
        graph <- generateResultsGraph(
            method = method, 
            object = object, 
            data = data, 
            ...)
        
        if (format == "igraph") {
            message("Exporting to a RData file using 'igraph' object...")
            save(graph, file = file)
        } else {
            message(
                "Exporting to the format ", format, " using igraph...")
            write.graph(graph = graph, file = file, format = format)
        }
        
    }
    
    message("Done")
    return(invisible())
}

#' @inheritParams .params
#'
#' @return \code{generateResultsTable} returns a 
#' data.frame that contains the nodes below the \code{p.score} threshold 
#' from an enrichment analysis
#' 
#' @name export-funs
#' @rdname export-funs
#' 
#' @import igraph
#' @export
generateResultsTable <- function(
    method = "diffusion", 
    threshold = 0.05, 
    plimit = 15, 
    nlimit = 250, 
    LabelLengthAtPlot = 45, 
    capPscores = 1e-6, 
    object = NULL, 
    data = NULL, 
    ...) {
    
    if (!is.FELLA.DATA(data)) {
        stop("'data' is not a FELLA.DATA object")
    } else if (getStatus(data) != "loaded"){
        stop("'data' points to an empty FELLA.DATA object")
    }
    
    checkArgs <- checkArguments(
        method = method, 
        threshold = threshold, 
        plimit = plimit, 
        nlimit = nlimit, 
        LabelLengthAtPlot = LabelLengthAtPlot, 
        object = object, 
        data = data)
    
    if (!checkArgs$valid)
        stop("Bad argument when calling function 'generateResultsGraph'.")
    
    if (is.na(getValid(object, method)) | !getValid(object, method)) {
        warning(
            "Mehod ", method, " has not been executed yet. ",  
            "Returning NULL...")
        return(invisible())
    } 
    
    # HYPERGEOMETRIC TEST
    if (method == "hypergeom") {
        message("Writing hypergeom results...")
        
        pscores <- sort(getPscores(object, "hypergeom"))
        
        if (pscores[1] >= threshold) {
            message("No pathway is below the p-value threshold.")
        } else {
            pscores <- head(pscores[pscores < threshold], plimit)
            
            # Info to display
            paths <- names(pscores)
            pathnames <- as.character(data@keggdata@id2name[paths])
            pathhits <- object@hypergeom@pathhits[paths]
            pathbackground <- object@hypergeom@pathbackground[paths]
            
            # Build the dataframe
            out.hypergeom <- data.frame(
                "KEGG id" = paths, 
                "KEGG name" = pathnames, 
                "CompoundHits" = pathhits, 
                "CompoundsInPathway" = pathbackground, 
                "p.value" = pscores, 
                stringsAsFactors = FALSE)
            rownames(out.hypergeom) <- NULL
            
            message("Done.")
            
            return(out.hypergeom)
        }
    } else {
        # Diffusion and pagerank
        message("Writing ", method, " results...")
        
        pscores <- sort(getPscores(object, method))
        pscores[pscores < capPscores] <- capPscores
        
        if (pscores[1] >= threshold) {
            message("No node is below the p-score threshold.")
        } else {
            pscores <- head(pscores[pscores < threshold], nlimit)
            pscores <- pscores[order(names(pscores))]
            
            nodeIds <- names(pscores)
            # Take names (1st name in KEGG, abbreviate if it's too long)
            nodeNames <- as.character(vapply(nodeIds, function(id) {
                ans <- data@keggdata@id2name[[id]]
                if (length(ans) == 0) 
                    return("")
                
                ans <- ans[1]
                if (nchar(ans) > LabelLengthAtPlot) 
                    ans <- paste0(substr(ans, 1, LabelLengthAtPlot), "...")
                return(ans)
            }, FUN.VALUE = character(1)))
            nodeCom <- V(getGraph(data))[nodeIds]$com
            nodeTypes <- listCategories()[nodeCom]
            
            out <- data.frame(
                "KEGG id" = nodeIds,
                "Entry type" = nodeTypes,
                "KEGG name" = nodeNames, 
                "p.score" = pscores, 
                stringsAsFactors = FALSE)[order(nodeCom), ]
            rownames(out) <- NULL
            
            message("Done.")
            
            return(out)
        }
    }
}

#' Internal function to add a legend to a graph plot
#' 
#' This function adds a legend to a solution plot. 
#' It can include the CC similarity.
#'
#' @param GO.annot Logical, should GO annotations be included?
#' @param cex Numeric value, \code{cex} parameter for the function 
#' \code{\link[graphics]{legend}}
#' 
#' @return This function is only used for its effect, 
#' so it returns \code{invisible()}
#' 
#' @examples 
#' ## This function is internal
#' 
#' library(igraph)
#' g <- barabasi.game(20)
#' plot(g)
#' FELLA:::plotLegend()
#' plot(g)
#' FELLA:::plotLegend(GO.annot = TRUE)
plotLegend <- function(
    GO.annot = FALSE, 
    cex = 0.75) {
    # In the left side, legend for node categories
    graphics::legend(
        text.width = .25, 
        "bottomleft", 
        title = "Categories for each node", 
        title.col = "black", 
        legend = c(
            "Pathway", 
            "Module", 
            "Enzyme", 
            "Reaction", 
            "Compound", 
            "Input compound"), 
        pch = c(21, 21, 21, 21, 21, 22), 
        col = "black", 
        cex = cex, 
        pt.cex = c(1.1, 1.1, 1.1, 1.1, 1.1, 1.1), 
        pt.lwd = 1, 
        x.intersp = .3, 
        box.col = "grey", 
        pt.bg = c(
            "#CD0000", 
            "#CD96CD", 
            "#FFD500", 
            "#8DB6CD", 
            "#548B54", 
            "#548B54"), 
        text.col = c(
            "#CD0000", 
            "#CD96CD", 
            "#FFD500", 
            "#8DB6CD", 
            "#548B54", 
            "#548B54"), 
        ncol = 3
    )
    
    # In the right side, enzyme for cellular component
    if (GO.annot) {
        graphics::legend(
            text.width = .2, 
            "bottomright", 
            title = "Enzymes with CC similarity", 
            title.col = "black", 
            legend = c(
                "Simil < 0.5", 
                "Simil < 0.7", 
                "Simil < 0.9", 
                "Simil <= 1"), 
            pch = c(24, 24, 24, 24), 
            col = "black", 
            cex = cex, 
            pt.cex = c(1.1, 1.1, 1.1, 1.1), 
            pt.lwd = 1, 
            x.intersp = .3, 
            box.col = "grey", 
            pt.bg = c(
                "#FFD500", 
                "#FF5500", 
                "#FF0000", 
                "#B300FF"), 
            text.col = c(
                "#FFD500", 
                "#FF5500", 
                "#FF0000", 
                "#B300FF"), 
            ncol = 2
        )
    }
    
    return(invisible())
}

#' @include generateEnzymesTable.R
#' 
#' @description 
#' Function \code{generateResultsGraph} 
#' gives a sub-network, plottable through 
#' \code{plotGraph}, witht the nodes with 
#' the lowest \code{p.score} from an enrichment analysis. 
#' Function \code{addGOToGraph} can be applied to such 
#' sub-networks to overlay GO labels and 
#' similarity to a user-defined GO term. 
#' 
#' @details
#' Function \code{generateResultsGraph} returns an 
#' \pkg{igraph} 
#' object with a relevant sub-network 
#' for manual examination. 
#' A \code{\link{FELLA.USER}} 
#' object with a successful enrichment analysis and the corresponding 
#' \code{\link{FELLA.DATA}} must be supplied. 
#' Graph nodes are prioritised by \code{p.score} and selected through 
#' the most stringent between (1) p.score \code{threshold} and 
#' (2) maximum number of nodes \code{nlimit}. 
#' 
#' There is an additional filtering feature for tiny connected components, 
#' controllable through \code{thresholdConnectedComponent} 
#' (smaller is stricter). 
#' The user can choose to turn off this filter by setting 
#' \code{thresholdConnectedComponent = 1}.  
#' The idea is to discard connected components so small 
#' that are likely to arise from random selection of nodes. 
#' Let \code{k} be the order of the current sub-network.
#' A connected component of order \code{r} will
#' be kept only if the probability that a 
#' random subgraph from the whole KEGG knowledge model 
#' of order \code{k} contains a
#' connected component of order at least \code{r} 
#' is smaller than \code{thresholdConnectedComponent}. 
#' Such probabilities are estimated during 
#' \code{\link[=data-funs]{buildDataFromGraph}}; the amount of random 
#' trials can be controlled by its \code{niter} argument. 
#' 
#' @inheritParams .params
#'
#' @return \code{generateResultsGraph} returns 
#' an \pkg{igraph}
#' object: a sub-network from the whole 
#' KEGG knowledge model under the specified thresholds 
#' (\code{threshold} and \code{thresholdConnectedComponent})
#' 
#' @rdname export-funs
#' 
#' @import igraph
#' @export
generateResultsGraph <- function(
    method = "diffusion", 
    threshold = 0.05, 
    plimit = 15, 
    nlimit = 250, 
    thresholdConnectedComponent = 0.05, 
    LabelLengthAtPlot = 22, 
    object = NULL, 
    data = NULL, 
    ...) {
    
    if (!is.FELLA.DATA(data)) {
        stop("'data' is not a FELLA.DATA object")
    } else if (getStatus(data) != "loaded"){
        stop("'data' points to an empty FELLA.DATA object")
    }
    
    checkArgs <- checkArguments(
        method = method, 
        threshold = threshold, 
        plimit = plimit, 
        nlimit = nlimit, 
        thresholdConnectedComponent = thresholdConnectedComponent, 
        LabelLengthAtPlot = LabelLengthAtPlot, 
        object = object, 
        data = data)
    
    if (!checkArgs$valid)
        stop("Bad argument when calling function 'generateResultsGraph'.")
    
    valid <- getValid(object, method)
    if (is.na(valid) || !valid) {
        warning(
            "Method ", method, " has not been executed yet. ", 
            "Returning NULL...")
        return(invisible())
    } 
    
    #####################
    
    if (method == "hypergeom") {
        # HYPERGEOMETRIC TEST
        pscores <- getPscores(object, "hypergeom")
        g.data <- getGraph(data)
        
        # Select pathways and compounds
        n.paths <- sum(pscores < threshold)
        if (n.paths < 1) {
            message("Graph is empty. None of the pathways is significant.")
            return(NULL)
        } else {
            path.hypergeom <- names(head(
                sort(pscores[pscores < threshold]), 
                plimit))
        } 
        
        comp.hypergeom <- intersect(
            getInput(object), 
            rownames(getMatrix(data, "hypergeom")))

        # Build the bipartite graph
        incidence <- getMatrix(data, "hypergeom")[
            comp.hypergeom, path.hypergeom, drop = FALSE]
        
        graph.bipartite <- graph.incidence(incidence = incidence)
        graph.bipartite <- induced.subgraph(
            graph.bipartite, 
            vids = (degree(graph.bipartite) > 0))
        
        # The com attribute for each node
        V(graph.bipartite)$com <- V(g.data)[V(graph.bipartite)$name]$com
        V(graph.bipartite)$label <- vapply(
            V(g.data)[V(graph.bipartite)$name]$NAME, 
            function(name.aux) {
                if (length(name.aux) == 0) return(NA_character_)
                # Take first name
                name.first <- name.aux[[1]]
                name.def <- substr(name.first, 1, LabelLengthAtPlot)
                if (nchar(name.first) > LabelLengthAtPlot) 
                    name.def <- paste0(name.def, "...")
                
                name.def
            }, 
            FUN.VALUE = character(1)
        )
            
        return(graph.bipartite)
    } else { 
        # DIFFUSION AND PAGERANK
        pscores <- getPscores(object, method)
        input <- getInput(object)
        
        n.nodes <- sum(pscores < threshold)
        if (n.nodes < 1) {
            message("Graph is empty.")
            return(NULL)
        } else if (n.nodes > nlimit) {
            message(paste0(
                n.nodes, 
                " nodes below the threshold have been limited to ", 
                nlimit, 
                " nodes."))
            nodes <- names(pscores)[sort(head(order(pscores), nlimit))]
        } else {
            nodes <- names(pscores)[pscores < threshold]
        }
        
        graph <- induced.subgraph(graph = getGraph(data), vids = nodes)
        
        if (method == "diffusion") graph <- as.undirected(graph)
        
        # Define labels for the plot
        vertex.labels <- character(vcount(graph))
        vertex.labels <- vapply(
            V(graph)$NAME, 
            function(name.aux) {
                if (length(name.aux) == 0) return(NA_character_)
                # Take first name
                name.first <- name.aux[[1]]
                name.def <- substr(name.first, 1, LabelLengthAtPlot)
                if (nchar(name.first) > LabelLengthAtPlot) 
                    name.def <- paste0(name.def, "...")
                
                name.def
            }, 
            FUN.VALUE = character(1)
        )
        
        V(graph)$label <- vertex.labels
        V(graph)$input <- V(graph)$name %in% input
        
        # Filter out small CCs
        n.nodes.graph <- vcount(graph)
        
        # Connected components
        graph.clust <- clusters(graph)
        
        # Size cannot exceed 250 to 
        # calculate p-values... we will approximate
        if (n.nodes.graph > 250) {
            warning(
                "The number of nodes of the whole solution, which is ", 
                n.nodes.graph, 
                ", exceeds 250. Small connected components ", 
                "will be filtered using 250 nodes instead.")
            
            n.nodes.graph <- 250
        }
        
        # p-values of largest cc size (they are decreasing in 
        # CC size)
        tab.significant <- getPvaluesSize(data)[, n.nodes.graph]
        # Minimum size to consider "significant"
        csize.significant <- which(
            tab.significant <= thresholdConnectedComponent)[1]
        if (length(csize.significant) == 0) {
            warning(
                "None of the connected components are below the ", 
                "'thresholdConnectedComponent'. Returning empty graph...")
            return(igraph::induced_subgraph(graph, NULL))
        } 
        
        # Graph is not empty 
        # Select the biggest CCs only
        clust.select <- which(graph.clust$csize >= csize.significant)
        
        graph.ans <- igraph::induced_subgraph(
            graph, 
            vids = which(graph.clust$membership %in% clust.select)
        )
        
        return(graph.ans)
    }
    
}

#' @include buildDataFromGraph.R
#' 
#' @description 
#' Function \code{loadKEGGdata} loads the internal files 
#' containing the KEGG knowledge model into a 
#' \code{\link{FELLA.DATA}} object. 
#' 
#' In general, \code{generateGraphFromKEGGREST} and 
#' \code{generateDataFromGraph} are one-time executions 
#' for a given organism and knowledge model, 
#' in this precise order. 
#' On the other hand, the user needs to run \code{loadKEGGdata} 
#' in every new R session to load such model into a 
#' \code{\link{FELLA.DATA}} object. 
#' 
#' @details 
#' Function \code{loadKEGGdata} returns a 
#' \code{\link{FELLA.DATA}} object from any of the 
#' databases generated by \code{\link{FELLA.DATA}}.
#' This object is the starting point of any enrichment 
#' using \code{\link{FELLA}}.
#' In case the user built the matrices for "diffusion" and "pagerank", 
#' he or she can choose to load them.  
#' Further detail on the methods can be found in [Picart-Armada, 2017].
#' The matrices allow a faster computation and the definition 
#' of a custom background, but use up to 250MB of memory each.
#'
#' @inheritParams .params
#'
#' @return \code{loadKEGGdata} returns the 
#' \code{\link{FELLA.DATA}} object 
#' that contains the KEGG knowledge representation.
#'  
#' @examples 
#' ## Toy example
#' ## In this case, the graph is not built from current KEGG. 
#' ## It is loaded from sample data in FELLA
#' data("FELLA.sample")
#' ## Graph to build the database (this example is a bit hacky)
#' g.sample <- FELLA:::getGraph(FELLA.sample)
#' dir.tmp <- paste0(tempdir(), "/", paste(sample(letters), collapse = ""))
#' ## Build internal files in a temporary directory
#' buildDataFromGraph(
#' keggdata.graph = g.sample, 
#' databaseDir = dir.tmp, 
#' internalDir = FALSE, 
#' matrices = NULL, 
#' normality = NULL, 
#' dampingFactor = 0.85,
#' niter = 10)
#' ## Load database
#' myFELLA.DATA <- loadKEGGdata(
#' dir.tmp, 
#' internalDir = FALSE)
#' myFELLA.DATA
#'
#' ######################
#'
#' \dontrun{
#' ## Full example
#' 
#' ## First step: graph for Mus musculus discarding the mmu01100 pathway
#' ## (an analog example can be built from human using organism = "hsa")
#' g.mmu <- buildGraphFromKEGGREST(
#' organism = "mmu", 
#' filter.path = "mmu01100")
#' summary(g.mmu)
#' cat(comment(g.mmu))
#' 
#' ## Second step: build internal files for this graph
#' ## (consumes some time and memory, especially if we compute 
#' "diffusion" and "pagerank" matrices)
#' buildDataFromGraph(
#' keggdata.graph = g.mmu, 
#' databaseDir = "example_db_mmu", 
#' internalDir = TRUE, 
#' matrices = c("hypergeom", "diffusion", "pagerank"), 
#' normality = c("diffusion", "pagerank"), 
#' dampingFactor = 0.85,
#' niter = 1e3)
#' ## Third step: load the internal files into a FELLA.DATA object
#' FELLA.DATA.mmu <- loadKEGGdata(
#' "example_db_mmu", 
#' internalDir = TRUE, 
#' loadMatrix = c("diffusion", "pagerank"))
#' FELLA.DATA.mmu
#' }
#' 
#' @seealso class \code{\link{FELLA.DATA}}
#' 
#' @template refs_fella_data
#' 
#' @rdname data-funs
#' 
#' @import igraph
#' @export
loadKEGGdata <- function(
    databaseDir = tail(listInternalDatabases(), 1), 
    internalDir = TRUE, 
    loadMatrix = NULL) { 
    
    message("Loading KEGG graph data...")
    
    # Checking the input
    ########################
    checkArgs <- checkArguments(
        loadMatrix = loadMatrix, 
        databaseDir = databaseDir, 
        internalDir = internalDir)
    if (!checkArgs$valid)
        stop("Bad argument when calling function 'runDiffusion'.")  
    
    ##########################
    assign("F.DATA", new("FELLA.DATA"))
    
    # Make sure there is a slash
    path <- ifelse(
        internalDir, 
        paste0(
            system.file("database", package = "FELLA"), 
            "/", databaseDir, "/"), 
        paste0(databaseDir, "/"))
    
    # Does the dir exist?
    if (!dir.exists(path)) {
        stop(
            "Directory ", path, " does not exist. ", 
            "Database '", databaseDir, "' cannot be found. ",
            "Aborting...")
    }
    
    # Load the graph and the identifiers (required)
    if (file.exists(paste0(path, "keggdata.graph.RData"))) {
        load(paste0(path, "keggdata.graph.RData"))
        keggdata.graph <- get("keggdata.graph")
        keggdata.pvalues.size <- get("keggdata.pvalues.size")
        
        F.DATA@keggdata@graph <- keggdata.graph
        F.DATA@keggdata@pvalues.size <- keggdata.pvalues.size
        F.DATA@keggdata@id2name <- V(keggdata.graph)$NAME
        names(F.DATA@keggdata@id2name) <- V(keggdata.graph)$name
        
        F.DATA@keggdata@id$pathway <- which(V(keggdata.graph)$com == 1)
        names(F.DATA@keggdata@id$pathway) <- 
            (V(keggdata.graph)$name)[F.DATA@keggdata@id$pathway]
        F.DATA@keggdata@id$module <- which(V(keggdata.graph)$com == 2)
        names(F.DATA@keggdata@id$module) <- 
            (V(keggdata.graph)$name)[F.DATA@keggdata@id$module]
        F.DATA@keggdata@id$enzyme <- which(V(keggdata.graph)$com == 3)
        names(F.DATA@keggdata@id$enzyme) <- 
            (V(keggdata.graph)$name)[F.DATA@keggdata@id$enzyme]
        F.DATA@keggdata@id$reaction <- which(V(keggdata.graph)$com == 4)
        names(F.DATA@keggdata@id$reaction) <- 
            (V(keggdata.graph)$name)[F.DATA@keggdata@id$reaction]
        F.DATA@keggdata@id$compound <- which(V(keggdata.graph)$com == 5)
        names(F.DATA@keggdata@id$compound) <- 
            (V(keggdata.graph)$name)[F.DATA@keggdata@id$compound]
    } else {
        stop(
            "'keggdata.graph.RData' not present in:", 
            paste0(path, "keggdata.graph.RData"), 
            ". Please check that KEGG data is available.")
    }
    message("Done.")
    
    # Load matrix for hypergeometric test
    message("Loading hypergeom data...")
    message("Loading matrix...")
    if (file.exists(paste0(path, "hypergeom.matrix.RData"))) {
        load(paste0(path, "hypergeom.matrix.RData"))
        hypergeom.matrix <- get("hypergeom.matrix")
        
        F.DATA@hypergeom@matrix <- hypergeom.matrix
    } else {
        message(
            "'hypergeom.matrix.RData' not present in:", 
            paste0(path, "hypergeom.matrix.RData"), 
            ". Hypergeometric test won't execute.")
    }
    message("Done.")
    
    # Load matrix for diffusion 
    message("Loading diffusion data...")
    message("Loading matrix...")
    if ("diffusion" %in% loadMatrix) {
        if (!file.exists(paste0(path, "diffusion.matrix.RData"))) {
            message(
                "'diffusion.matrix.RData' not present in:", 
                paste0(path, "diffusion.matrix.RData"), 
                ". Simulated permutations may execute slower for diffusion.")
        } else {
            load(paste0(path, "diffusion.matrix.RData"))
            diffusion.matrix <- get("diffusion.matrix")
            
            F.DATA@diffusion@matrix <- diffusion.matrix
        }
        
    } else {
        message(
            "'diffusion.matrix.RData' not loaded. ", 
            "Simulated permutations may execute slower for diffusion.")
    }
    message("Done.")
    
    # Load diffusion rowsums for z-score calculation 
    message("Loading rowSums...")
    if (file.exists(paste0(path, "diffusion.rowSums.RData")) ) {
        load(paste0(path, "diffusion.rowSums.RData"))
        diffusion.rowSums <- get("diffusion.rowSums")
        diffusion.squaredRowSums <- get("diffusion.squaredRowSums")
        
        F.DATA@diffusion@rowSums <- diffusion.rowSums
        F.DATA@diffusion@squaredRowSums <- diffusion.squaredRowSums
    } else {
        message(
            "'diffusion.rowSums.RData' not present in:", 
            paste0(path, "diffusion.rowSums.RData"), 
            ". Z-scores won't be available for diffusion.")
    }
    message("Done.")
    
    # Load matrix for pagerank
    message("Loading pagerank data...")
    message("Loading matrix...")
    if ("pagerank" %in% loadMatrix) {
        if (!file.exists(paste0(path, "pagerank.matrix.RData"))) {
            message(
                "'pagerank.matrix.RData' not present in:", 
                paste0(path, "pagerank.matrix.RData"), 
                ". Simulated permutations may execute slower for pagerank.")
        } else {
            load(paste0(path, "pagerank.matrix.RData"))
            pagerank.matrix <- get("pagerank.matrix")
            
            F.DATA@pagerank@matrix <- pagerank.matrix
        }
        
    } else {
        message(
            "'pagerank.matrix.RData' not loaded. ", 
            "Simulated permutations may execute slower for pagerank.")  
    }
    message("Done.")
    
    # Load pagerank rowsums for z-score calculation
    message("Loading rowSums...")
    if (file.exists(paste0(path, "pagerank.rowSums.RData")) ) {
        load(paste0(path, "pagerank.rowSums.RData"))
        pagerank.rowSums <- get("pagerank.rowSums")
        pagerank.squaredRowSums <- get("pagerank.squaredRowSums")
        
        F.DATA@pagerank@rowSums <- pagerank.rowSums
        F.DATA@pagerank@squaredRowSums <- pagerank.squaredRowSums
    } else {
        message(
            "'pagerank.rowSums.RData' not present in:", 
            paste0(path, "pagerank.rowSums.RData"), 
            ". Z-scores won't be available for pagerank.") 
    }
    message("Done.")
    
    F.DATA@keggdata@status <- "loaded"
    
    message("Data successfully loaded.")
    return(F.DATA)
}

#' ID sanitiser function
#' 
#' Sanitise KEGG identifiers
#'
#' @param x Character vector, IDs to sanitise
#' @param category Character, one of: 
#' \code{"pathway"}, \code{"module"}, \code{"enzyme"}, 
#' \code{"ncbi"}, \code{"reaction"}, \code{"compound"}
#'
#' @return Character vector, sanitised \code{x}
#' 
#' @examples 
#' FELLA:::sanitise(c("path:hsa00010", "path:hsa00020"), "pathway", "hsa")
#' 
#' @keywords internal
sanitise <- function(x, category, organism) {
    old.attr <- attributes(x)
    if (category == "pathway") {
        ans <- gsub("(path:)(.+)(\\d{5})", paste0(organism, "\\3"), x)
    }
    if (category == "module") {
        ans <- gsub("(md:)(.*)(M\\d{5})", "\\3", x)
    }
    if (category == "enzyme") {
        ans <- ifelse(
            grepl(pattern = "-", x = x),  
            NA, 
            gsub("(ec:)(\\d+\\.\\d+\\.\\d+\\.\\d+)", "\\2", x))
    }
    if (category == "ncbi") {
        ans <- gsub("(ncbi.+:)(.*\\d+)", "\\2", x)
    }
    if (category == "reaction") {
        ans <- gsub("(rn:)(R\\d{5})", "\\2", x)
    }
    if (category == "compound") {
        ans <- gsub("(cpd:)(C\\d{5})", "\\2", x)
    }
    
    attributes(ans) <- old.attr
    ans
}

#' Infer connections to EC 
#' 
#' Function \code{infere.con2ec} infers network connections to KEGG EC 
#' families by passing through genes. This assumes that the category being 
#' mapped to enzymes is above them.
#'
#' @param ids Character vector of identifiers to map. For example, 
#' all the KEGG pathways
#' @param ent Character, entity that we are mapping 
#' (one of \code{"pathway"} and one of \code{"module"})
#' @param ent2gene Named character vector, names are the entity \code{ent} 
#' and values are genes
#' @param gene2enyzme Named character vector, names are genes and 
#' values are EC enzyme families
#' category Character, one of: 
#'
#' @return Two-column data frame. Column \code{"from"} contains the 
#' KEGG enzyme families whereas \code{"to"} contains the entity \code{ent}.
#' 
#' @examples 
#' ids <- "hsa00010"
#' ent <- "pathway"
#' ent2gene <- c("hsa00010" = "hsa:10", "hsa00010" = "hsa:120")
#' gene2enzyme <- c("hsa:10" = "1.1.1.1", "hsa:120" = "1.2.3.4")
#' FELLA:::infere.con2ec(ids, ent, ent2gene, gene2enzyme)
#' 
#' @keywords internal
infere.con2ec <- function(ids, ent, ent2gene, gene2enzyme) {
    ans <- plyr::ldply(
        ids, 
        function(x) {
            aux <- ent2gene[names(ent2gene) == x]
            ans <- unique(gene2enzyme[names(gene2enzyme) %in% aux])
            # names(ans) <- rep(x, length(ans))
            data.frame(from = ans, to = rep(x, length(ans)))
        }) 
    
    attr(ans, "from") <- "enzyme"
    attr(ans, "to") <- ent
    ans
} 

#' Extract largest CC
#' 
#' Function \code{largestcc} extracts the 
#' largest connected component of an igraph object
#'
#' @param graph Igraph object
#' 
#' @return Connected igraph object
#' 
#' @examples 
#' library(igraph)
#' g <- barabasi.game(10) + graph.empty(10)
#' FELLA:::largestcc(g)
#' 
#' @keywords internal
largestcc <- function(graph) {
    cl <- clusters(graph)
    x <- which.max(cl$csize)
    induced.subgraph(graph, which(cl$membership == x))
}


#' @title Parse, build and load the KEGG knowledge model
#' 
#' @description 
#' Function \code{buildGraphFromKEGGREST} makes use of the KEGG 
#' REST API (requires internet connection) 
#' to build and return the curated KEGG graph. 
#' 
#' @details
#' In function \code{buildGraphFromKEGGREST}, 
#' The user specifies (i) an organism, and (ii) patterns matching 
#' pathways that should not be included as nodes. 
#' A graph object, as described in [Picart-Armada, 2017], 
#' is built from the comprehensive 
#' KEGG database [Kanehisa, 2017]. 
#' As described in the main vignette, accessible through 
#' \code{browseVignettes("FELLA")}, this graph has five levels that 
#' represent categories of KEGG nodes. 
#' From top to bottom: pathways, modules, enzymes, reactions and compounds.
#' This knowledge representation is resemblant to the one formerly 
#' used by MetScape [Karnovsky, 2011], in which enzymes connect 
#' to genes instead of modules and pathways.
#' The necessary KEGG annotations 
#' are retrieved through KEGGREST R package [Tenenbaum, 2013]. 
#' Connections between pathways/modules and enzymes are inferred through 
#' organism-specific genes, i.e. an edge is added if a gene 
#' connects both entries. 
#' However, in order to enrich metabolomics data, the user has to 
#' pass the graph object to \code{buildDataFromGraph}  
#' to obtain the \code{\link{FELLA.USER}} object. 
#' All the networks are handled with the igraph R package [Csardi, 2006].
#' 
#' 
#' @param organism Character, KEGG code for the organism of interest
#' @param filter.path Character vector, pathways to filter. 
#' This is a pattern matched using regexp. 
#' E.g: \code{"01100"} to filter 
#' the overview metabolic pathway in any species
#' 
#' @return \code{buildGraphFromKEGGREST} returns the 
#' curated KEGG graph (class \pkg{igraph})
#' 
#' @name data-funs
#' @rdname data-funs
#' 
#' @import igraph
#' @import Matrix
#' @import KEGGREST
#' @import plyr
#' @export
buildGraphFromKEGGREST <- function(
    organism = "hsa",  
    filter.path = NULL) {
    
    categories <- listCategories()
    
    # Data from KEGGREST
    # 
    # List of id-name
    message("Building through KEGGREST...")
    
    info.org <- KEGGREST::keggInfo(organism)
    info.geneannot <- grep(
        "ncbi-[[:lower:]]+", 
        capture.output(cat(info.org)), 
        value = TRUE)
    info.geneannot <- gsub("[[:space:]]", "", info.geneannot)
    cat.geneannot <- head(
        intersect(c("ncbi-geneid", "ncbi-proteinid"), info.geneannot), 
        1
    )
    if (length(cat.geneannot) == 0) 
        stop(
            "Organism ", organism, " does not appear to have either ", 
            "ncbi-geneid or ncbi-proteinid. Please contact ", 
            "FELLA's maintainer.")
    message(
        "Available gene annotations: ", 
        paste(info.geneannot, collapse = ", "), 
        ". Using ", cat.geneannot)
    
    list.list <- plyr::llply(
        stats::setNames(categories, categories), 
        function(category) {
            # only pathways are organism-specific now
            # modules are filtered through genes
            if (category %in% c("pathway")) {
                ans <- KEGGREST::keggList(
                    database = category, 
                    organism = organism)
            } else {
                ans <- KEGGREST::keggList(database = category)
            }
            names(ans) <- sanitise(names(ans), category, organism)
            
            ans
        }, 
        .progress = "text"
    )
    
    # Map identifiers to category 
    map.category <- plyr::ldply(
        list.list, 
        function(categ) 
            data.frame(id = names(categ), stringsAsFactors = FALSE), 
        .id = "category") 
    map.category <- stats::setNames(
        as.character(map.category$category), 
        map.category$id)
    
    # List of kegg links - essentially our edges
    list.link <- plyr::alply(
        expand.grid(
            categories, 
            categories, 
            KEEP.OUT.ATTRS = FALSE, 
            stringsAsFactors = FALSE)[lower.tri(
                matrix(seq_len(25), nrow = 5)), ], 
        1, 
        function(row) {
            original <- KEGGREST::keggLink(row[1], row[2])
            df <- data.frame(
                from = sanitise(original, row[1], organism), 
                to = sanitise(names(original), row[2], organism))
            attr(df, "from") <- as.character(row[1])
            attr(df, "to") <- as.character(row[2])
            
            df
        }, 
        .progress = "text"
    )
    attributes(list.link) <- NULL
    
    # To mine mapping through enzymes
    m.path_gene <- KEGGREST::keggLink(organism, "pathway") %>% 
        stats::setNames(., sanitise(names(.), "pathway", organism))
    m.mod_gene <- KEGGREST::keggLink(organism, "module") %>% 
        stats::setNames(., sanitise(names(.), "module", organism))
    
    # Gene to enzyme
    m.gene_enzyme <- KEGGREST::keggLink("enzyme", organism) %>% 
        sanitise(., "enzyme", organism)
    
    # Enzyme to gene, but giving the entrez id rather than KEGG's
    
    # Map kegg to entrez
    keggGene2entrez <- KEGGREST::keggConv(cat.geneannot, organism) %>% 
        sanitise(., category = "ncbi") %>%  
        split(., names(.))
    # Map kegg enzymes to entrez
    m.enzyme_gene <- KEGGREST::keggLink(organism, "enzyme") %>% 
        stats::setNames(., sanitise(names(.), "enzyme", organism)) %>%
        # sanitise(., "gene", organism) %>% 
        split(., names(.), drop = TRUE) %>%
        plyr::llply(
            ., function(r) sort(as.character(unique(keggGene2entrez[r]))))
    
    # Inferred connections (through genes)
    con.infere <- list(
        infere.con2ec(
            names(list.list$pathway), 
            "pathway", 
            m.path_gene, 
            m.gene_enzyme),
        
        infere.con2ec(
            names(list.list$module), 
            "module", 
            m.mod_gene, 
            m.gene_enzyme)
    )
    
    # Direct connections
    df.noinfere <- plyr::ldply(
        list.link, 
        function(df.piece) {
            a.from <- attr(df.piece, "from")
            a.to <- attr(df.piece, "to")
            
            if (a.from == "enzyme" & (a.to %in% c("module", "pathway"))) 
                return(NULL)
            
            return(df.piece)
        }, 
        .id = NULL
    )
    
    df.infere <- plyr::ldply(
        con.infere, 
        function(df.piece) {
            a.from <- attr(df.piece, "from")
            a.to <- attr(df.piece, "to")
            
            return(df.piece)
        } 
    )
    
    matrix.adjacency <- as.matrix(rbind(
        df.noinfere, 
        df.infere
    ))
    
    message("Done.")
    
    message("Building graph...")
    g.raw <- igraph::simplify(
        graph.edgelist(matrix.adjacency, directed = TRUE)
    ) 
    
    V(g.raw)$com <- match(map.category[V(g.raw)$name], categories) 
    
    # Nodes without a kegg name are either obsolete or inexistent
    g.raw <- delete.vertices(
        g.raw, 
        which(is.na(V(g.raw)$com)))
    
    # Enzymes that cannot be inferred should be deleted 
    # (not found in desired species!)
    g.raw <- delete.vertices(
        g.raw, 
        which((V(g.raw)$com == 3) & !(V(g.raw)$name %in% df.infere$from)))
    
    # Same for the modules that do no belong to the species
    # Keep only those that have at least one gene associated 
    # 
    # Alternative: keggLink("genome", "compound") and pick only 
    # those of the organism code
    # The downside is that it takes around 90s, but might be 
    # a safer option
    # Checked in 19/10/2019 and both approaches are equivalent
    org.modules <- unique(names(m.mod_gene))
    g.raw <- delete.vertices(
        g.raw, 
        which((V(g.raw)$com == 2) & !(V(g.raw)$name %in% org.modules)))
    
    # Order by category and id
    g.raw <- permute.vertices(
        g.raw, 
        order(order(V(g.raw)$com, V(g.raw)$name)))
    
    # Weighting the edges
    tmp <- get.edges(g.raw, E(g.raw))
    E(g.raw)$weight <- abs(V(g.raw)$com[tmp[, 1]] - V(g.raw)$com[tmp[, 2]])
    
    # Keep only reactions in a pathway
    # i.e. delete reactions that don't have any 3-weight edge
    g.raw <- (setdiff(
        which(V(g.raw)$com == 4), 
        get.edges(g.raw, E(g.raw)[E(g.raw)$weight == 3])[, 1]) %>%
            delete.vertices(graph = g.raw, .))
    
    # Keep only compounds that are reactants/products in these reactions
    # i.e. delete compounds that don't have any 1-weight edge
    g.raw <- (setdiff(
        which(V(g.raw)$com == 5), 
        get.edges(g.raw, E(g.raw)[E(g.raw)$weight == 1])[, 1]) %>%
            delete.vertices(graph = g.raw, .)) 
    
    # Other filtering (remove nodes?)
    if (!is.null(filter.path)) {
        names.path <- V(g.raw)[V(g.raw)$com == 1]$name
        filter.out <- lapply(
            filter.path, 
            function(p) {
                which(grepl(p, names.path))
            })
        names.out <- names.path[unique(unlist(filter.out))]
        message(paste0("Filtering ", length(names.out), " pathways."))
        g.raw <- delete.vertices(g.raw, names.out)
    }
    
    g.raw <- largestcc(g.raw)
    
    message("Done.")
    
    message("Pruning graph...")
    # CURATE GRAPH
    # We start with the graph curation
    edges.split <- split(seq_len(ecount(g.raw)), E(g.raw)$weight)
    
    message(paste0("Current weight: 1 out of 4..."))
    g.curated <- subgraph.edges(
        graph = g.raw, 
        eids = edges.split[[1]], 
        delete.vertices = FALSE)
    
    for (w in names(edges.split)[-1]) {
        current.w <- as.numeric(w)
        message(paste0("Current weight: ", w, " out of 4..."))
        
        dist.matrix <- distances(g.curated, mode = "out")
        list.edges <- edges.split[[w]]
        
        list.ends <- ends(g.raw, list.edges)
        new.edges <- dist.matrix[list.ends] > E(g.raw)$weight[list.edges]
        
        g.curated <- add.edges(
            graph = g.curated, 
            edges = t(list.ends[new.edges, ]), 
            attr = list(weight = E(g.raw)[list.edges[new.edges]]$weight))
    }
    
    # Final edge weights have to be inverted
    E(g.curated)$weight <- 1/E(g.curated)$weight
    
    tmp <- list.list
    names(tmp) <- NULL
    tmp <- unlist(tmp)
    
    # Tried sorting according to number of characters 
    # (take shortest names). This is weird, as some names 
    # are not very known. I will leave the original order
    V(g.curated)$NAME <- strsplit(tmp[V(g.curated)$name], split = "; ")
    V(g.curated)$entrez <- m.enzyme_gene[V(g.curated)$name]
    
    comment(g.curated) <- info.org
    g.curated$organism <- organism
    
    message("Done.")
    
    keggdata.graph <- g.curated
    
    return(keggdata.graph)
}

#' @include generateResultsTable.R
#' 
#' @description 
#' In general, \code{generateResultsTable}, \code{generateEnzymesTable} 
#' and \code{generateResultsGraph} provide the results of an enrichment 
#' in several formats. 
#' 
#' Function \code{generateResultsTable} returns a table 
#' that contains the best hits from
#' a \code{\link{FELLA.USER}} object 
#' with a successful enrichment analysis.
#' Similarly, \code{generateEnzymesTable} returns 
#' a data frame with the best scoring enzyme families and their 
#' annotated genes.
#' 
#' @details 
#' Functions \code{generateResultsTable} and 
#' \code{generateEnzymesTable} need a 
#' \code{\link{FELLA.DATA}} object and a 
#' \code{\link{FELLA.USER}} object with a successful enrichment.
#' \code{generateResultsTable} provides the entries 
#' whose p-score is below the chosen \code{threshold} in a tabular format. 
#' \code{generateEnzymesTable} returns a table 
#' that contains (1) the enzymes that are below the user-defined 
#' p-score threshold, along with (2) the genes that belong to 
#' the enzymatic families in the organism defined in the database, 
#' and (3) GO labels of such enzymes, if \code{mart.options} is 
#' not \code{NULL} and points to the right database.
#' 
#' @inheritParams .params
#' @param method one in \code{"diffusion"}, \code{"pagerank"}
#'
#' @return \code{generateEnzymesTable} returns a 
#' data.frame that contains the enzymes below the \code{p.score} threshold,
#' along with their genes and GO labels
#' 
#' @rdname export-funs
#' 
#' @import igraph
#' @export
generateEnzymesTable <- function(
    method = "diffusion", 
    threshold = 0.05, 
    nlimit = 250, 
    LabelLengthAtPlot = 45, 
    capPscores = 1e-6, 
    mart.options = list(
        biomart = "ensembl", dataset = "hsapiens_gene_ensembl"),
    object = NULL, 
    data = NULL, 
    ...) {
    
    checkArgs <- checkArguments(
        method = method, 
        threshold = threshold, 
        nlimit = nlimit, 
        LabelLengthAtPlot = LabelLengthAtPlot, 
        object = object, 
        data = data)
    if (!checkArgs$valid)
        stop("Bad argument when calling function 'generateEnzymesGraph'.")
    
    if (getStatus(data) != "loaded"){
        stop("'data' points to an empty FELLA.DATA object")
    }
    
    if (!(method %in% c("diffusion", "pagerank"))) {
        warning(
            "Method should be one of: 'diffusion', 'pagerank'", 
            " but it is ", method, ". Returning NULL...")
        return(NULL)
    }
    if (is.na(getValid(object, method)) | !getValid(object, method)) {
        warning(
            "Mehod ", method, " has not been executed yet. ",  
            "Returning NULL...")
        return(invisible())
    } 
    
    message("Writing ", method, " enzymes...")
    
    id.ec <- getCom(data, level = 3, format = "id")
    pscores.ec <- sort(getPscores(object, method)[id.ec])
    pscores.ec[pscores.ec < capPscores] <- capPscores
    
    if (pscores.ec[1] >= threshold) {
        message("No enzyme is below the p-score threshold.")
        return(NULL)
    } 
    nodePscores <- head(pscores.ec[pscores.ec < threshold], nlimit)
    
    nodeIds <- names(nodePscores)
    nodeNames <- vapply(
        getName(data, id = nodeIds), 
        function(id) {
            ans <- id[1]
            if (is.null(ans)) return(NULL)
            
            if (nchar(ans) > LabelLengthAtPlot) 
                ans <- paste0(substr(ans, 1, LabelLengthAtPlot), "...")
            return(ans)
        }, 
        FUN.VALUE = character(1))
    
    g <- getGraph(data)
    nodeGenes <- vapply(
        V(g)[nodeIds]$entrez, 
        function(genes) paste(genes, collapse = ";"), 
        FUN.VALUE = character(1)
    )

    out.df <- data.frame(
        "EC_number" = nodeIds,
        "p.score" = nodePscores, 
        "EC_name" = nodeNames, 
        "Genes" = nodeGenes, 
        stringsAsFactors = FALSE)
    rownames(out.df) <- NULL
    
    if (!is.null(mart.options)) {
        g <- addGOToGraph(
            graph = g, GOterm = NULL, mart.options = mart.options)
        nodeGO <- vapply(
            V(g)[nodeIds]$GO, 
            function(goterms) paste(goterms, collapse = ";"), 
            FUN.VALUE = character(1)
        )
        out.df$GO_id <- nodeGO
    }
    
    message("Done.")
    
    return(out.df)
}

#' @include exportResults.R
#' 
#' @details
#' Function \code{addGOToGraph} takes and returns 
#' a graph object with class 
#' \pkg{igraph} 
#' adding the following attributes: 
#' GO labels in \code{V(graph)$GO}, and 
#' semantic similarities in \code{V(graph)$GO.simil} if 
#' \code{GOterm != NULL}. 
#' 
#' The GO database describes genes in terms of three ontologies: 
#' molecular function (MF), biological process (BP) and 
#' cellular component (CC) [Gene Ontology Consortium, 2015].
#' The user can be interested in finding which enzymatic families 
#' reported with a low \code{p.score}
#' are closest to a particular GO term. 
#' To assess similarity between GO labels, FELLA uses the 
#' semantic similarity defined in [Yu, 2010] and their implementation 
#' in the \pkg{GOSemSim} R package. 
#' The user will obtain, for each enzymatic family, the closest GO 
#' term to his or her GO query and the semantic similarity between them. 
#' Exact matches have a similarity of \code{1}. 
#' Function \code{plotGraph} detects the presence 
#' of the GO similarity option and plots its magnitude.
#' 
#' 
#' @inheritParams .params
#'
#' @return \code{addGOToGraph} returns 
#' an \pkg{igraph} object, 
#' which is the input \code{graph} with 
#' extra attributes: GO labels in \code{V(graph)$GO}, and 
#' semantic similarities in \code{V(graph)$GO.simil} if 
#' \code{GOterm != NULL}
#' 
#' @rdname export-funs
#' 
#' @import igraph
#' @import plyr
#' @export
addGOToGraph <- function(
    graph = NULL, 
    GOterm = NULL, 
    godata.options = list(
        OrgDb = "org.Hs.eg.db", ont = "CC"),
    mart.options = list(
        biomart = "ensembl", dataset = "hsapiens_gene_ensembl")) {
    
    # check if biomaRt is available
    if (!requireNamespace("biomaRt", quietly = TRUE)) {
        stop(
            "Package biomaRt must be installed to add GO labels", 
            call. = FALSE)
    }
    
    if (!is.igraph(graph)) {
        warning("'graph' is not an igraph object. Leaving it as it was...")
        return(graph)
    }
    
    if (vcount(graph) == 0) return(graph)
    
    # First: map entrez genes to GO terms
    # All entrez ids:
    entrez.all <- unique(unlist(V(graph)$entrez))
    
    # Map them
    mart.go <- do.call(biomaRt::useMart, mart.options)
    df.entrez2go <- biomaRt::getBM(
        attributes = c('entrezgene_id', 'go_id'), 
        filters = 'entrezgene_id', 
        values = entrez.all, 
        mart = mart.go)
    list.entrez2go <- plyr::dlply(
        df.entrez2go, 
        "entrezgene_id", 
        function(df) grep("GO:\\d+", df$go_id, value = TRUE)
    )
    # Add GO terms to graph
    V(graph)$GO <- plyr::llply(
        V(graph)$entrez, 
        function(x) {
            if (!is.null(x)) {
                unique(unlist(list.entrez2go[as.character(x)]))
            }
        }
    )
    
    if (is.null(GOterm)) {
        message(
            "Null GOterm provided to addGOToGraph. ", 
            "Only the GO labels will be added. ",
            "To include similarity values as well, please specify a GOterm")
        return(graph)
    }
    
    
    # Second: add similarity to desired term
    # 
    # Check that GOSemSim is available
    if (!requireNamespace("GOSemSim", quietly = TRUE)) {
        stop(
            "Package GOSemSim must be installed to add GO semantic similarity", 
            call. = FALSE)
    }
    
    semData <- do.call(GOSemSim::godata, godata.options)
    # This outputs a list to keep the names of the best GO hit
    go.simil <- lapply(V(graph)$GO, FUN = function(entrez) {
        if (!is.null(entrez)) {
            # This is a row vector
            val <- GOSemSim::mgoSim(
                GOterm, entrez, semData = semData, combine = NULL
            )[1, ]
            return(val[which.max(val)])
        } else {
            return(NA)
        }
    })
    
    V(graph)$GO.simil <- go.simil
    return(graph)
}

#' @include defineCompounds.R
#' 
#' @details
#' Function \code{runHypergeom} performs an over representation analysis 
#' through the hypergeometric test [Fisher, 1935] on a 
#' \code{\link{FELLA.USER}} object with mapped metabolites 
#' and a \code{\link{FELLA.DATA}} object. 
#' If a custom background was specified, it will be used. 
#' This approach is included for completeness and it is not the 
#' main purpose behind the \code{\link{FELLA}} package. 
#' Importantly, \code{runHypergeom} is not a hypergeometric test using the 
#' original KEGG pathways. 
#' Instead, a compound "belongs" to a "pathway" if 
#' it can reach the original pathway in the 
#' upwards-directed KEGG graph. 
#' This is a way to evaluate enrichment including indirect connections 
#' to a pathway, e.g. through an enzymatic family. 
#' New "pathways" are expected to be larger than the original pathways
#' in this analysis and therefore the results can differ from the 
#' standard over representation.
#'
#' @inheritParams .params
#'
#' @return \code{runHypergeom} returns a 
#' \code{\link{FELLA.USER}} object 
#' updated with the hypergeometric test results
#' 
#' @rdname enrich-funs 
#' 
#' @importFrom stats phyper p.adjust
#' @import Matrix
#' @export
runHypergeom <- function(
    object = NULL, 
    data = NULL, 
    p.adjust = "fdr") {
    
    message("Running hypergeom...")
    
    # Checking the input
    ###############################
    if (!is.FELLA.USER(object)) {
        message(
            "'object' is not a FELLA.USER object. ", 
            "Returning NULL...")
        return(invisible())
    } 
    if (!is.FELLA.DATA(data)) {
        message(
            "'data' is not a FELLA.DATA object. ", 
            "Returning NULL...")
        return(invisible())
    }
    
    if (getStatus(data) != "loaded"){
        message(
            "'data' points to an empty FELLA.DATA object! ", 
            "Returning original 'object'...")
        return(object)
    }
    #############################
    
    message("Starting hypergeometric p-values calculation...")
    
    # The matrix
    if (prod(dim(getMatrix(data, "hypergeom"))) == 1) {
        message(
            "Hypergeometric test failed ", 
            "because its matrix is not loaded.")
        return(object)
    }
    hypergeom.matrix <- getMatrix(data, "hypergeom")
    metabolites.input <- getInput(object)
    metabolites.input.intersect <- intersect(
        metabolites.input, 
        rownames(hypergeom.matrix))
    metabolites.background.intersect <- intersect(
        getBackground(object), 
        rownames(hypergeom.matrix))
    
    # Metabolites in the input
    if (length(metabolites.input) == 0) {
        message(
            "Hypergeometric test failed because ", 
            "there are no compounds in the input.")
        return(object)
    } else if (length(metabolites.input.intersect) == 0) {
        message(
            "None of the compounds were in the ", 
            "hypergeometric test background.")
        return(object)
    } else if (
        length(metabolites.input.intersect) < length(metabolites.input)) {
        message(
            "Some of the compounds have been excluded ", 
            "as they are not in the hypergeometric test background.")
        message(
            "Amount decreased from ", length(metabolites.input), 
            " to ", length(metabolites.input.intersect))
        metabolites.input <- metabolites.input.intersect
    }
    
    # Background metabolites (if supplied) resize the matrix
    if (length(metabolites.background.intersect) > 0) {
        hypergeom.matrix <- hypergeom.matrix[
            metabolites.background.intersect, ]
    }
    #   hypergeom.matrix <- hypergeom.matrix[, colSums(hypergeom.matrix) > 0]
    row_comp <- which(rownames(hypergeom.matrix) %in% metabolites.input)
    
    pvalues.path <- vector("double", length = dim(hypergeom.matrix)[2])
    names(pvalues.path) <- colnames(hypergeom.matrix)
    
    # Additional variables for the report
    pathbackground <- pvalues.path
    pathhits <- pvalues.path
    
    # p-values calculation
    for (path in seq_len(ncol(hypergeom.matrix))) {
        sample_success <- sum(hypergeom.matrix[row_comp, path])
        pathhits[path] <- sample_success
        
        # sum over row or column (current)?
        total_success <- sum(hypergeom.matrix[, path])
        pathbackground[path] <- total_success
        
        total_failure <- dim(hypergeom.matrix)[1] - total_success
        sample_size <- length(row_comp)
        
        pvalues.path[path] <- stats::phyper(
            sample_success - 1, 
            total_success, 
            total_failure, 
            sample_size, 
            lower.tail = FALSE)
    }
    
    object@hypergeom@pvalues <- stats::p.adjust(pvalues.path, method = p.adjust)
    object@hypergeom@nbackground <- dim(hypergeom.matrix)[1]
    object@hypergeom@ninput <- length(metabolites.input.intersect)
    object@hypergeom@pathhits <- pathhits
    object@hypergeom@pathbackground <- pathbackground
    
    message("Done.")
    
    object@hypergeom@valid <- TRUE
    return(object)
}

#' @title Functions to map and enrich a list of metabolites
#' 
#' @description 
#' Functions \code{runHypergeom}, 
#' \code{runDiffusion} and \code{runPagerank} 
#' perform an enrichment on a \code{\link{FELLA.USER}} with 
#' the mapped input metabolites 
#' (through \code{defineCompounds}) 
#' and a \code{\link{FELLA.DATA}} object. 
#' They are based on the hypergeometric test, the heat diffusion model 
#' and the PageRank algorithm, respectively. 
#' 
#' Function \code{enrich} is a wrapper with 
#' the following order: 
#' \code{loadKEGGdata} (optional), 
#' \code{defineCompounds} and one or more in 
#' \code{runHypergeom}, \code{runDiffusion} 
#' and \code{runPagerank}
#' 
#' @template approxTemplate
#' 
#' @details
#' Finally, the function \code{enrich} 
#' is a wrapper to perform the enrichment analysis. 
#' If no \code{\link{FELLA.DATA}} object is supplied, 
#' it loads it, maps the affected compounds and performs 
#' the desired enrichment(s) with a single call.
#' Returned is a list with the loaded 
#' \code{\link{FELLA.DATA}} object 
#' and the results in a \code{\link{FELLA.USER}} object. 
#' Conversely, the user can supply the 
#' \code{\link{FELLA.DATA}} object and the wrapper 
#' will map the metabolites and run the desired enrichment 
#' method(s). 
#' In this case, only the \code{\link{FELLA.USER}} 
#' will be returned.
#'
#' @inheritParams .params
#' @param databaseDir Character, path to load the 
#' \code{\link{FELLA.DATA}} object if
#' it is not already passed through the argument \code{data}
#' @param internalDir Logical, is the directory located 
#' in the package directory?
#' @param ... Further arguments for the enrichment function(s) 
#' \code{runDiffusion}, \code{runPagerank}
#' 
#' @return \code{enrich} returns a 
#' \code{\link{FELLA.USER}} object 
#' updated with the desired enrichment results if 
#' the \code{\link{FELLA.DATA}} was supplied. 
#' Otherwise, a list with the freshly loaded  
#' \code{\link{FELLA.DATA}} object and the 
#' corresponding enrichment in the 
#' \code{\link{FELLA.USER}} object. 
#' 
#' @template refs_enrichment
#' @include runPagerank.R
#' 
#' @rdname enrich-funs 
#' 
#' @examples 
#' ## Load the internal database. 
#' ## This one is a toy example!
#' ## Do not use as a regular database
#' data(FELLA.sample)
#' ## Load a list of compounds to enrich
#' data(input.sample)
#' 
#' ######################
#' ## Example, step by step
#' 
#' ## First, map the compounds
#' obj <- defineCompounds(
#' compounds = c(input.sample, "I_dont_map", "me_neither"), 
#' data = FELLA.sample)
#' obj
#' ## See the mapped and unmapped compounds
#' getInput(obj)
#' getExcluded(obj)
#' ## Compounds are already mapped 
#' ## We can enrich using any method now
#' 
#' ## If no compounds are mapped an error is thrown. Example:
#' \dontrun{
#' data(FELLA.sample)
#' obj <- defineCompounds(
#' compounds = c("C00049", "C00050"), 
#' data = FELLA.sample)}
#' 
#' ## Enrich using hypergeometric test
#' obj <- runHypergeom(
#' object = obj, 
#' data = FELLA.sample)
#' obj
#' 
#' ## Enrich using diffusion
#' ## Note how the results are added;  
#' ## the hypergeometric results are not overwritten
#' obj <- runDiffusion(
#' object = obj, 
#' approx = "normality", 
#' data = FELLA.sample)
#' obj
#' 
#' ## Enrich using PageRank
#' ## Again, this does not overwrite other methods 
#' obj <- runPagerank(
#' object = obj, 
#' approx = "simulation", 
#' data = FELLA.sample)
#' obj
#' 
#' ######################
#' ## Example using the "enrich" wrapper
#' 
#' ## Only diffusion
#' obj.wrap <- enrich(
#' compounds = input.sample, 
#' method = "diffusion", 
#' data = FELLA.sample)
#' obj.wrap
#' 
#' ## All the methods
#' obj.wrap <- enrich(
#' compounds = input.sample, 
#' methods = FELLA::listMethods(), 
#' data = FELLA.sample)
#' obj.wrap
#' 
#' @export
enrich <- function(
    compounds = NULL, 
    compoundsBackground = NULL, 
    methods = listMethods(), 
    loadMatrix = "none", 
    approx = "normality", 
    t.df = 10, 
    niter = 1000, 
    databaseDir = NULL, 
    internalDir = TRUE,
    data = NULL, 
    ...) {
    
    # Check if data is loaded
    returnList <- FALSE
    if (!is.FELLA.DATA(data)) {
        message(
            "No data object supplied. ", 
            "Loading it from the 'databaseDir' argument...")
        returnList <- TRUE
        data <- loadKEGGdata(
            databaseDir = databaseDir, 
            internalDir = internalDir, 
            loadMatrix = loadMatrix)
    } 
    
    # Define custom metabolites
    object <- defineCompounds(
        compounds = compounds, 
        compoundsBackground = compoundsBackground, 
        data = data)
    
    
    # Run all the analyses
    if ("hypergeom" %in% methods) {
        object <- runHypergeom(object = object, data = data)
    }
    
    if ("diffusion" %in% methods) {
        object <- runDiffusion(
            object = object, 
            data = data, 
            approx = approx, 
            t.df = t.df, 
            niter = niter, 
            ...)
    }
    
    if ("pagerank" %in% methods) {
        object <- runPagerank(
            object = object, 
            data = data, 
            approx = approx, 
            t.df = t.df, 
            niter = niter, 
            ...)
    }
    
    if (returnList) {
        return(list(user = object, data = data))
    }
    
    return(object)
}

#' List of node categories
#' 
#' Node categories used in the internal representations
#'
#' @return Character vector
#' 
#' @examples 
#' listCategories()
#' 
#' @export
listCategories <- function() {
    c("pathway", "module", "enzyme", "reaction", "compound")
}

#' List of methods
#' 
#' Methods available for the analysis
#'
#' @return Character vector
#' 
#' @examples 
#' listMethods()
#' 
#' @export
listMethods <- function() {
    c("hypergeom", "diffusion", "pagerank")
}

#' List of approximations
#' 
#' Available approximations for the analysis
#'
#' @return Character vector
#' 
#' @examples 
#' listApprox()
#' 
#' @export
listApprox <- function() {
    c("simulation", "normality", "gamma", "t")
}

#' List internal databases
#' 
#' This function lists the directories in the local database path
#'
#' @param full.names Logical, should full paths be returned?
#'
#' @return Vector with database directories
#' 
#' @examples 
#' listInternalDatabases()
#' 
#' @export
listInternalDatabases <- function(full.names = FALSE) {
    dir.internal <- system.file("database", package = "FELLA")
    
    if (dir.internal == "") {
        message("No local databases have been built yet.")
        return(NULL)
    }
    
    list.dirs(dir.internal, full.names = full.names, recursive = FALSE)
}

#' \code{"show"} is an S4 method to show a FELLA.DATA object
#'
#' @param object A \code{\link[FELLA]{FELLA.DATA}} object
#' 
#' @return \code{show} returns \code{invisible()}
#' 
#' @rdname FELLA.DATA
#' @import igraph
#' @exportMethod show
setMethod("show", signature = "FELLA.DATA", function(object) {
    breakline <- "\n-----------------------------\n"
    
    cat("General data:\n")
    g <- getGraph(object)
    if (vcount(g) == 0) {
        cat("- KEGG graph not loaded.\n")
    } else {
        cat("- KEGG graph:\n")
        # To keep the original order, subset it
        tab.com <- table(listCategories()[V(g)$com])[listCategories()]
        tab.show <- paste0("    + ", names(tab.com), " [", tab.com, "]")
        cat("  * Nodes: ", vcount(g), "\n")
        cat("  * Edges: ", ecount(g), "\n")
        cat("  * Density: ", graph.density(g), "\n")
        cat("  * Categories:\n")
        cat(tab.show, sep = "\n")
        cat("  * Size: ", format(utils::object.size(g), "auto"), "\n")
    }
    if (length(object@keggdata@id2name) == 0) {
        cat("- KEGG names not loaded.")
    } else {
        cat("- KEGG names are ready.")
    }
    
    cat(breakline)
    
    cat("Hypergeometric test:\n")
    mat <- getMatrix(object, "hypergeom")
    if (prod(dim(mat)) == 1) {
        cat("- Matrix not loaded.")
    } else {
        cat("- Matrix is ready\n")
        cat("  * Dim: ", nrow(mat), "x", ncol(mat), "\n")
        cat("  * Size: ", format(utils::object.size(mat), "auto"))
    }
    
    cat(breakline)
    
    cat("Heat diffusion:\n")
    mat <- getMatrix(object, "diffusion")
    if (prod(dim(mat)) == 1) {
        cat("- Matrix not loaded.\n")
    } else {
        cat("- Matrix is ready\n")
        cat("  * Dim: ", nrow(mat), "x", ncol(mat), "\n")
        cat("  * Size: ", format(utils::object.size(mat), "auto"), "\n")
    }
    if (length(getSums(object, "diffusion", squared = FALSE)) == 0 || 
        length(getSums(object, "diffusion", squared = TRUE)) == 0) {
        cat("- RowSums not loaded.")
    } else {
        cat("- RowSums are ready.")
    }
    
    cat(breakline)
    
    cat("PageRank:\n")
    mat <- getMatrix(object, "pagerank")
    if (prod(dim(mat)) == 1) {
        cat("- Matrix not loaded.\n")
    } else {
        cat("- Matrix is ready\n")
        cat("  * Dim: ", nrow(mat), "x", ncol(mat), "\n")
        cat("  * Size: ", format(utils::object.size(mat), "auto"), "\n")
    }
    if (length(getSums(object, "pagerank", squared = FALSE)) == 0 || 
        length(getSums(object, "pagerank", squared = TRUE)) == 0) {
        cat("- RowSums not loaded.\n")
    } else {
        cat("- RowSums are ready.\n")
    }
    
    invisible()
})

#' \code{"show"} is an S4 method to show a FELLA.USER object
#' 
#' Assigning the value of show to a variable will provide
#' small data frames with the best scoring pathways (\code{hypergeom})
#' and the best nodes in the KEGG network (\code{diffusion} and 
#' \code{pagerank})
#'
#' @param object A \code{\link{FELLA.USER}} object
#' 
#' @return \code{show} invisibly returns a list of data frames with the 
#' best hits for each applied method
#' 
#' @rdname FELLA.USER
#' @exportMethod show
setMethod("show", signature = "FELLA.USER", function(object) {
    breakline <- function() {
        cat(fill = TRUE)
        cat("-----------------------------", fill = TRUE)
    }
    
    cat("Compounds in the input: ")
    if (length(getInput(object)) == 0) {
        cat("empty", fill = TRUE)
    } else {
        cat(length(getInput(object)), fill = TRUE)
        print(getInput(object))
    }
    if (length(getBackground(object)) == 0) {
        cat("Background compounds: all available compounds (default)")
    } else {
        cat("Background compounds:", length(getBackground(object)))
    }
    
    breakline()
    
    cat("Hypergeometric test: ")
    if (is.na(getValid(object, "hypergeom"))) cat("not performed")
    else if (!getValid(object, "hypergeom")) cat("error during execution")
    else {
        cat("ready.", fill = TRUE)
        n.show <- min(15, length(
            getPscores(object = object, method = "hypergeom")))
        cat("Top", n.show, "p-values:", fill = TRUE)
        print(head(sort(getPscores(object, "hypergeom")), n.show))
    }
    
    breakline()
    
    cat("Heat diffusion: ")
    if (is.na(getValid(object, "diffusion"))) cat("not performed")
    else if (!getValid(object, "diffusion")) cat("error during execution")
    else {
        cat("ready.", fill = TRUE)
        cat("P-scores under 0.05: ", 
            sum(getPscores(object, "diffusion") < 0.05))
    }
    
    breakline()
    
    cat("PageRank: ")
    if (is.na(getValid(object, "pagerank"))) cat("not performed")
    else if (!getValid(object, "pagerank")) cat("error during execution")
    else {
        cat("ready.", fill = TRUE)
        cat("P-scores under 0.05: ", 
            sum(getPscores(object, "pagerank") < 0.05))
    }
    
    # Return data frames
    ans <- lapply(
        stats::setNames(listMethods(), listMethods()), 
        function(method) {
            ans <- list()
            
            valid <- getValid(object, method)
            if (is.na(valid)) return("Not performed")
            if (!valid) return("Failed")
            
            if (method == "hypergeom") {
                # Data frame with top pathway hits
                pval <- getPscores(object, "hypergeom")
                p.values <- head(sort(pval), 30)
                
                data.frame(
                    "Description" = names(p.values), 
                    "p.value" = signif(p.values, digits = 4), 
                    row.names = NULL)
            } else {
                # Data frame with best diffusion scores
                out.pscores <- signif(
                    head(
                        sort(getPscores(object, method)), 
                        50), 
                    digits = 4)

                # Set an order (we do not use the kegg data 
                # as it only uses the FELLA.USER object...)
                out.names <- names(out.pscores)
                out.order <- order(out.names)
                
                out.pscores <- format(out.pscores[out.order])
                out.pscores[out.pscores < 1e-6] <- "<1e-6"
                
                df <- data.frame(
                    "KEGG id" = names(out.pscores), 
                    "p.score" = out.pscores, 
                    row.names = NULL)
                
                df
            }
        }
    )
    invisible(ans)
})

#' \code{"plot"} is an S4 method to plot the results 
#' from a FELLA.USER object
#'
#' @param x A \code{\link{FELLA.USER}} object
#' @inheritParams .params
#' @param ... Additional arguments passed to plotting functions
#' 
#' @return \code{plot} returns a layout if \code{layout = T}, 
#' otherwise \code{invisible()}
#' 
#' @rdname FELLA.USER
#' @exportMethod plot
setMethod(
    "plot", 
    signature(x = "FELLA.USER", y = "missing"), 
    function(
        x = new("FELLA.USER"), 
        method = "hypergeom", 
        threshold = 0.05, 
        plimit = 15, 
        nlimit = 250, 
        layout = FALSE, 
        thresholdConnectedComponent = 0.05, 
        LabelLengthAtPlot = 22, 
        data = NULL, 
        ...) {
        
        checkArgs <- checkArguments(
            method = method, 
            threshold = threshold, 
            plimit = plimit, 
            nlimit = nlimit, 
            layout = layout, 
            thresholdConnectedComponent = thresholdConnectedComponent, 
            LabelLengthAtPlot = LabelLengthAtPlot, 
            object = x, 
            data = data)
        if (!checkArgs$valid)
            stop("Bad argument when calling function 'plot' in FELLA.")
        
        if (getStatus(data) != "loaded"){
            stop("'data' points to an empty FELLA.DATA object")
        }
        
        valid <- getValid(x, method)
        if (is.na(valid) || !valid) {
            stop("Results from ", method, " are not ready yet.")
        } 
        
        if (method == "hypergeom") {
            graph.bipartite <- generateResultsGraph(
                method = method, 
                threshold = threshold, 
                plimit = plimit,
                object = x, 
                data = data)
            
            ans.return <- plotBipartite(
                graph = graph.bipartite, 
                layout = layout, 
                ...)

            return(invisible(ans.return))
            
        } else {
            # We have checked that "method" is in hypergeom, diffusion
            # and pagerank. Therefore, it's one of the last two
            # It has to be one graph
            graph <- generateResultsGraph(
                method = method, 
                threshold = threshold, 
                nlimit = nlimit,
                LabelLengthAtPlot = LabelLengthAtPlot, 
                object = x, 
                data = data)
            
            ans.return <- plotGraph(
                graph = graph, 
                layout = layout, 
                ...)
            
            return(invisible(ans.return))
        }
        return(invisible())
    })

---
title: "A fatty liver study on Mus musculus"
author: 
-   name: Sergio Picart-Armada 
    affiliation: B2SLab at Polytechnic University of Catalonia
    email: sergi.picart@upc.edu
-   name: Alexandre Perera-Lluna
    affiliation: B2SLab at Polytechnic University of Catalonia
    email: alexandre.perera@upc.edu
date: "September 17, 2018"
package: "`r BiocStyle::pkg_ver('FELLA')`"
output: BiocStyle::pdf_document
bibliography: bibliography_mouse.bib
vignette: >
    %\VignetteIndexEntry{Example: a fatty liver study on Mus musculus}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
---

# Introduction

This vignette shows the utility of the `FELLA` package, 
which is based in a statistically normalised 
diffusion process [@picart2017null], on 
non-human organisms.
In particular, we will work on a multi-omic _Mus musculus_ study. 
The original study [@gogiashvili2017metabolic] presents a mouse model of the 
non-alcoholic fatty liver disease (NAFLD).
Metabolites in liver tissue from leptin-deficient _ob/ob_ mice and 
wild type mice were compared using Nuclear Magnetic Resonance (NMR). 
Afterwards, quantitative real-time polymerase chain reaction (qRT-PCR) 
helped identify changes at the gene expression level. 
Finally, biological mechanisms behind NAFLD were elucidated by leveraging 
the data from both omics.

## Building the database

The first step is to build the `FELLA.DATA` object for the 
`mmu` organism from the KEGG database [@kanehisa2016kegg].

```{r, warning=FALSE, message=FALSE, results='hide'}
library(FELLA)
library(org.Mm.eg.db)
library(KEGGREST)

library(igraph)
library(magrittr)

set.seed(1)
# Filter overview pathways
graph <- buildGraphFromKEGGREST(
    organism = "mmu", 
    filter.path = c("01100", "01200", "01210", "01212", "01230"))

tmpdir <- paste0(tempdir(), "/my_database")
# Mke sure the database does not exist from a former vignette build
# Otherwise the vignette will rise an error 
# because FELLA will not overwrite an existing database
unlink(tmpdir, recursive = TRUE)  
buildDataFromGraph(
    keggdata.graph = graph, 
    databaseDir = tmpdir, 
    internalDir = FALSE, 
    matrices = "none", 
    normality = "diffusion", 
    niter = 100)
```


We load the `FELLA.DATA` object and two mappings 
(from gene symbol to entrez identifiers, and from enzyme EC numbers 
to their annotated entrez genes).

```{r, warning=FALSE, message=FALSE, results='hide'}
alias2entrez <- as.list(org.Mm.eg.db::org.Mm.egSYMBOL2EG)
entrez2ec <- KEGGREST::keggLink("enzyme", "mmu")
entrez2path <- KEGGREST::keggLink("pathway", "mmu")

fella.data <- loadKEGGdata(
    databaseDir = tmpdir, 
    internalDir = FALSE, 
    loadMatrix = "none"
)
```

Summary of the database:

```{r}
fella.data
```

In addition, we will store the ids of all the metabolites, 
reactions and enzymes in the database:

```{r}
id.cpd <- getCom(fella.data, level = 5, format = "id") %>% names
id.rx <- getCom(fella.data, level = 4, format = "id") %>% names
id.ec <- getCom(fella.data, level = 3, format = "id") %>% names
```

## Note on reproducibility

We want to emphasise that `FELLA` builds its `FELLA.DATA` object 
using the most recent version of the KEGG database. 
KEGG is frequently updated and therefore small changes can 
take place in the knowledge graph between different releases. 
The discussion on our findings was written at the date specified 
in the vignette header and using the KEGG release in the 
[Reproducibility](#reproducibility) section. 


# Enrichment analysis

## Defining the input and running the enrichment

_Table 2_ from the main body in [@gogiashvili2017metabolic] 
contains six metabolites that show 
significant changes between the experimental classes by a univariate test 
followed by multiple test correction. 
These are the start of our enrichment analysis:

```{r}
cpd.nafld <- c(
    "C00020", # AMP
    "C00719", # Betaine
    "C00114", # Choline
    "C00037", # Glycine
    "C00160", # Glycolate
    "C01104"  # Trimethylamine-N-oxide
)

analysis.nafld <- enrich(
    compounds = cpd.nafld, 
    data = fella.data, 
    method = "diffusion", 
    approx = "normality")
```

Five compounds are successfully mapped to the graph object:

```{r}
analysis.nafld %>% 
    getInput %>% 
    getName(data = fella.data)
```

Likewise, one compound does not map:

```{r}
getExcluded(analysis.nafld) 
```

The highlighted subgraph with the default parameters has the 
following appeareance, with large connected components that 
involve the metabolites in the input:

```{r, fig.width=8, fig.height=8}
plot(
    analysis.nafld, 
    method = "diffusion", 
    data = fella.data, 
    nlimit = 250,  
    plotLegend = FALSE)
```

We will also extract all the p-scores and the suggested sub-network 
for further analysis:

```{r}
g.nafld <-  generateResultsGraph(
    object = analysis.nafld, 
    data = fella.data, 
    method = "diffusion")

pscores.nafld <- getPscores(
    object = analysis.nafld, 
    method = "diffusion")
```

## Examining the metabolites

### From Table 2

The authors find 5 extra metabolites in _Table 2_ that 
are significant at $p < 0.05$ but
do not appear after thresholding the false discovery rate at 5%.
Such metabolites, highlighted in italics but without an asterisk,
are also relevant and play a role in their discussion. 
We will examine how `FELLA` prioritises such metabolites:

```{r}
cpd.nafld.suggestive <- c(
    "C00008", # ADP
    "C00791", # Creatinine
    "C00025", # Glutamate
    "C01026", # N,N-dimethylglycine
    "C00079", # Phenylalanine
    "C00299"  # Uridine
)
getName(cpd.nafld.suggestive, data = fella.data)
```

When checking if any of these metabolites are found in the reported 
sub-network, we find that `C01026` is already reported:

```{r}
V(g.nafld)$name %>% 
    intersect(cpd.nafld.suggestive) %>% 
    getName(data = fella.data)
```

Abbreviated as __DMG__ in their study, 
N,N-Dimethylglycine is a cornerstone of their findings. 
It is reported in Figure 6a as part of the folate-independent remethylation 
to explain the metabolic changes observed in the _ob/ob_ mice.
__DMG__ is also mentioned in the conclusions as part of one of 
the most prominent alterations found in the study: a reduced conversion of 
betaine to __DMG__.

### From Figure 6a

_Figure 6a_ contains the metabolic context of the observed 
alterations, with processes such as 
transsulfuration and folate-dependent remethylation. 
These were identified with the help of gene expression analysis. 
We will now check for coincidences between the metabolites in _Figure 6a_, 
excluding choline and betaine for being in the input and 
DMG since it was already discussed.

```{r}
cpd.new.fig6 <- c(
    "C00101", # THF
    "C00440", # 5-CH3-THF
    "C00143", # 5,10-CH3-THF
    "C00073", # Methionine
    "C00019", # SAM
    "C00021", # SAH
    "C00155", # Homocysteine
    "C02291", # Cystathione
    "C00097"  # Cysteine
)
getName(cpd.new.fig6, data = fella.data)
```

This time, there are no coincidences with the reported sub-network:

```{r}
cpd.new.fig6 %in% V(g.nafld)$name
```

However, we can further inquire whether the p-scores of such metabolites 
tend to be low among all the metabolites in the whole network 
from the `fella.data` object.

```{r}
wilcox.test(
    x = pscores.nafld[cpd.new.fig6], # metabolites from fig6
    y = pscores.nafld[setdiff(id.cpd, cpd.new.fig6)], # rest of metabolites
    alternative = "less")
```

The test is indeed significant -- despite `FELLA` does not directly 
report such metabolites, its metabolite ranking supports 
the claims by the authors.


## Examining the genes

### Cbs

The authors complement the metabolomic profilings with a differential 
gene expression study. 
One of the main findings is a change of _Cbs_ expression levels. 
To link _Cbs_ to the enrichment from `FELLA`, we will first map 
it to its EC number, _4.2.1.22_ at the time of writing:

```{r}
ec.cbs <- entrez2ec[[paste0("mmu:", alias2entrez[["Cbs"]])]] %>% 
    gsub(pattern = "ec:", replacement = "")

getName(fella.data, ec.cbs)
```

In _Figure 6a_, the reaction linked to _Cbs_ and catalysed by 
the enzyme _4.2.1.22_ has the KEGG identifier _R01290_.

```{r}
rx.cbs <- "R01290"

getName(fella.data, rx.cbs)
```

As shown in _Figure 6a_, _Cbs_ is not directly linked to the metabolites 
found through NMR, and nor the reaction neither the enzyme are suggested 
by `FELLA`:

```{r}
c(rx.cbs, ec.cbs) %in% V(g.nafld)$name
```

However, both of them have a relatively low p-score 
in their respective categories.
This can be seen through the proportion of enzymes (resp. reactions) 
that show a p-score as low or lower than _4.2.1.22_ (resp. _R01290_)

```{r}
# enzyme
pscores.nafld[ec.cbs]
mean(pscores.nafld[id.ec] <= pscores.nafld[ec.cbs])

# reaction
pscores.nafld[rx.cbs]
mean(pscores.nafld[id.rx] <= pscores.nafld[rx.cbs])
```

It's not surprising that none of them is directly reported, because none of 
the metabolites participating in the reaction is found in the input. 
The main evidence for finding _Cbs_ is gene expression, and our approach 
gives indirect hints of this connection.

### Bhmt

The alteration of _Bhmt_ activity is related to the downregulation of _Cbs_. 
Despite not finding evidence of change in _Bhmt_ expression, the authors 
argue that its inhibition would explain the increased 
betaine-to-DMG ratio in _ob/ob_ mice. 
Such claim is also backed up by prior studies.
To find out the role of _Cbs_ in our analysis, we will again map it to 
its EC number, _2.1.1.5_:

```{r}
ec.bhmt <- entrez2ec[[paste0("mmu:", alias2entrez[["Bhmt"]])]] %>% 
    gsub(pattern = "ec:", replacement = "")

getName(fella.data, ec.bhmt)
```

This time, `FELLA` not only reports it, but also its associated reaction 
_R02821_ (represented by an arrow in _Figure 6a_) and both of its metabolites.
While __betaine__ was already an input metabolite, 
__DMG__ was a novel finding as discussed earlier

```{r}
ec.bhmt %in% V(g.nafld)$name
"R02821" %in% V(g.nafld)$name
```

This illustrates how `FELLA` can translate knowledge from dysregulated 
metabolites to other molecular levels, such as reactions and enzymes.

### Slc22a5

The decrease of _Bhmt_ activity is later connected to the upregulation of 
_Slc22a5_, also proved within the original study. 
However, _Slc22a5_ does not map to any EC number and therefore 
it cannot be found through `FELLA`:

```{r}
entrez.slc22a5 <- alias2entrez[["Slc22a5"]]
entrez.slc22a5 %in% names(entrez2ec)
```

As a matter of fact, the only connection that can be found from KEGG is 
the role of _Slc22a5_ in the _Choline metabolism in cancer_ pathway.

```{r}
path.slc22a5 <- entrez2path[paste0("mmu:", entrez.slc22a5)] %>% 
    gsub(pattern = "path:", replacement = "")

getName(fella.data, path.slc22a5)
```

Coincidentally, this pathway is reported in the sub-graph:

```{r}
path.slc22a5 %in% V(g.nafld)$name
```

### Genes from Figure 3

We also examined if genes from _Table 3_ were reachable in our analysis. 
These five literature-derived genes were experimentally confirmed to show 
gene expression changes, in order to prove that RNA extracted after the 
metabolomic profiling was still reliable for further transcriptomic analyses. 
However, only _Scd2_ maps to an enzymatic family:


```{r}
symbol.fig3 <- c(
    "Cd36",
    "Scd2", 
    "Apoa4", 
    "Lcn2", 
    "Apom")

entrez.fig3 <- alias2entrez[symbol.fig3] %>% unlist %>% unique
ec.fig3 <- entrez2ec[paste0("mmu:", entrez.fig3)] %T>% 
    print %>%
    unlist %>% 
    unique %>% 
    na.omit %>% 
    gsub(pattern = "ec:", replacement = "")

getName(fella.data, ec.fig3)
```

Such family is not reported in our sub-graph

```{r}
ec.fig3 %in% V(g.nafld)$name
```

In addition, its p-score is high compared to other enzymes

```{r}
pscores.nafld[ec.fig3]
mean(pscores.nafld[id.ec] <= pscores.nafld[ec.fig3])
```

The fact that only one gene mapped to an EC number hinders the potential 
findings using `FELLA`, and is probably the main reason why `FELLA` missed 
_Scd2_.
In addition, `FELLA` defines a knowledge model that offers simplicity and 
interpretability, at the cost of introducing limitations on 
how sophisticated its findings can be.


### Genes from Table S2

In parallel with the original study, and cited within its main body, 
gene array expression data was collected [@godoy2016gene]
and its hits are included in the supplementary _Table S2_ from 
[@gogiashvili2017metabolic]. 
These genes include the already discussed _Cbs_.
We will attempt to link the genes marked as significantly changed to 
our reported sub-network. 
In contrast with _Figure 3_, all the genes map to an EC number: 

```{r}
symbol.tableS2 <- c(
    "Mat1a",
    "Ahcyl2", 
    "Cbs",
    "Mat2b",  
    "Mtr")
entrez.tableS2 <- alias2entrez[symbol.tableS2] %>% unlist %>% unique
ec.tableS2 <- entrez2ec[paste0("mmu:", entrez.tableS2)] %T>%
    print %>%
    unlist %>% 
    unique %>% 
    na.omit %>% 
    gsub(pattern = "ec:", replacement = "")
```

None of these EC families are reported in the sub-graph:

```{r}
ec.tableS2 %in% V(g.nafld)$name
```

But in this case, their scores tend to be lower than the rest of enzymes:

```{r}
wilcox.test(
    x = pscores.nafld[ec.tableS2], # enzymes from table S2
    y = pscores.nafld[setdiff(id.ec, ec.tableS2)], # rest of enzymes
    alternative = "less")
```

These findings suggest that if the annotation database is complete enough, 
`FELLA` can provide a meaningful priorisisation of the enzymes surrounding 
the affected metabolites.

# Conclusions

`FELLA` has been used to give a biological meaning to a list of 6 metabolites 
extracted from a multi-omic study of a mouse model of NAFLD. 
It has been able to reproduce some findings at the metabolite and 
gene expression levels, whereas most of the times missed entities would 
still present a low ranking compared to their background in the database.  
The bottom line from our analysis in the present vignette is that 
`FELLA` not only works on human studies, 
but also generalises to animal models. 


# Reproducibility

This is the result of running `sessionInfo()`

```{r}
sessionInfo()
```

KEGG version:

```{r}
cat(getInfo(fella.data))
```

Date of generation:

```{r}
date()
```

Image of the workspace (for submission):

```{r}
tempfile(pattern = "vignette_mmu_", fileext = ".RData") %T>% 
    message("Saving workspace to ", .) %>% 
    save.image(compress = "xz")
```


# References {#references}

---
title: "An oxybenzone exposition study on gilt-head bream"
author: 
-   name: Sergio Picart-Armada 
    affiliation: B2SLab at Polytechnic University of Catalonia
    email: sergi.picart@upc.edu
-   name: Alexandre Perera-Lluna
    affiliation: B2SLab at Polytechnic University of Catalonia
    email: alexandre.perera@upc.edu
date: "September 18, 2018"
package: "`r BiocStyle::pkg_ver('FELLA')`"
output: BiocStyle::pdf_document
bibliography: bibliography_zebrafish.bib
vignette: >
    %\VignetteIndexEntry{Example: oxybenzone exposition in gilt-head bream}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
---

# Introduction

This vignette contains a case study of the effects of 
environmental contamination on gilt-head bream (_Sparus aurata_) [@ziarrusta2018bream]. 
Fish were exposed over 14 days to *oxybenzone* and changes were sought 
in their brain, liver and plasma using untargeted metabolomics. 
Samples were processed using Ultra-performance liquid chromatography mass-spectrometry (UHPLC-qOrbitrap MS) in 
positive and negative modes with both C18 and HILIC separation.

The mortality of exposed fish was not altered, as well as the 
brain-related metabolites. 
However, liver and plasma showed perturbations, proving that 
adverse effects beyond the well-studied hormonal activity were present. 

The enrichment procedure implemented in `FELLA` [@picart2017null] 
was used in the 
study for a deeper understanding of the dysregulated metabolites 
in both tissues. 


## Building the database

At the time of publication, the KEGG database [@kanehisa2016kegg] 
--upon which `FELLA` is based-- did not have pathway annotations for 
the _Sparus aurata_ organism. 
It is common, however, to use the zebrafish (_Danio rerio_) pathways as 
a good approximation. 
KEGG provides pathway annotations for it under the organismal code `dre`, 
which will be used to build the `FELLA.DATA` object.

```{r, warning=FALSE, message=FALSE, results='hide'}
library(FELLA)

library(igraph)
library(magrittr)

set.seed(1)
# Filter the dre01100 overview pathway, as in the article
graph <- buildGraphFromKEGGREST(
    organism = "dre", 
    filter.path = c("01100"))

tmpdir <- paste0(tempdir(), "/my_database")
# Make sure the database does not exist from a former vignette build
# Otherwise the vignette will rise an error 
# because FELLA will not overwrite an existing database
unlink(tmpdir, recursive = TRUE)  
buildDataFromGraph(
    keggdata.graph = graph, 
    databaseDir = tmpdir, 
    internalDir = FALSE, 
    matrices = "none", 
    normality = "diffusion", 
    niter = 100)
```

We load the `FELLA.DATA` object to run both analyses:

```{r, warning=FALSE, message=FALSE, results='hide'}
fella.data <- loadKEGGdata(
    databaseDir = tmpdir, 
    internalDir = FALSE, 
    loadMatrix = "none"
)
```

Given the 11-month temporal gap between the study and this vignette, 
small changes to the amount of nodes in each category are expected 
(see section _2.4 Data handling and statistical analyses_ from the study).
Please see the [Note on reproducibility](#notereproducibility) to understand 
why.

```{r}
fella.data
```


## Note on reproducibility {#notereproducibility}

We want to emphasise that each time this vignette is built, 
`FELLA` constructs its `FELLA.DATA` object 
using the most recent version of the KEGG database. 
KEGG is frequently updated and therefore small changes can 
take place in the knowledge graph between different releases. 
The discussion on our findings was written at the date specified 
in the vignette header and using the KEGG release in the 
[Reproducibility](#reproducibility) section. 


# Enrichment analysis on liver tissue


## Defining the input and running the enrichment {#defenrichliver}

_Table 1_ from the main body in [@ziarrusta2018bream] 
contains 5 KEGG identifiers associated to metabolic changes 
in liver tissue and 12 in plasma.
Our first enrichment analysis with `FELLA` will be based on the 
liver-derived metabolites. 
Also note that we use the faster `approx = "normality"` approach, 
whereas the original article uses `approx = "simulation"` with 
`niter = 15000`
This is not only intended to keep the bulding time 
of this vignette as low as possible, 
but also to demonstrate that the findings 
using both statistical approaches are consistent.

```{r}
cpd.liver <- c(
    "C12623", 
    "C01179", 
    "C05350", 
    "C05598", 
    "C01586"
)

analysis.liver <- enrich(
    compounds = cpd.liver, 
    data = fella.data, 
    method = "diffusion", 
    approx = "normality")
```

All the metabolites are successfully mapped:

```{r}
analysis.liver %>% 
    getInput %>% 
    getName(data = fella.data)
```

Below is a plot of the reported sub-network using the default parameters. 
The five metabolites are present and lie within the same connected component.

```{r, fig.width=8, fig.height=8}
plot(
    analysis.liver, 
    method = "diffusion", 
    data = fella.data, 
    nlimit = 250,  
    plotLegend = FALSE)
```

We will examine the igraph object with the reported sub-network and 
some of its reported entities in tabular format:

```{r}
g.liver <-  generateResultsGraph(
    object = analysis.liver, 
    data = fella.data, 
    method = "diffusion")

tab.liver <- generateResultsTable(
    object = analysis.liver, 
    data = fella.data, 
    method = "diffusion")
```

The reported sub-network contains around 
100 nodes and can be manually inquired:

```{r}
g.liver
```


## Examining the pathways

_Figure 2_ from the original study frames the five metabolites in the 
input around _Phenylalanine metabolism_. 
We can verify that `FELLA` finds such pathway and two closely related 
suggestions: _Tyrosine metabolism_ and 
_Phenylalanine, tyrosine and tryptophan biosynthesis_.

```{r}
path.fig2 <- "dre00360" # Phenylalanine metabolism
path.fig2 %in% V(g.liver)$name
```

These are the reported pathways:

```{r}
tab.liver[tab.liver$Entry.type == "pathway", ]
```


## Examining the metabolites {#exammetplasma}

_Figure 2_ also gathers two types of metabolites: 
metabolites in the input (inside shaded frames) and 
other contextual metabolites (no frames) that link the 
input metabolites. 

First of all, we can check that all the input metabolites 
appear in the suggested sub-network. 
While it's expected that most of the input metabolites appear as 
relevant, it is an important property of our method, 
in order to elaborate a sensible 
biological justification of the experimental differences. 

```{r}
cpd.liver %in% V(g.liver)$name
```

On the other hand, one of the two contextual metabolites 
is also suggested by `FELLA`, proving its usefulness to fill the 
gaps between the input metabolites.

```{r}
cpd.fig2 <- c(
    "C00079", # Phenylalanine
    "C00082"  # Tyrosine
)
cpd.fig2 %in% V(g.liver)$name
```


# Enrichment analysis on plasma


## Defining the input and running the enrichment

As shown in section 
[Defining the input and running the enrichment](#defenrichliver), 
12 KEGG identifiers (one ID is repeated) are related to the 
experimental changes observed in plasma, which are the starting 
point of the enrichment:

```{r}
cpd.plasma <- c(
    "C16323", 
    "C00740", 
    "C08323", 
    "C00623", 
    "C00093", 
    "C06429", 
    "C16533", 
    "C00740", 
    "C06426", 
    "C06427", 
    "C07289", 
    "C01879"
) %>% unique

analysis.plasma <- enrich(
    compounds = cpd.plasma, 
    data = fella.data, 
    method = "diffusion", 
    approx = "normality")
```

The totality of the 11 unique metabolites 
map to the `FELLA.DATA` object:

```{r}
analysis.plasma %>% 
    getInput %>% 
    getName(data = fella.data)
```

Again, the reported sub-network consists of a large connected component 
encompassing most input metabolites:

```{r, fig.width=8, fig.height=8}
plot(
    analysis.plasma, 
    method = "diffusion", 
    data = fella.data, 
    nlimit = 250,  
    plotLegend = FALSE)
```

We will export the results as a network and as a table:

```{r}
g.plasma <-  generateResultsGraph(
    object = analysis.plasma, 
    data = fella.data, 
    method = "diffusion")

tab.plasma <- generateResultsTable(
    object = analysis.plasma, 
    data = fella.data, 
    method = "diffusion")
```

The reported sub-network is a bit larger than the one 
from liver, containing roughly 120 nodes:

```{r}
g.plasma
```


## Examining the pathways

_Figure 3_ from the original study is a holistic view of the 
affected metabolites found in plasma, based on literature and 
on an analysis with `FELLA`.
The 11 metabolites are depicted within their core metabolic pathways. 
We will check whether `FELLA` is able to highlight them, 
by first showing the reported metabolic pathways:

```{r}
tab.plasma[tab.plasma$Entry.type == "pathway", ]
```

And then comparing against the ones in _Figure 3_:

```{r}
path.fig3 <- c(
    "dre00591", # Linoleic acid metabolism
    "dre01040", # Biosynthesis of unsaturated fatty acids
    "dre00592", # alpha-Linolenic acid metabolism
    "dre00564", # Glycerophospholipid metabolism
    "dre00480", # Glutathione metabolism
    "dre00260"  # Glycine, serine and threonine metabolism
)
path.fig3 %in% V(g.plasma)$name
```

All of them but *Glutathione metabolism* are recovered, 
showing how `FELLA` can help gaining perspective on 
the input metabolites. 


## Examining the metabolites 

As in the [analogous section for liver](#exammetplasma), 
we will quantify how many input metabolites, 
drawn within a shaded frame in _Figure 3_, are reported 
in the sub-network:

```{r}
cpd.plasma %in% V(g.plasma)$name
```

From the 11 highlighted metabolites, only one is 
not reported by `FELLA`: *5-Oxo-L-proline*. 

Conversely, two out of the three contextual metabolites 
from the same figure are reported:

```{r}
cpd.fig3 <- c(
    "C01595", # Linoleic acid
    "C00157", # Phosphatidylcholine
    "C00037"  # Glycine
) 
cpd.fig3 %in% V(g.plasma)$name
```

As _Figure 3_ shows, the addition of *linoleic acid* and 
*phosphatidylcholine*, backed up by `FELLA`, helps connecting 
almost all the metabolites found in blood.

`FELLA` misses *glycine* and, in fact, stays consistent with the 
pathway (*Glutathione metabolism*) and the input metabolite 
(*5-Oxo-L-proline*) that it left out from _Figure 3_. 
The fact that `FELLA` does not suggest such pathway seems to happen 
at several molecular levels and therefore none of its metabolites 
are pinpointed.

Even if the glutathione pathway was not reported, 
`FELLA` can greatly ease the creation of elaborated contextual figures, 
such as _Figure 3_, by suggesting the intermediate metabolites and 
the metabolic pathways that link the input compounds. 


# Conclusions

In this vignette, we apply `FELLA` to an untargeted metabolic study 
of gilt-head bream exposed to an environmental contaminat (oxybenzome). 
This study is an example of how `FELLA` can be useful for 
(1) organisms not limited to _Homo sapiens_, and 
(2) conditions not limited to a specific disease. 

On one hand, `FELLA` helps creating complex 
contextual interpretations of the data, such as the comprehensive 
_Figure 3_ from the original article [@ziarrusta2018bream]. 
This material would be challenging to build through regular 
over-representation analysis of the input metabolites. 
On the other hand, metabolites and pathways suggested by `FELLA` 
were also mentioned in the literature and supported the
main findings in the study. 
In particular, it helped identify key processes such as 
*phenylalanine metabolism*, 
*alpha-linoleic acid metabolism* and 
*serine metabolism*, 
which ultimately pointed to alterations in *oxidative stress*.


# Reproducibility

This is the result of running `sessionInfo()`

```{r}
sessionInfo()
```

KEGG version:

```{r}
cat(getInfo(fella.data))
```

Date of generation:

```{r}
date()
```

Image of the workspace (for submission):

```{r}
tempfile(pattern = "vignette_dre_", fileext = ".RData") %T>% 
    message("Saving workspace to ", .) %>% 
    save.image(compress = "xz")
```


# References {#references}

%\textwidth=6.2in \textheight=8.5in
%\parskip=.3cm \oddsidemargin=.1in \evensidemargin=.1in
%\headheight=-.3in
%\VignetteIndexEntry{FELLA}
%\VignettePackage{BiocStyle}
%\VignetteEngine{utils::Sweave}

\documentclass[12pt]{article}

<<style-Sweave, echo=FALSE, results=tex>>=
BiocStyle::latex()
@

\usepackage{dsfont}
\usepackage{booktabs}
\usepackage{fixltx2e} %subscripts
\usepackage{multirow}
\usepackage{adjustbox}
%\usepackage{hyperref}


\newcommand{\textq}[1]{``#1''}
% \newcommand{\Rcode}[1]{{\texttt{#1}}}
% \newcommand{\Robject}[1]{{\texttt{#1}}}
% \newcommand{\Rfunction}[1]{{\texttt{#1}}}
% \newcommand{\Rpackage}[1]{{\textit{#1}}}
% \newcommand{\Rclass}[1]{{\textit{#1}}}
\newcommand{\Rmethod}[1]{{\textit{#1}}}
\newcommand{\Rfunarg}[1]{{\textit{#1}}}

\newcommand{\fella}{{\Rpackage{FELLA}}}
\newcommand{\metaboanalyst}{{\href{www.metaboanalyst.ca}{MetaboAnalyst}}}
\newcommand{\impala}{{\href{http://impala.molgen.mpg.de}{IMPaLA}}}
\newcommand{\warnkegg}{{\footnote{
This analysis is subject to KEGG release 83.0, from August 17th, 2017. 
Posterior KEGG releases might alter the reported sub-network
}}}

\begin{document}

\SweaveOpts{concordance=TRUE, include=TRUE, echo=TRUE, results=hide}
%\SweaveOpts{fig=FALSE, results=hide, prefix.string=fella_latexfiles/}
%\setkeys{Gin}{width=1\textwidth}
\bioctitle[The FELLA R package]{FELLA: an R package to enrich metabolomics data}
\author[1,2]{Sergio Picart-Armada\thanks{\email{sergi.picart@upc.edu}}}
\author[1,2]{Francesc Fern\'andez-Albert}
\author[3,4,5]{Maria Vinaixa}
\author[3,4]{Oscar Yanes}
\author[1,2]{Alexandre Perera-Lluna}
\affil[1]{B2SLab, Departament d'Enginyeria de Sistemes,
Autom\`atica i Inform\`atica Industrial,
Universitat Polit\`ecnica de Catalunya, CIBER-BBN, Barcelona, 08028, Spain}
\affil[2]{Institut de Recerca Pedi\`atrica
Hospital Sant Joan de D\'eu, Esplugues de Llobregat, Barcelona, 08950, Spain}
\affil[3]{Centre for Omic Sciences, Department of Electronic Engineering, 
Rovira i Virgili University, Reus, 43204, Spain}
\affil[4]{Metabolomics Platform, Spanish Biomedical Research Centre in 
Diabetes and Associated Metabolic Disorders, Madrid, 28029, Spain}
\affil[5]{Manchester Synthetic Biology Research Centre for Fine and 
Speciality Chemicals, University of Manchester, 
Manchester, M1 7DN, United Kingdom}

\maketitle

\section{Abstract}

Pathway enrichment techniques are useful for giving 
context to experimental metabolomics data.
The primary analysis of the raw metabolomics data leads to 
annotated metabolites with abundance measures. 
These metabolites are compared between experimental conditions, 
in order to find discriminative molecular signatures. 
The secondary analysis of the dataset aims at giving context 
to the affected metabolites in terms of the 
prior biological knowledge gathered in metabolic pathways. 
Several statistical approaches are available to derive 
a list of prioritised metabolic pathways that relate to 
the underlying changes in metabolite abundances.
However, the interpretation of a prioritised pathway list 
remains challenging, as pathways are not disjoint and 
show overlap and cross talk effects. 
Furthermore, it is not straightforward to automatically propose 
novel enzymatic targets given a pathway enrichment. 

We introduce \fella, an R package to perform a 
network-based enrichment of a list of affected metabolites. 
\fella~builds a hierarchical network representation of 
the organism of choice using the Kyoto Encyclopedia of Genes and Genomes, 
which contains pathways, modules, enzymes, reactions and metabolites. 
The enrichment is accomplished by applying 
diffusion algorithms in the knowledge network. 
Flow is introduced in the metabolites from the input list 
and propagates to the rest of nodes, 
resulting in diffusion scores for all the nodes in the network. 
The top scoring nodes contain not only relevant pathways, 
but also the intermediate entities that build a plausible explanation 
on how the input metabolites translate into reported pathways. 
The highlighted sub-network can shed light on 
pathway cross talk under the experimental condition 
and potential enzymatic targets for further study.

The implementation and the programmatic use of \fella~is hereby described, 
along with a graphical user interface that wraps the package functionality. 
The algorithmic part in \fella~was previously validated on 
the study of an uncharacterised mitochondrial protein. 
The functionality of \fella~has been demonstrated on 
three public human metabolomics studies, respectively on 
(a) ovarian cancer cells, (b) dry eye and (c) malaria 
and other febrile illnesses. 
\fella~has been able to reproduce findings 
from the original publications and to report sub-network representations 
that can be manually handled. 

\section{Introduction}

Metabolomics is the science that studies the chemical reactions 
in living organisms by quantifying their lightweight molecules, 
called metabolites.
The utilities of metabolomics range from disease diagnosis 
through biomarkers and personalised medicine 
to the generation of biological knowledge \cite{metaboreview}. 

Metabolomics data is mainly acquired through technologies such as, 
but not limited to, Nuclear Magnetic Resonance (NMR) 
and Mass Spectrometry (MS). 
MS is usually preceded by Liquid Chromatography (LC) or 
Gas Chromatography (GC) \cite{metabolomicstechnologiescomplete}. 
The primary analysis of the raw metabolomics data 
can be achieved through publicly available tools: 
the R packages \Biocpkg{xmcs} \cite{xcms} for peak identification 
and \Biocpkg{CAMERA} \cite{camera} for peak annotation.
There are pipelines that cover the whole process, 
for example the online tool 
\href{https://meltdb.cebitec.uni-bielefeld.de}{MeltDB} \cite{meltdb} 
or the R package \Biocpkg{MAIT} \cite{mait}. 
Metabolites found in samples are mapped to specral databases 
such as the Human Metabolome Database \cite{hmdb}. 

The secondary analysis, or data interpretation, 
starts when the metabolites are mapped to a database and 
their abundances are available \cite{reviewsecondary}. 
The existence of experimental conditions enables a 
statistical differential analysis that yields a set of 
metabolites that exhibit changes in the intervention. 
It is, however, increasingly important to understand the 
underlying biological perturbation by giving context to the 
affected metabolites rather than focusing on the ability to 
classify samples through them \cite{metaboreview}. 
Pathway analysis is a fundamental methodology for data interpretation 
\cite{review10years} that enriches the affected metabolites with 
current knowledge on biology, available in pathway databases 
including the Kyoto Encyclopedia of Genes and Genomes 
or KEGG \cite{kegg}, Reactome \cite{reactome} 
and WikiPathways \cite{wikipathways}. 
Enrichment techniques will be discussed in three categories 
or generations, according to the classification 
proposed in the review \cite{review10years}. 
Commercial pathway analysis products such as \software{IPA} 
(QIAGEN Inc., 
\url{https://www.qiagenbioinformatics.com/products/ingenuitypathway-analysis}) 
are out of the scope of this work.

The first generation of methods, 
named over representation analysis (ORA), 
are based on testing if the proportion of 
affected metabolites within a pathway is statistically meaningful. 
ORA is based in statistical tests on probability distribution 
like the hypergeometric, binomial or chi-squared \cite{review10years}. 
ORA is available in tools like the web servers 
\metaboanalyst~\cite{metaboanalyst} and \impala~\cite{impala} 
and the R package \Biocpkg{clusterProfiler} \cite{clusterprofiler}. 
The online resource 
\href{http://www.bio-bigdata.com/SubpathwayMiner/}{SubPathwayMiner} 
identifies sub-pathways from KEGG pathways 
by mining $k$-cliques in each metabolic pathway prior to ORA. 
With this strategy, significant sub-regions can be spotted 
even if the whole pathway is not significant \cite{subpathwayminer}. 

The second generation of methods, functional class scoring (FCS), 
uses quantitative data instead and seeks 
subtle but coordinated changes in the metabolites belonging to a pathway.
MSEA \cite{msea} in \metaboanalyst~\cite{metaboanalyst} 
and \impala~\cite{impala} contain implementations of FCS for metabolomics. 
The R package \Biocpkg{PAPi} calculates pathways activity scores 
per sample, based on the number of metabolites identified 
from each pathway and their relative abundances.
Significantly affected pathways are found by applying an ANOVA 
or a t-test on those scores \cite{papi}. 
On the other hand, there is an ensemble approach relying on 
several pathway-based statistical tests \cite{egsea} 
and is available in the R pacakge \Biocpkg{EGSEA}. 

The third generation, known as pathway topology-based (PT) methods, 
further includes topological measures of the metabolites 
in the statistic, accounting for their inequivalence 
in the metabolic network. 
PT analyses can be performed using \metaboanalyst~\cite{metaboanalyst}, 
where metabolites are weighted by their centrality within the pathway. 
The R package \CRANpkg{MPINet} builds a pathway-level statistic 
that accounts for metabolite inequivalence in the 
global metabolic network and for bias in technical equipment \cite{mpinet}. 

Another perspective for understanding metabolomics data is 
through the construction and inquiry of metabolic networks. 
The \software{MetScape} plugin \cite{metscape} within the 
\software{Cytoscape} environment \cite{cytoscape} is useful for 
representing metabolite-reaction-enzyme-gene networks. 
\Biocpkg{KEGGGraph} is an R package for constructing 
metabolic networks from the KEGG pathways \cite{kegggraph}.
\Biocpkg{MetaboSignal} is an R package for 
building and examining the topology of 
gene-metabolite networks \cite{metabosignal}. 
The R package \Githubpkg{dgrapov/MetaMapR} helps reduce sparsity 
in metabolic networks by integrating biochemical transformations, 
structural similarity, mass spectral similarity and 
empirical correlation information \cite{metamapr}.

Here, we introduce the R package \fella~for 
metabolomics data interpretation that combines concepts from 
pathway enrichment and network analysis. 
The main objective of \fella~is providing the user with a 
biological explanation involving biological pathways. 
\fella~starts from a single, comprehensive network 
consisting of metabolites, reactions, 
enzymes, modules and pathways as nodes.
The list of affected metabolites and the pathways 
highlighted by \fella~are connected through intermediate entities 
-reactions, enzymes and KEGG modules- and returned as a sub-network.
The intermediate entities suggest how the perturbation spreads 
from metabolites to pathways and how pathways cross talk. 
The provided enzymes are candidates for further examination, 
whereas new metabolites might be reported as well. 
\fella~is publicly available in 
\url{https://github.com/b2slab/FELLA} under the GPL-3 license. 

\section{Methodology}

\subsection{Implementation details}

\fella~is written entirely in R \cite{r} and relies on 
the \Biocpkg{KEGGREST} R package \cite{keggrest} for retreiving KEGG, 
the \CRANpkg{igraph} R package \cite{igraph} for network analysis and 
the \CRANpkg{shiny} R package \cite{shiny} for providing 
a graphical user interface.

\fella~defines two S4 classes for handling its main purposes: 
a \Rclass{FELLA.DATA} object that encompasses the knowledge model 
from KEGG and a \Rclass{FELLA.USER} object that contains 
the current analysis by the user.
Table \ref{tab:classes} contains further details about 
the slots and sub-slots in each one of these classes, 
whereas figure \ref{fig:workflow} depicts the package 
workflow and main functions. 

\begin{table}[h]
%\centering
%\begin{adjustbox}{width=\linewidth,center}
% \begin{adjustbox}{center}
\resizebox{\linewidth}{!}{%
\begin{tabular}{lllll}
\hline
Custom class & Slot & Sub-slot & Class & Description \\
\hline
\multirow{12}{*}{\texttt{FELLA.DATA}} & \multirow{5}{*}{\texttt{@keggdata}} & 
\texttt{@graph} & igraph & Knowledge graph object \\
& & \texttt{@id2name} & list & Dictionary from KEGG ID to common name \\
& & \texttt{@pvalues.size} & matrix & Matrix with largest 
CC size probabilities \\
& & \texttt{@id} & list & Correspondence between IDs and category \\
& & \texttt{@status} & character & Status indicator 
of the object \\ \cline{2-5}
& \multirow{1}{*}{\texttt{@hypergeom}} & \texttt{@matrix} & 
Matrix & Metabolite-pathway binary relationship \\ \cline{2-5}
& \multirow{3}{*}{\texttt{@diffusion}} & \texttt{@matrix} & 
matrix & Matrix to compute diffusion as a matrix-vector product \\
& & \texttt{@rowSums} & vector & Internal data to compute the z-scores \\
& & \texttt{@squaredRowSums} & vector & Internal data to compute 
the z-scores \\ \cline{2-5}
& \multirow{3}{*}{\texttt{@pagerank}} & \texttt{@matrix} & 
matrix & Matrix to compute PageRank as a matrix-vector product \\
& & \texttt{@rowSums} & vector & Internal data to compute the z-scores \\
& & \texttt{@squaredRowSums} & vector & Internal data 
to compute the z-scores \\ \hline
\multirow{17}{*}{\texttt{FELLA.USER}} & \multirow{3}{*}{\texttt{@userinput}} & 
\texttt{@metabolites} & vector & KEGG IDs that map to the knowledge graph \\
& & \texttt{@metabolitesbackground} & vector & Background KEGG IDs \\
& & \texttt{@excluded} & vector & Input IDs not mapping to the 
knowledge graph \\ \cline{2-5}
& \multirow{6}{*}{\texttt{@hypergeom}} & \texttt{@valid} & logical & 
Indicator of analysis validity \\
& & \texttt{@pvalues} & vector & Pathway p-values \\
& & \texttt{@pathhits} & vector & Number of hits in each pathway \\
& & \texttt{@pathbackground} & vector & Number of metabolites 
in each pathway \\
& & \texttt{@nbackground} & numeric & Number of compounds 
in the background \\
& & \texttt{@ninput} & numeric & Number of compounds 
in the input \\ \cline{2-5}
& \multirow{4}{*}{\texttt{@diffusion}} & \texttt{@valid} & 
logical & Indicator of analysis validity \\
& & \texttt{@pscores} & vector & P-scores for each node in the network \\
& & \texttt{@approx} & character & Chosen approximation \\
& & \texttt{@niter} & numeric & Chosen iterations \\ \cline{2-5}
& \multirow{4}{*}{\texttt{@parerank}} & \texttt{@valid} & logical & 
Indicator of analysis validity \\
& & \texttt{@pscores} & vector & P-scores for each node in the network \\
& & \texttt{@approx} & character & Chosen approximation \\
& & \texttt{@niter} & numeric & Chosen iterations \\ \hline
\end{tabular}
}\caption{Summary of the S4 classes defined in \fella.}
\label{tab:classes}
\end{table}

\begin{figure}[!tpb]%figure1
\centerline{\includegraphics[width=\linewidth]{workflow3.eps}}
\caption{Design of the R package \fella.
Block \textbf{I} covers the creation of a graph object from an 
organism code and its database, which can be loaded 
into a \Rclass{FELLA.DATA} object.
This object is needed in all the following blocks.
Block \textbf{II} requires block \textbf{I} and shows 
how to map the KEGG identifiers to the database 
in a \Rclass{FELLA.USER} object and run the propagation algorithms 
(diffusion, PageRank) to score all the entities in the graph.
Block \textbf{III} requires blocks \textbf{I} and \textbf{II} and 
exports the results as a sub-network or as a table.}
\label{fig:workflow}
\end{figure}


\fella~contains two vignettes that illustrate its capabilities: 
(1) a quick-start example with the main functions applied to 
a toy dataset, and (2) this document, an in-depth 
demonstration on three real studies. 
This vignette requires an internet connection 
and can take up some time and memory to build, 
as it builds the internal KEGG representation 
for Homo sapiens on the fly.

\subsection{Database and knowledge model}

A distinctive feature of \fella~is its unique knowledge model. 
Instead of using individual pathway representations, 
either as a list of metabolites (ORA) or as a metabolic network (TP), 
\fella~builds a unique network that encompasses 
all the pathways at once: the KEGG graph.
Figure \ref{fig:kegggraph} shows the hierarchical representation 
of the KEGG database, ranging from the small, specific 
molecular level (metabolite) to the large, complex unit (pathway). 
Intermediate levels contain, from bottom to top: 
reactions relating the metabolites, enzymes catalising the 
reactions and KEGG modules containing the enzymes.
More details on the construction and curation of this structure, 
resemblant to the one used by MetScape \cite{metscape}, 
can be found in \cite{metabopicart}.
The enrichment is therefore achieved by finding a sub-network 
from the whole KEGG graph that is statistically 
relevant for a list of input metabolites.

\begin{figure}[!tpb]%figure2
\centerline{\includegraphics[width=\linewidth]{kegggraph.eps}}
\caption{Internal knowledge representation from KEGG. 
The scheme outlines the KEGG graph, a heterogeneous network 
whose nodes belong to a category in KEGG: 
compound, reaction, enzyme, module or pathway. 
Lower levels are expected to be more specific entities, 
while top levels are broader concepts. 
The enrichment procedure starts from input metabolites and 
extracts a relevant sub-network from the KEGG graph. 
Figure extractred from \cite{metabopicart}}
\label{fig:kegggraph}
\end{figure}

As shown in the block (I) of figure \ref{fig:workflow}, 
the first step is to build a KEGG graph from an organism 
in KEGG -Homo sapiens by default- using the 
\Rfunction{buildGraphFromKEGGREST} command. 
Afterwards, a local database can be built from 
the KEGG graph through the \Rfunction{buildDataFromGraph} command. 
The main purposes of \Rfunction{buildDataFromGraph} are to 
save (1) the matrices that allow computing diffusion and 
PageRank as a matrix-vector product, and (2) the null distribution 
of the largest connected component of a $k$-th order subgraph, 
with uniformly chosen nodes. 
Point (1) is required to compute the diffusion scores, 
whereas (2) is useful for filtering small connected components 
in the reported subgraphs.

The user should be aware that KEGG is frequently updated and 
therefore the derived KEGG graph can change between KEGG releases.
The metadata from the KEGG version used to build a 
\Rclass{FELLA.DATA} object can be retrieved through \Rfunction{getInfo}.

\subsection{Enrichment analysis}

Once the database is ready as a \Rclass{FELLA.DATA} object 
and the input is formatted as a list of KEGG compounds, 
the enrichment can be performed. 
The results of the enrichment are stored in a 
\Rclass{FELLA.USER} object, possibly using three 
methodologies described below. 

\subsubsection{Hypergeometric test}

For completeness purposes, the hypergeometric test is 
included in \fella~in the function \Rfunction{runHypergeom}. 
As in several ORA implementations, the hypergeometric distribution 
is used to assess whether a biological pathway contains 
more hits within the input list than expected from chance given its size. 
Pathways are ranked according to their p-value 
after multiple testing correction. 

Note that the results from this test will differ from 
a hypergeometric test using the original KEGG pathways, 
because metabolite-pathway connections are inferred from the KEGG graph. 
A metabolite is included in a pathway if the pathway 
can be reached from the metabolite in the upwards-directed 
KEGG graph, depicted in figure \ref{fig:pr}. 
In consequence, metabolites related to the enzymes 
within a pathway will belong to the pathway, 
even if they were not in the original definition of the KEGG pathway. 

\subsubsection{Diffusion}\label{sec:hd}

Diffusion algorithms have been extensively used in computational biology. 
For instance, HotNet is an algorithm for finding 
sub-networks with a large amount of mutated genes \cite{hotnet}, 
whereas TieDIE attemps to link a source set and 
a target set of molecular entities through 
two diffusion processes \cite{tiedie}.
Other applications include the prioritisation of 
disease genes \cite{gwadata} and the prediction of 
gene function \cite{genemania}.

In \fella, diffusion is a natural way to score all the nodes 
in the KEGG graph given an input list of metabolites, 
available using \Rcode{method = "diffusion"} 
in the function \Rfunction{runDiffusion}.
The input metabolites introduce unitary flow in the network.
Flow can only leave the network through pathway nodes, 
forcing it to propagate through the intermediate entities 
as well (reactions, enzymes and modules), see figure \ref{fig:hd}. 
Further details can found in \cite{metabopicart}. 

\begin{figure}[!tpb]
\centerline{\includegraphics[width=.8\linewidth]{HD_contour.eps}}
\caption{Network setup for the diffusion process. 
nput metabolites (in black rings) introduce a unitary flow 
in the network and only the pathway nodes (blue rings) 
can leak the flow. The final score of the nodes reflects 
the \textq{temperature} of a stationary state. 
Figure extractred from \cite{metabopicart}.}
\label{fig:hd}
\end{figure}

However, the diffusion scores are biased due to 
the network topology \cite{metabopicart} and therefore a 
normalisation step is required. 
\fella~offers a normalisation through a z-score 
(\Rcode{approx = "normality"}) or through an empirical p-value 
(\Rcode{approx = "simulation"}), both assessing whether 
the diffusion score of a node is likely to be reached 
in a permutation analysis, i.e. if the input is random. 

The normalisation through the z-scores leads to p-scores, defined as:

$$ ps_i = 1 - \Phi(z_i) $$

Where $ps_i$ is the p-score of node $i$, $z_i$ is 
its z-score \cite{metabopicart} and $\Phi$ is the 
cumulative distribution function of the standard gaussian distribution. 
Under this definition, nodes are ranked using increasing p-scores. 

For completeness, two alternative parametric scores have been added. 
The heavier-tailed \textbf{t}-distribution can be used 
instead of the gaussian by choosing \Rcode{approx = "t"} 
and supplying the desired degrees of freedom $\nu$. 

Similarly, the \textbf{gamma} distribution 
can be used through \Rcode{approx = "gamma"}. 
The p-score is obtained with

$$ ps_i = 1 - F_i(T_i) $$

Being $T_i$ the raw temperature of node $i$ and $F_i$ 
the cumulative distribution function of a gamma distribution, 
adjusted by its shape ($\frac{\mu_i^2}{\sigma_i^2}$) and scale 
($\frac{\sigma_i^2}{\mu_i}$) parameters. 
The quantities $\mu_i$ and $\sigma_i^2$ are the mean 
and variance of the null temperatures and are analytically known 
from the null model formulation \cite{metabopicart}. 

\subsubsection{PageRank}

PageRank \cite{pagerank} offers a scoring method for 
the nodes in the KEGG graph, based on a random walks approach.
The random walks start at the input metabolites and 
are forced to explore their reachable nodes, see figure \ref{fig:pr}. 
As random walks take into account the direction of the edges, 
PageRank is applied to the upwards-directed KEGG graph 
(figure \ref{fig:kegggraph}) in order to force 
the walks to reach pathway nodes. 
Nodes that are frequently visited by the random walks 
earn a higher PageRank, analogously to the diffusion scores. 
More details about this particular formulation, 
implemented in \Rfunction{runPagerank}, 
can be found in \cite{metabopicart}.

\begin{figure}[!tpb]
\centerline{\includegraphics[width=.8\linewidth]{PR_contour.eps}}
\caption{Network setup for PageRank. 
Input metabolites (in black rings) are the source of random walks 
that must climb through the graph levels, up to the pathway nodes. 
Figure extractred from \cite{metabopicart}.}
\label{fig:pr}
\end{figure}

The PageRank scores are statistically normalised, 
providing the same options as in the diffusion scores in section \ref{sec:hd}. 
Therefore, the argument \Rfunarg{approx} can be set 
to \Rcode{"simulation"} for the permutation analysis, 
or to \Rcode{"normality"}, \Rcode{"t"} or \Rcode{"gamma"} 
for the parametric alternatives.

\subsection{Enrichment wrapper}

\fella~contains the wrapper \Rfunction{enrich} 
that maps the KEGG ids and runs the desired enrichment 
procedure with a single call. 
This can be convenient for producing compact scripts 
and running quick analyses.

\subsection{Limitations}

\fella~currently starts the statistical analysis 
from a list of affected metabolites. 
Therefore, it inherits a limitation from ORA methods: 
the need of choosing a cutoff to derive the list of 
affected metabolites, assuming that the metabolites 
stem from a differential abundance analysis. 

Another limitation, shared among network-based models, 
is the incomplete biological knowledge from which the network is built. 
The knowledge model in \fella~might also constraint 
the complexity of the mechanisms that can be found through it.
Processes such as genetic and epigenetic events, 
or the type and directionality of regulatory events, 
are not considered at the moment. 

The user should be aware that \fella~neither builds 
a dynamic model of the biochemical reactions in the metabolism, 
nor relies on flux balance analysis.  
Conversely, \fella~is built on a knowledge representation 
from the biology in KEGG that focuses on offering 
interpretability to the final user.

\section{Case studies}

The functionalities of \fella~are demonstrated by (1) 
building a Homo sapiens database and (2) 
enriching summary metabolomics data from three public datasets. 

\subsection{Building the database}\label{sec:builddb}

\fella~requires a database built from KEGG to perform any data enrichment. 
\fella~contains a small example database as a 
\Rclass{FELLA.DATA} object, accessible via 
\Rcode{data("FELLA.sample")}, but this is a toy example 
for demonstration purposes, not suited for regular analyses. 

Therefore, the database for the corresponding organism 
has to be built before any analysis is run. 
The first step is to build the KEGG graph from the current 
KEGG release with the function \Rfunction{buildGraphFromKEGGREST}. 
Note that the user can force specific KEGG pathways to be 
excluded from the graph - the following code removes 
\textq{overview} metabolic pathways based on 
\href{http://www.genome.jp/kegg/brite.html}{KEGG brite}. 


<<01_graph, eval=TRUE>>=
library(FELLA)
set.seed(1)
# Filter overview pathways
graph <- buildGraphFromKEGGREST(
    organism = "hsa", 
    filter.path = c("01100", "01200", "01210", "01212", "01230"))
@

Once the KEGG graph is ready, the database will be saved 
locally using \Rfunction{buildDataFromGraph}. 
The user can choose which matrices shall be stored 
using the \Rfunarg{matrices} argument - saving both 
\Rcode{"diffusion"} and \Rcode{"pagerank"} 
might take up to 1GB of disk space. 

If the user plans on using the z-score approximation, 
it is advisable to set the \Rfunarg{normality} 
argument to \Rcode{c("diffusion", "pagerank")} 
in order to speed up future computations. 
Using the z-scores with a custom metabolite background 
will require the matrices to be saved as well. 

Finally, the argument \Rfunarg{niter} controls how many 
random trials are performed in the estimation of the 
null distribution of the largest connected component 
of a $k$-th order random subgraph. 
As this is a property of the KEGG graph, 
it is performed once and reused in each analysis. 
This finds application when filtering 
small connected components from the reported sub-network, 
see section \ref{sec:export}.

<<01_database, eval=TRUE>>=
tmpdir <- paste0(tempdir(), "/my_database")
# Mke sure the database does not exist from a former vignette build
# Otherwise the vignette will rise an error 
# because FELLA will not overwrite an existing database
unlink(tmpdir, recursive = TRUE)  
buildDataFromGraph(
    keggdata.graph = graph, 
    databaseDir = tmpdir, 
    internalDir = FALSE, 
    matrices = "diffusion", 
    normality = "diffusion", 
    niter = 50)
@

When the database is available in local, it can be loaded 
in an \R{} session and assigned to a \Rclass{FELLA.DATA} 
object using the function \Rfunction{loadKEGGdata}. 
This should be the only procedure for creating any \Rclass{FELLA.DATA} object.
The user is given the choice of loading the diffusion 
and pagerank matrices to ease memory saving. 

<<01_loadkegg, eval=TRUE>>=
fella.data <- loadKEGGdata(
    databaseDir = tmpdir, 
    internalDir = FALSE, 
    loadMatrix = "diffusion"
)
@

The contents of the \Rclass{FELLA.DATA} object can be summarised as well:

<<01_summary, eval=TRUE, results=verbatim>>=
fella.data
@

The function \Rfunction{getInfo} provides the KEGG 
release and organism that generated a \Rclass{FELLA.DATA} object:

<<01_info, eval=TRUE, results=verbatim>>=
cat(getInfo(fella.data))
@

Please note that the database built for this vignette is 
stored in a temporary folder and will not be persistent.  
The user should build his or her own database and save it 
in a persistent location, either in the package 
installation directory (\Rcode{internalDir = TRUE}) 
or in a custom folder (\Rcode{internalDir = FALSE}). 
Internal databases can be listed using \Rfunction{listInternalDatabases}.

A cautionary note if the user is relying on the 
internal directory: reinstalling \fella~will wipe 
existent databases because its internal directory is overwritten.
Also, if the database name already exists when saving 
a new database, the existing database will be renamed by 
appending \Rcode{\_old} in order to avoid overwriting.

\subsection{Epithelial cells dataset}

This example data is extracted from the epithelial 
cancer cells dataset \cite{epithelial}, an in vitro model 
of dry eye in which the human epithelial cells IOBA-NHC 
are put under hyperosmotic stress. 
The original study files are deposited in the Metabolights repository 
\cite{metabolights} under the identifier MTBLS214: 
\url{https://www.ebi.ac.uk/metabolights/MTBLS214}.
The list of metabolites hereby used reflects 
metabolic changes in \textq{Treatment 1} (24 hours in 
serum-free media at 380 mOsm) against control (24 hours at 280 mOsm). 
The metabolites have been extracted 
from \textq{Table 1} in the original manuscript and mapped to KEGG ids. 


\subsubsection{Mapping the input metabolites}

The input metabolites should be provided as 
\href{http://www.genome.jp/kegg/compound/}{KEGG compound} identifiers. 
If the user starts from another source (common names, 
\href{http://www.hmdb.ca/}{HMDB} identifiers), tools like the 
\textq{compound ID conversor} from 
\metaboanalyst~can be useful for the ID conversion. 

<<02_compounds, eval=TRUE>>=
compounds.epithelial <- c(
    "C02862", "C00487", "C00025", "C00064", 
    "C00670", "C00073", "C00588", "C00082", "C00043")
@

The first step is to map the input metabolites 
to the KEGG graph with \Rfunction{defineCompounds}. 
This step requires the \Rclass{FELLA.DATA} object, 
loaded in section \ref{sec:builddb}. 
The user can impose a custom metabolite background 
with the \Rfunarg{compoundsBackground} argument. 
By default, all the KEGG compounds in the graph are used. 

<<02_mapcompounds, eval=TRUE>>=
analysis.epithelial <- defineCompounds(
    compounds = compounds.epithelial, 
    data = fella.data)
@

Notice that \Rfunction{defineCompounds} throws a 
warning if any of the input metabolites does not map to the graph. 
The user can retrieve the mapped and unmapped identifiers 
through \Rfunction{getInput} and \Rfunction{getExcluded}, respectively.

<<02_mapped, results=verbatim, eval=TRUE>>=
getInput(analysis.epithelial)
getExcluded(analysis.epithelial)
@

The status of a \Rclass{FELLA.USER} object 
can be checked by printing the object.

<<02_print, results=verbatim, eval=TRUE>>=
analysis.epithelial
@

\subsubsection{Enriching using diffusion}

Having mapped the compounds, the enrichment can be performed. 
In this vignette, only the diffusion method 
in \Rfunction{runDiffusion} will be applied, 
although PageRank has an almost identical usage in \Rfunction{runPagerank}.

If the user prefers an explicit permutation analysis, 
the option \Rcode{approx = "simulation"} performs 
the amount of iterations specified in the \Rfunarg{niter} argument.

Conversely, if the desired approximation is 
the z-score (\Rcode{approx = "normality"}), 
the process does not require permutations. 
The z-scores are converted to \Rcode{p.scores} using 
the \Rcode{pnorm} routine. 
Likewise, \Rcode{approx = "t"} and \Rcode{approx = "gamma"} 
respectively rely on \Rcode{pt} and \Rcode{pgamma}. 
Section \ref{sec:hd} contains further details on the scores.

This example applies \Rcode{approx = "normality"}, a fast option. 
For a comparison between prioritisations using 
Monte Carlo trials or the parametric z-score, 
the user can is referred to \cite{metabopicart}.

<<03_enrich, eval=TRUE>>=
analysis.epithelial <- runDiffusion(
    object = analysis.epithelial, 
    data = fella.data, 
    approx = "normality")
@

The \Rclass{FELLA.USER} object has been updated 
with the \Rcode{p.scores} from the diffusion results:

<<03_summary, results=verbatim, eval=TRUE>>=
analysis.epithelial
@

At this point, the subgraph consisting of top scoring nodes 
can be plotted in a heterogeneous network layout. 
In the presence of signal, this subgraph will exhibit 
large connected components and contain nodes from 
all the levels in the KEGG graph. 
It is also expected that the algorithm gives a high priority 
to the metabolites specified in the input, 
although not all of them must necessarily be top ranked. 

Therefore, the user should expect to find 
the presence of intermediate entities 
(reactions, enzymes and modules) that connect 
the input to relevant KEGG pathways. 
Note that \fella~can also pinpoint new KEGG 
compounds as potentially relevant.

In this example, the plot is limited to $150$ nodes 
using the \Rfunarg{nlimit} argument from \Rfunction{plot}. 

<<03_plot, fig=TRUE, fig.wide=TRUE, fig.asp=1, eval=TRUE>>=
nlimit <- 150
vertex.label.cex <- .5
plot(
    analysis.epithelial, 
    method = "diffusion", 
    data = fella.data, 
    nlimit = nlimit, 
    vertex.label.cex = vertex.label.cex)
@

In the original work \cite{epithelial}, the activation of 
the \textbf{glycerophosphocholine synthesis} rather than 
the \textbf{carnitine} response is a main result. 
\fella~highlights\warnkegg~the related pathway 
\textit{choline metabolism in cancer} and the 
\textit{choline} metabolite as well. 
Another key process is the \textbf{O-linked glycosilation}, 
which is close to the KEGG module 
\textit{O-glycan biosynthesis, mucin type core} and to 
the KEGG pathway \textit{Mucin type O-glycan biosynthesis}.
Finally, \fella~reproduces the finding of \textbf{UAP1} 
by reporting the enzyme \textit{2.7.7.23}, named 
\textit{UDP-N-acetylglucosamine diphosphorylase}. 
\textbf{UAP1} is a key protein in the study, 
pinpointed by iTRAQ and validated via western blot. 


\subsubsection{Exporting the results}\label{sec:export}

After an initial exploration of the results, 
these can be exported using three functions that 
lead to network and tabular formats. 

The top scoring nodes can be exported as a network in 
\CRANpkg{igraph} with the function \Rfunction{generateResultsGraph}. 
The number $k$ of nodes in the subgraph is controlled 
by the most stringent filter between \Rfunarg{nlimit} 
(limit on the number of nodes) and \Rfunarg{threshold} 
(limit on the \Rcode{p.score}). 

Once $k$ is determined, the argument \Rfunarg{thresholdConnectedComponent} 
further filters small connected components from the subgraph, 
implying that the resulting subgraph can have less than $k$ nodes. 
A connected component of order $r$ will be kept only if 
the probability that a random subgraph of order $k$ contains 
a connected component of order at least $r$ is smaller than 
the specified threshold.
In other words, small connected components can arise 
from random sampling of the subgraph, whereas larger 
connected components are highly unlikely under a uniform sampling. 
The user can filter connected components that are 
too small to be meaningful in that sense. 

Lastly, the argument \Rfunarg{LabelLengthAtPlot} allows to 
truncate the KEGG names at the given number of 
characters for visualisation purposes.

<<04_graph, results=verbatim, eval=TRUE>>=
g <- generateResultsGraph(
    object = analysis.epithelial, 
    method = "diffusion", 
    nlimit = nlimit, 
    data = fella.data)
g
@

The exported (sub)graph can be further complemented with 
data from GO, the \href{www.geneontology.org}{Gene Ontology} 
\cite{geneontology}. 
Specifically, the enzymes can be equipped with annotations 
from their underlying genes in any ontology from GO. 
Note that this requires additional packages: \Biocpkg{biomaRt} 
and \Biocpkg{org.Hs.eg.db}.
The latter should be changed in case the analysis and 
the database are not from Homo sapiens.

The function \Rfunction{addGOToGraph} achieves this by 
accepting a query GO term and computing the semantic similarity of 
all the genes within each enzyme to the query GO term. 
The semantic similarity is detailed and implemented in the 
package \Biocpkg{GOSemSim} \cite{gosemsim}.

In the current example, enzymes are going to be compared to 
the GO cellular component term 
\href{http://amigo.geneontology.org/amigo/term/GO:0005739}{mitochondrion}.
Enzymes that contain genes whose cellular component is 
closer or coincident with the mitochondrion will be highlighted.

<<04_go, results=verbatim, eval=TRUE>>=
# GO:0005739 is the term for mitochondrion
g.go <- addGOToGraph(
    graph = g, 
    GOterm = "GO:0005739", 
    godata.options = list(
        OrgDb = "org.Hs.eg.db", ont = "CC"), 
    mart.options = list(
        biomart = "ensembl", dataset = "hsapiens_gene_ensembl"))
g.go
@

Plotting the graph with the function \Rfunction{plotGraph} 
reveals the addition of the GO term due to 
a slight change in the plotting legend. 
Enzyme nodes have a different shape and their colour scale 
reflects their degree of similarity to the queried GO term. 

<<04_plot_go, fig=TRUE, eval=TRUE>>=
plotGraph(
    g.go, 
    vertex.label.cex = vertex.label.cex)
@

The second way to export the enrichment results is to 
write the data from the KEGG entries in the top $k$ 
p.scores using \Rfunction{generateResultsTable}. 
This function accepts arguments similar to those 
in \Rfunction{generateResultsTable}. 

<<04_table, results=tex, eval=TRUE>>=
tab.all <- generateResultsTable(
    method = "diffusion", 
    nlimit = 100, 
    object = analysis.epithelial, 
    data = fella.data)
# Show head of the table
knitr::kable(head(tab.all), format = "latex")
@

The last exporting option, \Rfunction{generateEnzymesTable}, 
is to a tabular format with details from the enzymes 
reported among the top $k$ KEGG entries. 
In particular, the table contains the genes that belong to 
each enzyme family, separated by semicolons.

<<04_enzyme, results=tex, eval=TRUE>>=
tab.enzyme <- generateEnzymesTable(
    method = "diffusion", 
    nlimit = 100, 
    object = analysis.epithelial, 
    data = fella.data)
# Show head of the table
knitr::kable(head(tab.enzyme, 10), format = "latex")
@

The three exporting options shown above are included in 
the wrapper function \Rfunction{exportResults}, 
using \Rcode{format = "csv"} for the general tabular data, 
\Rcode{format = "enzyme"} for the enzyme tabular data and 
\Rcode{format = "igraph"} for saving an \Rcode{.RData} 
object with the igraph sub-network object. 

For instance, the general tabular data:

<<04_file, eval=TRUE>>=
tmpfile <- tempfile()
exportResults(
    format = "csv", 
    file = tmpfile, 
    method = "diffusion", 
    object = analysis.epithelial, 
    data = fella.data)
@

If the argument \Rfunarg{format} is none of the former, 
\fella~saves the sub-network using \Rfunction{write.graph} 
from the \CRANpkg{igraph} package with the desired format.

<<04_pajek, eval=TRUE>>=
tmpfile <- tempfile()
exportResults(
    format = "pajek", 
    file = tmpfile, 
    method = "diffusion", 
    object = analysis.epithelial, 
    data = fella.data)
@

\subsubsection{Deploying the graphical user interface}

\fella~is equipped with a graphical user interface that 
eases data analysis without learning the package syntax. 
The app is divided in the following tabs:

\begin{itemize}

\item Compounds upload (figure \ref{fig:shiny01}): 
contains a general description of 
the tabs and a handle to submit the input metabolite list 
as a text file. Examples are provided as well. 
The right panel shows the mapped and the mismatching 
compounds with regard to the default database.

\begin{figure}[!h]
\centerline{\includegraphics[width=11cm]{shiny1.png}}
\caption{Graphical interface: compounds upload}
\label{fig:shiny01}
\end{figure}

\item Advanced options (figure \ref{fig:shiny02}): 
widgets that contain the main 
function arguments for customising the enrichment procedure. 
Allows database choice from the internal package directory, 
method and approximation choice and parameter tweaking. 
It also allows defining a GO label for the semantic similarity 
analysis on the reported enzymes.

\begin{figure}[!h]
\centerline{\includegraphics[width=11cm]{shiny2.png}}
\caption{Graphical interface: advanced options}
\label{fig:shiny02}
\end{figure}

\item Results (figure \ref{fig:shiny03}): 
interactive plot with the sub-graph with the 
top $k$ KEGG entries. Nodes can be selected, 
queried and link to the KEGG entries when hovered. 
Below the network lies an interactive table with the graph nodes, 
allowing the user to look into particular entries.

\begin{figure}[!h]
\centerline{\includegraphics[width=12cm]{shiny3.png}}
\caption{Graphical interface: results}
\label{fig:shiny03}
\end{figure}

\item Export (figure \ref{fig:shiny04}): 
several tabular and network exporting options.

\begin{figure}[!h]
\centerline{\includegraphics[width=12cm]{shiny4.png}}
\caption{Graphical interface: export}
\label{fig:shiny04}
\end{figure}

\end{itemize}

The app is based on \CRANpkg{shiny} \cite{shiny} and can 
be launched through \Rfunction{launchApp}.

\subsubsection{Helper functions}

\fella~is equipped with helper functions that ease the 
user experience and avoid direct manipulation of the S4 classes. 
Some of them have been already introduced - a complete 
enumeration of the exported functions is hereby provided. 

Functions of the type \Rcode{get-} ease object and slot 
retrieval, with the following possibilities: 
\Rfunction{getBackground}, \Rfunction{getExcluded}, 
\Rfunction{getInfo}, \Rfunction{getInput}, 
\Rfunction{getName}, \Rfunction{getPscores}. 

On the other hand, functions starting by \Rcode{list-} 
provide general purpose data about the package 
(\Rfunction{listMethods}, \Rfunction{listApprox}, 
\Rfunction{listCategories}) and a listing of the available 
internal databases (\Rfunction{listInternalDatabases}).

Finally, functions starting by \Rcode{is-} check if 
an object belongs to a certain class: \Rfunction{is.FELLA.DATA} 
and \Rfunction{is.FELLA.USER}.


\subsection{Ovarian cancer cells dataset}

The next example has been extracted from the study on 
metabolic responses of ovarian cancer cells \cite{ovarian}. 
The original files can be found in the MTBLS150 study 
in the Metabolights respository: 
\url{https://www.ebi.ac.uk/metabolights/MTBLS150}.
OCSCs are isogenic ovarian cancer stem cells derived from 
the OVCAR-3 ovarian cancer cells.
The abundances of six metabolites are affected by the 
exposure to several environmental conditions: 
glucose deprivation, hypoxia and ischemia 
(column \textq{All} in \textq{Figure 3} from their main manuscript).

The common names have been converted to KEGG ids prior to applying \fella. 
The analysis is performed using the wrapper \Rfunction{enrich} 
that maps the compounds to the internal representation 
and runs the desired methods.

<<05, fig=TRUE, eval=TRUE>>=
compounds.ovarian <- c(
    "C00275", "C00158", "C00042", 
    "C00346", "C00122", "C06468")
analysis.ovarian <- enrich(
    compounds = compounds.ovarian, 
    data = fella.data, 
    methods = "diffusion")

plot(
    analysis.ovarian, 
    method = "diffusion", 
    data = fella.data, 
    nlimit = 150, 
    vertex.label.cex = vertex.label.cex, 
    plotLegend = FALSE)
@

The resulting subnetwork\warnkegg~reports several 
\textbf{TCA cycle}-related entities, also reported by 
the authors and by previous work \cite{ovarian_tca_fumarate_succinate}. 
It also mentions \textit{sphingosine degradation}, 
closely related to the reported \textbf{sphingosine metabolism} 
in the original work. 
Enzymes that have been formerly related to 
cancer are suggested within the TCA cycle, 
like \textit{fumarate hydratase} 
\cite{ovarian_fumarate_pithukpakorn,ovarian_4_2_1_2_lehtonen, 
ovarian_tca_fumarate_succinate} 
\textit{succinate dehydrogenase} 
\cite{ovarian_succinate_dehydrogenase_ni,ovarian_tca_fumarate_succinate} 
and \textit{aconitase} \cite{ovarian_4_2_1_3_singh}.
Another suggestion is \textit{lysosome} - 
lysosomes suffer changes in cancer cells and directly affect 
apoptosis \cite{ovarian_lysosome_kirkegaard}. 
Finally, the graph contains several \textit{hexokinases}, 
potential targets to disrupt glycolysis, a fundamental need 
in cancer cells \cite{ovarian_hexokinase_kaelin}.

\subsection{Malaria dataset}

The metabolites in the last example are related to 
the distinction between malaria and other febrile ilnesses in \cite{malaria}. 
The study files can be found under the MTBLS315 identifier in Metabolights: 
\url{https://www.ebi.ac.uk/metabolights/MTBLS315}.
Specifically, the list of KEGG identifiers has been 
extracted from the supplementary data spreadsheet, 
using all the possible KEGG matches for the 
\textq{non malaria} patient group. 

<<06, fig=TRUE, eval=TRUE>>=
compounds.malaria <- c(
    "C05471", "C14831", "C02686", "C06462", "C00735", "C14833", 
    "C18175", "C00550", "C01124", "C05474", "C05469")

analysis.malaria <- enrich(
    compounds = compounds.malaria, 
    data = fella.data, 
    methods = "diffusion")

plot(
    analysis.malaria, 
    method = "diffusion", 
    data = fella.data, 
    nlimit = 50, 
    vertex.label.cex = vertex.label.cex, 
    plotLegend = FALSE)
@

In this case, the depicted subnetwork\warnkegg~contains 
the modules \textit{C21-Steroid hormone biosynthesis, 
progesterone => corticosterone/aldosterone} and 
\textit{C21-Steroid hormone biosynthesis, progesterone => cortisol/cortisone}, 
related to the \textbf{corticosteroids} as a main 
pathway reported in the original text.  
This is part of the also reported 
\textit{Aldosterone synthesis and secretion}; 
aldosterone is known to show changes related to 
fever as a metabolic response to infection \cite{mala_nonmala_aldosterone}.
Another plausible hit in the sub-network is 
\textit{linoleic acid metabolism}, as erythrocytes infected 
by various malaria parasytes can be enriched in 
linoleic acid \cite{mala_nonmala_linoleic}. 
In addition, the pathway \textit{sphingolipid metabolism} 
can play a role in the immune response 
\cite{mala_nonmala_sphingo, mala_nonmala_sphingo2}. 
As for the enzymes, \textit{3alpha-hydroxysteroid 3-dehydrogenase 
(Si-specific)} and \textit{Delta4-3-oxosteroid 5beta-reductase} 
are related to three input metabolites each 
and might be candidates for further examination. 

\section{Conclusions}

The \fella~R package provides a simple, programmatic 
and intuitive enrichment tool for metabolomics summary data.
Starting from a list of metabolites, \fella~not only 
pinpoints relevant pathways but also intermediate reactions, 
enzymes and modules that links the input metabolites to the pathways.
The reported entries have a network structure focused on 
interpretability and new hypotheses generation, 
giving a richer perspective than classical pathway enrichment tools.
This comprehensive layout can also suggest potential 
enzymes and new metabolites for further study.
Finally, \fella~comes equipped with a graphical user interface 
that promotes its usage to a wider audience and offers 
interactive sub-network examination.

\section{Funding}
This work was supported by the Spanish
Ministry of Economy and Competitiveness (MINECO)
[BFU2014-57466-P to O.Y., TEC2014-60337-R and DPI2017-89827-R to A.P.].
O.Y., A.P. and S.P. thank for funding the
Spanish Biomedical Research Centre in Diabetes
and Associated Metabolic Disorders (CIBERDEM)
and the Networking Biomedical Research Centre
in the subject area of Bioengineering,
Biomaterials and Nanomedicine (CIBER-BBN),
both initiatives of Instituto de Investigaci\'on Carlos III (ISCIII).
SP. thanks the AGAUR FI-scholarship programme.

\newpage

\bibliography{bibliography}

\newpage

\appendix

\section{Session info}

Here is the output of \Rfunction{sessionInfo()} on the system that
compiled this vignette:

<<sessioninfo, results=tex, echo=FALSE>>=
toLatex(sessionInfo())
@

\end{document}

---
title: "An overview of FELLA: data enrichment for metabolomics summary data"
author: 
-   name: Sergio Picart-Armada 
    affiliation: B2SLab at Polytechnic University of Catalonia
    email: sergi.picart@upc.edu
-   name: Alexandre Perera-Lluna
    affiliation: B2SLab at Polytechnic University of Catalonia
    email: alexandre.perera@upc.edu
date: "`r BiocStyle::doc_date()`"
package: "`r BiocStyle::pkg_ver('FELLA')`"
output: BiocStyle::html_document
bibliography: bibliography.bib
vignette: >
    %\VignetteIndexEntry{Quick start}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
---

# Introduction

`FELLA` is an R package that brings a new concept 
for metabolomics data interpretation. 
The starting point of this data enrichment is 
a list of affected metabolites, which can stem from a 
contrast between experimental groups. 
This list, that may vary in size, 
encompasses key role players from different 
__biological pathways__ that generate a biological perturbation. 

The classical way to analyse this list 
is the __over representation analysis__. 
Each metabolic pathway has a statistic, 
the number of affected metabolites in it, that yields a p-value. 
After correcting for multiple testing, 
a list of prioritised pathways helps 
performing a quality check on the data and 
suggesting novel biological mechanisms 
related to the data. 
Subsequent generations of __pathway analysis__ methods 
attempt to include quantitative and/or topological data 
in the statistics in order to improve power for subtle signals, 
but the interpretation of a prioritised pathway list remains a challenge. 

Package `FELLA`, on the other hand, 
introduces a comprehensive output that encompasses 
other biological entities that coherently relate 
the top ranked pathways. 
The priorisation of the pathways and other entiteis stems from a 
diffusion process on a holistic __graph representation__ 
of the __KEGG database__. 
`FELLA` needs:

1. The KEGG graph and other complementary data files. 
This is stored in a unique `FELLA.DATA` S4 object.
2. A list of affected metabolites (KEGG compounds). 
This is stored in a unique `FELLA.USER` S4 object, 
along with user analyses.

# Loading the KEGG data

This vignette makes use of sample data 
that contains small subgraph of `FELLA`'s KEGG graph
(mid 2017 KEGG release). 
All the necessary contextual data is stored 
in an S4 data structure with class `FELLA.DATA`. 
Several functions need access to the contextual data, 
passed as an argument called `data`, 
being the enrichment itself among them.

```{r, warning=FALSE, message=FALSE}
library(FELLA)

data("FELLA.sample")
class(FELLA.sample)
show(FELLA.sample)
```

Keep in mind that `FELLA.DATA` objects need to 
be constructed only once by using `buildGraphFromKEGGREST` 
and `buildDataFromGraph`, in that precise order. 
This will store them in a local path and they 
should be loaded through `loadKEGGdata`. 
The user is disadvised from manually modifying the database
internal files and the `FELLA.DATA` object slots
not to corrupt the database.

# Loading the metabolomics summary data

The second block of necessary data 
is a list of affected metabolites, 
which shoud be specified as KEGG compound IDs. 
Provided is a list of hypothetical affected metabolites 
belonging to the graph, to which some decoys 
that do not map to the graph are added. 

```{r, warning=FALSE, message=FALSE}
data("input.sample")
input.full <- c(input.sample, paste0("intruder", 1:10))

show(input.full)
```

Compounds are introduced through the `defineCompounds` 
function and provide the first `FELLA.USER` 
user data object containing the 
mapped compounds and empty analyses slots. 
The user should always build `FELLA.USER` objects 
through `defineCompounds` instead of manipulating 
the slots of the object manually - this might skip quality checks.

```{r, warning=TRUE, message=TRUE}
myAnalysis <- defineCompounds(
    compounds = input.full, 
    data = FELLA.sample)
```

Note that a warning message informs the user 
that some compounds did not map to the KEGG compound collection. 
Compounds that successfully mapped 
can be obtained through `getInput`,

```{r, warning=TRUE, message=TRUE}
getInput(myAnalysis)
```

while compounds that were excluded 
because of mismatch can be accessed through `getExcluded`:

```{r, warning=TRUE, message=TRUE}
getExcluded(myAnalysis)
```

Keep in mind that exact matching is sought, 
so be extremely careful with __whitespaces__, 
tabs or similar characters that might create mismatches. 
For example:

```{r, warning=FALSE, message=FALSE, error=TRUE}
input.fail <- paste0(" ", input.full)
defineCompounds(
    compounds = input.fail, 
    data = FELLA.sample)
```

# Enriching the data

Once the `FELLA.DATA` and the `FELLA.USER` 
with the affected metabolites are ready, 
the data can be easily enriched. 

## Enrichment methods

There are three methods to enrich:

1. __Hypergeometric test__ (`method = "hypergeom"`): 
it performs the metabolite-sampling hypergeometric test 
using the connections in `FELLA`'s KEGG graph. 
This is included for completeness and does not include 
the contextual novelty of the diffusive methods.
2. __Diffusion__ (`method = "diffusion"`): 
it performs sub-network analysis on the KEGG graph 
to extract a meaningful subgraph. 
This subgraph can be plotted an interpreted
3. __PageRank__ (`method = "pagerank"`): 
analogous to `"diffusion"` but using the directed diffusion, 
which matches the PageRank algorithm for web ranking.

## Statistical approximations

For methods `"diffusion"` and `"pagerank"`, 
two statistical approximations are proposed:

1. __Normal approximation__ (`approx = "normality"`): 
scores are computed through z-scores 
based on analytical expected value and covariance matrix 
of the null model for diffusion. 
This approximation is deterministic and fast.
1. __Monte Carlo trials__ (`approx = "simulation"`): 
scores are computed through Monte Carlo trials 
of the random variables. 
This approximation requires computing the random trials, 
governed by the `ntrials` argument. 

## Enrichment: methods, approximations and wrapper function

The function `enrich` wraps the functions 
`defineCompounds`, `runHypergeom`, `runDiffusion` and `runPagerank` 
in an easily usable manner, returning a `FELLA.USER` 
object with complete analyses. 

```{r, warning=TRUE, message=TRUE}
myAnalysis <- enrich(
    compounds = input.full, 
    method = "diffusion", 
    approx = "normality", 
    data = FELLA.sample)
```

The output is quite informative and aggregates 
all the warnings.
Let's compare an empty `FELLA.USER` object

```{r, warning=TRUE, message=TRUE}
show(new("FELLA.USER"))
```

to the output of a processed one:

```{r, warning=TRUE, message=TRUE}
show(myAnalysis)
```

The wrapper function `enrich` can run the three analysis 
at once with the option `method = listMethods()`, or only 
the desired ones providing them as a character vector:

```{r, warning=FALSE, message=FALSE}
myAnalysis <- enrich(
    compounds = input.full, 
    method = listMethods(), 
    approx = "normality", 
    data = FELLA.sample)

show(myAnalysis)
```

The wrapped functions work in a similar way, 
here is an example with `runDiffusion`:

```{r, warning=FALSE, message=TRUE}
myAnalysis_bis <- runDiffusion(
    object = myAnalysis, 
    approx = "normality", 
    data = FELLA.sample)
show(myAnalysis_bis)
```

# Visualising the results

The method `plot` for data from the package `FELLA` 
allows a friendly visualisation of the relevant 
part of the KEGG graph. 

## Hypergeom

In the case `method = "hypergeom"` the plot encompasses 
a bipartite graph that contains 
top pathways and affected compounds. 
In that case, `threshold = 1` allows the visualisation 
of both pathways; otherwise a plot with only one pathway 
would be quite uninformative. 

```{r, warning=FALSE, message=TRUE, fig.width=8, fig.height=8}
plot(
    x = myAnalysis, 
    method = "hypergeom", 
    main = "My first enrichment using the hypergeometric test in FELLA", 
    threshold = 1, 
    data = FELLA.sample)
```

## Diffusion

For `method = "diffusion"` the graph contains 
a richer representations involving
__modules, enzymes and reactions__ 
that link affected pathways and compounds.

```{r, warning=FALSE, message=TRUE, fig.width=8, fig.height=8}
plot(
    x = myAnalysis, 
    method = "diffusion", 
    main = "My first enrichment using the diffusion analysis in FELLA", 
    threshold = 0.1, 
    data = FELLA.sample)
```

## PageRank

For `method = "pagerank"` the concept is analogous to diffusion:

```{r, warning=FALSE, message=TRUE, fig.width=8, fig.height=8}
plot(
    x = myAnalysis, 
    method = "pagerank", 
    main = "My first enrichment using the PageRank analysis in FELLA", 
    threshold = 0.1, 
    data = FELLA.sample)
```

# Exporting the results

`FELLA` offers several exporting alternatives, 
both for the R environment and for external software.

## Exporting inside R

The appropriate functions to export the results 
inside R are `generateResultsTable` for a __data.frame__ object:

```{r, warning=FALSE, message=TRUE, results='asis'}
myTable <- generateResultsTable(
    object = myAnalysis, 
    method = "diffusion", 
    threshold = 0.1, 
    data = FELLA.sample)

knitr::kable(head(myTable, 20))
```

...and `generateResultsGraph` for a 
__graph__ in [igraph](http://igraph.org/r/) format:

```{r, warning=FALSE, message=TRUE}
myGraph <- generateResultsGraph(
    object = myAnalysis, 
    method = "diffusion", 
    threshold = 0.1, 
    data = FELLA.sample)

show(myGraph)
```

## Exporting outside R

Results can be saved as permanent files. 
The __data.frame__ data format can be saved as a `.csv` file:

```{r, warning=FALSE, message=TRUE, results='asis'}
myTempDir <- tempdir()
myExp_csv <- paste0(myTempDir, "/table.csv")
exportResults(
    format = "csv", 
    file = myExp_csv, 
    method = "pagerank", 
    threshold = 0.1, 
    object = myAnalysis, 
    data = FELLA.sample)

test <- read.csv(file = myExp_csv)
knitr::kable(head(test))
```

In the same line, the __graph__ can be saved in `RData`:

```{r, warning=FALSE, message=TRUE, results='asis'}
myExp_graph <- paste0(myTempDir, "/graph.RData")
exportResults(
    format = "igraph", 
    file = myExp_graph, 
    method = "pagerank", 
    threshold = 0.1, 
    object = myAnalysis, 
    data = FELLA.sample)

stopifnot("graph.RData" %in% list.files(myTempDir))
```

Other formats exported by [igraph](http://igraph.org/r/) 
are also available, internally using 
their function `igraph::write.graph`. 
Check the __format__ argument 
of `?igraph::write.graph` for a list of 
the supported formats. 
For example, using `"pajek"` format:

```{r, warning=FALSE, message=TRUE, results='asis'}
myExp_pajek <- paste0(myTempDir, "/graph.pajek")
exportResults(
    format = "pajek", 
    file = myExp_pajek, 
    method = "diffusion", 
    threshold = 0.1, 
    object = myAnalysis, 
    data = FELLA.sample)

stopifnot("graph.pajek" %in% list.files(myTempDir))
```

This option is toggled if the format 
does not match any other predefined export option. 

# Session info

For reproducibility purposes, below is the `sessionInfo()` output:

```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/is-.R
\name{is.FELLA.USER}
\alias{is.FELLA.USER}
\title{Check FELLA.USER class}
\usage{
is.FELLA.USER(x = NULL)
}
\arguments{
\item{x}{Object to check}
}
\value{
Logical value stating if \code{x} 
is a \code{\link[FELLA]{FELLA.USER}} object
}
\description{
Is \code{x} a \code{\link[FELLA]{FELLA.USER}} object?
}
\examples{
is.FELLA.USER(new("FELLA.USER"))
is.FELLA.USER(42)

data(FELLA.sample)
data(input.sample)
obj <- enrich(
compounds = input.sample, 
method = "diffusion", 
data = FELLA.sample)
is.FELLA.USER(obj)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get-.R
\name{getMatrix}
\alias{getMatrix}
\title{Get matrix for the desired methodology}
\usage{
getMatrix(data, method)
}
\arguments{
\item{data}{FELLA.DATA object}

\item{method}{Character, exactly one of: 
\code{"hypergeom"}, \code{"diffusion"}, \code{"pagerank"}}
}
\value{
Matrix for the desired methodology (internal usage)
}
\description{
Extractor function for the matrices of 
hypergeometric, diffusion and PageRank methodologies
}
\examples{
## This function is internal
attach(environment(FELLA:::getMatrix))
data(FELLA.sample)
# When a matrix is loaded:
x <- getMatrix(FELLA.sample, "hypergeom")
dim(x)
# When it is not:
y <- getMatrix(FELLA.sample, "diffusion")
dim(y)
y
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R, R/AllMethods.R
\docType{class}
\name{FELLA.USER-class}
\alias{FELLA.USER-class}
\alias{FELLA.USER}
\alias{show,FELLA.USER-method}
\alias{plot,FELLA.USER,missing-method}
\title{An S4 class to save all the user analysis data}
\usage{
\S4method{show}{FELLA.USER}(object)

\S4method{plot}{FELLA.USER,missing}(x = new("FELLA.USER"),
    method = "hypergeom", threshold = 0.05, plimit = 15,
    nlimit = 250, layout = FALSE, thresholdConnectedComponent = 0.05,
    LabelLengthAtPlot = 22, data = NULL, ...)
}
\arguments{
\item{object}{A \code{\link{FELLA.USER}} object}

\item{x}{A \code{\link{FELLA.USER}} object}

\item{method}{Character, exactly one of: 
\code{"hypergeom"}, \code{"diffusion"}, \code{"pagerank"}}

\item{threshold}{Numeric value between 0 and 1. 
\code{p.score} threshold applied when filtering KEGG nodes. 
Lower thresholds are more stringent.}

\item{plimit}{Pathway limit, must be a numeric value between 1 and 50. 
Limits the amount of pathways in \code{method = "hypergeom"}}

\item{nlimit}{Node limit, must be a numeric value between 1 and 1000. 
Limits the order of the solution sub-graph when 
in \code{method = "diffusion"} and \code{method = "pagerank"}}

\item{layout}{Logical, should the plot be returned as a layout?}

\item{thresholdConnectedComponent}{Numeric value between 0 and 1. 
Connected components that are below the threshold are kept, 
while the ones exceeding it (because they are too small) are discarded.}

\item{LabelLengthAtPlot}{Numeric value between 10 and 50. 
Maximum length that a label can reach when plotting the graph. 
The remaining characters will be truncated using "..."}

\item{data}{FELLA.DATA object}

\item{...}{Additional arguments passed to plotting functions}
}
\value{
\code{show} invisibly returns a list of data frames with the 
best hits for each applied method

\code{plot} returns a layout if \code{layout = T}, 
otherwise \code{invisible()}
}
\description{
Assigning the value of show to a variable will provide
small data frames with the best scoring pathways (\code{hypergeom})
and the best nodes in the KEGG network (\code{diffusion} and 
\code{pagerank})
}
\section{Slots}{

\describe{
\item{\code{userinput}}{A \code{U.userinput} S4 object}

\item{\code{hypergeom}}{A \code{U.hypergeom} S4 object}

\item{\code{diffusion}}{A \code{U.diffusion} S4 object}

\item{\code{pagerank}}{A \code{U.pagerank} S4 object}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/list-.R
\name{listInternalDatabases}
\alias{listInternalDatabases}
\title{List internal databases}
\usage{
listInternalDatabases(full.names = FALSE)
}
\arguments{
\item{full.names}{Logical, should full paths be returned?}
}
\value{
Vector with database directories
}
\description{
This function lists the directories in the local database path
}
\examples{
listInternalDatabases()

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllArguments.R
\name{.params}
\alias{.params}
\title{Dummy function with function arguments}
\usage{
.params()
}
\arguments{
\item{databaseDir}{Path for the KEGG RData files}

\item{internalDir}{Logical, is the directory located 
in the package directory?}

\item{object}{FELLA.USER object}

\item{data}{FELLA.DATA object}

\item{type}{Character vector, containing entries in
"hypergeom", "diffusion" or "pagerank"}

\item{level}{Desired level, can be coded as a number or a character: 
1 or "pathway"; 2 or "module"; 3 or "enzyme"; 
4 or "reaction"; 5 or "compound".}

\item{method}{Character, exactly one of: 
\code{"hypergeom"}, \code{"diffusion"}, \code{"pagerank"}}

\item{methods}{Character vector, containing some of: 
\code{"hypergeom"}, \code{"diffusion"}, \code{"pagerank"}}

\item{approx}{Character: "simulation" for Monte Carlo, "normality", 
"gamma" or "t" for parametric approaches}

\item{loadMatrix}{Character vector to choose if 
heavy matrices should be loaded. 
Can contain: \code{"diffusion"}, \code{"pagerank"}}

\item{threshold}{Numeric value between 0 and 1. 
\code{p.score} threshold applied when filtering KEGG nodes. 
Lower thresholds are more stringent.}

\item{thresholdConnectedComponent}{Numeric value between 0 and 1. 
Connected components that are below the threshold are kept, 
while the ones exceeding it (because they are too small) are discarded.}

\item{plimit}{Pathway limit, must be a numeric value between 1 and 50. 
Limits the amount of pathways in \code{method = "hypergeom"}}

\item{nlimit}{Node limit, must be a numeric value between 1 and 1000. 
Limits the order of the solution sub-graph when 
in \code{method = "diffusion"} and \code{method = "pagerank"}}

\item{niter}{Number of iterations (permutations) 
for Monte Carlo ("simulation"), 
must be a numeric value between 1e2 and 1e5}

\item{layout}{Logical, should the plot be returned as a layout?}

\item{graph}{An \pkg{igraph} object, 
typically a small one, 
coming from an enrichment through \code{"diffusion"} or \code{"pagerank"}.}

\item{GOterm}{Character, GO entry to draw 
semantic similarity in the solution graph. 
If \code{NULL}, the GO labels will be appended without similarities.}

\item{GONamesAsLabels}{Logical, should GO names 
be displayed as labels instead of GO identifiers?}

\item{LabelLengthAtPlot}{Numeric value between 10 and 50. 
Maximum length that a label can reach when plotting the graph. 
The remaining characters will be truncated using "..."}

\item{godata.options}{List, options for the database creator 
\code{\link[GOSemSim]{godata}}}

\item{mart.options}{List, options for the \code{biomaRt} function
\code{\link[biomaRt]{getBM}}. Importantly, this defines the organism, 
see \code{\link[biomaRt]{listDatasets}} for possibilities. 
If calling \code{generateEnzymesTable}, the user can set 
\code{mart.options = NULL} to avoid adding GO labels to enzymes.}

\item{p.adjust}{Character passed to the 
\code{\link[stats]{p.adjust}} method}

\item{dampingFactor}{Numeric value between 0 and 1 (none inclusive), 
damping factor \code{d} for 
PageRank (\code{\link[igraph:page_rank]{page.rank}})}

\item{t.df}{Numeric value; number of degrees of freedom 
of the t distribution 
if the approximation \code{approx = "t"} is used}

\item{compounds}{Character vector containing the 
KEGG IDs of the compounds considered as affected}

\item{compoundsBackground}{Character vector containing the KEGG IDs of 
the compounds that belong to the background. Can be \code{NULL} for the 
default background (all compounds)}

\item{NamesAsLabels}{Logical, should KEGG names be displayed 
as labels instead of KEGG identifiers?}

\item{capPscores}{Numeric value, minimum p-score 
admitted for the readable 
formatting. Smaller p-scores will be displayed 
as \code{< capPscores}}
}
\value{
\code{NULL}
}
\description{
This function eases parameter inheritance to centralise the 
documentation
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/doc-package.R
\docType{package}
\name{FELLA}
\alias{FELLA}
\alias{FELLA-package}
\title{The FELLA package}
\description{
\code{FELLA} is a metabolomics data enrichment tool that contextualises 
a list of metabolites using KEGG reactions, 
enzymes, modules and pathways [Picart-Armada, 2017].
}
\details{
\code{FELLA} can build knowledge models for the desired organism 
from the KEGG database [Kanehisa, 2017]. 
Once a model is ready, the input for the enrichment is introduced 
as a list of affected metabolites (as KEGG IDs). 
The output contains a comprehensive biological network layout 
that relates relevant pathways to the affected metabolites. 
Results are available in network and tabular format. 

\code{FELLA} is equipped with a simple graphical interface 
for the lay user, deployed through \link{launchApp}.

\code{FELLA} relies mainly on the following packages: 
KEGGREST for the queries 
to the KEGG server [Tenenbaum, 2013], 
\pkg{igraph} for the 
network support [Csardi, 2006] and 
\pkg{shiny} for the 
graphical user interface [Chang, 2017].
}
\examples{
## Walkthrough
browseVignettes("FELLA")
## I: create database
?buildGraphFromKEGGREST
## II: enrich data
?enrich
## III: export results
?exportResults

}
\references{
Methodology:

Picart-Armada, S., Fernandez-Albert, F., Vinaixa, 
M., Rodriguez, M. A., Aivio, S., Stracker, 
T. H., Yanes, O., & Perera-Lluna, A. (2017). 
Null diffusion-based enrichment for metabolomics data. 
PLOS ONE, 12(12), e0189012.


Database: 

Kanehisa, M., Furumichi, M., Tanabe,
M., Sato, Y., & Morishima, K. (2017).
KEGG: new perspectives on genomes, pathways, diseases and drugs.
Nucleic acids research, 45(D1), D353-D361.


Main dependencies:

Tenenbaum, D. (2013). KEGGREST: Client-side REST access 
to KEGG. R package version, 1(1).

Csardi, G., & Nepusz, T. (2006). The igraph software package 
for complex network research. 
InterJournal, Complex Systems, 1695(5), 1-9.

Chang, W., Cheng, J., Allaire, JJ., 
Xie, Y., & McPherson, J. (2017).
shiny: Web Application Framework for R. R package version 1.0.5.
https://CRAN.R-project.org/package=shiny
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R
\docType{class}
\name{D.hypergeom-class}
\alias{D.hypergeom-class}
\title{An internal S4 class for the binary matrix (hypergeometric test)}
\description{
An internal S4 class for the binary matrix (hypergeometric test)
}
\section{Slots}{

\describe{
\item{\code{matrix}}{Binary sparse matrix}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllArguments.R
\name{checkArguments}
\alias{checkArguments}
\title{Internal function to check arguments and give personalised errors}
\usage{
checkArguments(databaseDir = "myDatabase", internalDir = TRUE,
    method = "diffusion", methods = "diffusion", approx = "normality",
    loadMatrix = NULL, threshold = 0.05, plimit = 15, nlimit = 250,
    niter = 1000, t.df = 10, dampingFactor = 0.85, layout = FALSE,
    thresholdConnectedComponent = 0.05, GOterm = NULL,
    GONamesAsLabels = TRUE, LabelLengthAtPlot = 22,
    object = new("FELLA.USER"), data = new("FELLA.DATA"), ...)
}
\arguments{
\item{databaseDir}{Path for the KEGG RData files}

\item{internalDir}{Logical, is the directory located 
in the package directory?}

\item{method}{Character, exactly one of: 
\code{"hypergeom"}, \code{"diffusion"}, \code{"pagerank"}}

\item{methods}{Character vector, containing some of: 
\code{"hypergeom"}, \code{"diffusion"}, \code{"pagerank"}}

\item{approx}{Character: "simulation" for Monte Carlo, "normality", 
"gamma" or "t" for parametric approaches}

\item{loadMatrix}{Character vector to choose if 
heavy matrices should be loaded. 
Can contain: \code{"diffusion"}, \code{"pagerank"}}

\item{threshold}{Numeric value between 0 and 1. 
\code{p.score} threshold applied when filtering KEGG nodes. 
Lower thresholds are more stringent.}

\item{plimit}{Pathway limit, must be a numeric value between 1 and 50. 
Limits the amount of pathways in \code{method = "hypergeom"}}

\item{nlimit}{Node limit, must be a numeric value between 1 and 1000. 
Limits the order of the solution sub-graph when 
in \code{method = "diffusion"} and \code{method = "pagerank"}}

\item{niter}{Number of iterations (permutations) 
for Monte Carlo ("simulation"), 
must be a numeric value between 1e2 and 1e5}

\item{t.df}{Numeric value; number of degrees of freedom 
of the t distribution 
if the approximation \code{approx = "t"} is used}

\item{dampingFactor}{Numeric value between 0 and 1 (none inclusive), 
damping factor \code{d} for 
PageRank (\code{\link[igraph:page_rank]{page.rank}})}

\item{layout}{Logical, should the plot be returned as a layout?}

\item{thresholdConnectedComponent}{Numeric value between 0 and 1. 
Connected components that are below the threshold are kept, 
while the ones exceeding it (because they are too small) are discarded.}

\item{GOterm}{Character, GO entry to draw 
semantic similarity in the solution graph. 
If \code{NULL}, the GO labels will be appended without similarities.}

\item{GONamesAsLabels}{Logical, should GO names 
be displayed as labels instead of GO identifiers?}

\item{LabelLengthAtPlot}{Numeric value between 10 and 50. 
Maximum length that a label can reach when plotting the graph. 
The remaining characters will be truncated using "..."}

\item{object}{FELLA.USER object}

\item{data}{FELLA.DATA object}

\item{...}{ignored arguments}
}
\value{
A list with values. Currently only a 
logical value named \code{valid} 
if the process runs smoothly. If the checking fails, 
it also returns an 
object called \code{ans}, which depends on 
the situation (can be the original object, 
\code{NULL}, et cetera).
}
\description{
This function checks if the arguments are of the desired type, length 
and range. If it fails, it gives an error explaining why the argument 
is invalid.
}
\examples{
## This function is internal
arg1 <- FELLA:::checkArguments(method = "hello")
arg1$valid
arg2 <- FELLA:::checkArguments(method = "diffusion")
arg2$valid

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/buildGraphFromKEGGREST.R,
%   R/buildDataFromGraph.R, R/loadKEGGdata.R
\name{data-funs}
\alias{data-funs}
\alias{buildGraphFromKEGGREST}
\alias{buildDataFromGraph}
\alias{loadKEGGdata}
\title{Parse, build and load the KEGG knowledge model}
\usage{
buildGraphFromKEGGREST(organism = "hsa", filter.path = NULL)

buildDataFromGraph(keggdata.graph = NULL, databaseDir = NULL,
    internalDir = TRUE, matrices = c("hypergeom", "diffusion",
    "pagerank"), normality = c("diffusion", "pagerank"),
    dampingFactor = 0.85, niter = 100)

loadKEGGdata(databaseDir = tail(listInternalDatabases(), 1),
    internalDir = TRUE, loadMatrix = NULL)
}
\arguments{
\item{organism}{Character, KEGG code for the organism of interest}

\item{filter.path}{Character vector, pathways to filter. 
This is a pattern matched using regexp. 
E.g: \code{"01100"} to filter 
the overview metabolic pathway in any species}

\item{keggdata.graph}{An \pkg{igraph} 
object generated by the function 
\code{buildGraphFromKEGGREST}}

\item{databaseDir}{Character containing the directory to save KEGG files. 
It is a relative directory inside the library location
if \code{internalDir = TRUE}. If left to \code{NULL}, 
an automatic name containing the date, organism and 
the KEGG release is generated.}

\item{internalDir}{Logical, should the directory be internal 
in the package directory?}

\item{matrices}{A character vector, containing any of these: 
\code{"hypergeom"}, \code{"diffusion"}, \code{"pagerank"}}

\item{normality}{A character vector, containing any of these: 
\code{"diffusion"}, \code{"pagerank"}}

\item{dampingFactor}{Numeric value between 0 and 1 (none inclusive), 
damping factor \code{d} for 
PageRank (\code{\link[igraph:page_rank]{page.rank}})}

\item{niter}{Numeric value, number of iterations to estimate the p-values 
for the CC size. Between 10 and 1e3.}

\item{loadMatrix}{Character vector to choose if 
heavy matrices should be loaded. 
Can contain: \code{"diffusion"}, \code{"pagerank"}}
}
\value{
\code{buildGraphFromKEGGREST} returns the 
curated KEGG graph (class \pkg{igraph})

\code{buildDataFromGraph} returns 
\code{invisible(TRUE)} if successful. 
As a side effect, the
directory \code{outdir} is created, containing 
the internal data.

\code{loadKEGGdata} returns the 
\code{\link{FELLA.DATA}} object 
that contains the KEGG knowledge representation.
}
\description{
Function \code{buildGraphFromKEGGREST} makes use of the KEGG 
REST API (requires internet connection) 
to build and return the curated KEGG graph.

Function \code{buildDataFromGraph} takes as input the KEGG graph 
generated by \code{buildGraphFromKEGGREST} 
and writes the KEGG knowledge model in the desired permanent directory.

Function \code{loadKEGGdata} loads the internal files 
containing the KEGG knowledge model into a 
\code{\link{FELLA.DATA}} object. 

In general, \code{generateGraphFromKEGGREST} and 
\code{generateDataFromGraph} are one-time executions 
for a given organism and knowledge model, 
in this precise order. 
On the other hand, the user needs to run \code{loadKEGGdata} 
in every new R session to load such model into a 
\code{\link{FELLA.DATA}} object.
}
\details{
In function \code{buildGraphFromKEGGREST}, 
The user specifies (i) an organism, and (ii) patterns matching 
pathways that should not be included as nodes. 
A graph object, as described in [Picart-Armada, 2017], 
is built from the comprehensive 
KEGG database [Kanehisa, 2017]. 
As described in the main vignette, accessible through 
\code{browseVignettes("FELLA")}, this graph has five levels that 
represent categories of KEGG nodes. 
From top to bottom: pathways, modules, enzymes, reactions and compounds.
This knowledge representation is resemblant to the one formerly 
used by MetScape [Karnovsky, 2011], in which enzymes connect 
to genes instead of modules and pathways.
The necessary KEGG annotations 
are retrieved through KEGGREST R package [Tenenbaum, 2013]. 
Connections between pathways/modules and enzymes are inferred through 
organism-specific genes, i.e. an edge is added if a gene 
connects both entries. 
However, in order to enrich metabolomics data, the user has to 
pass the graph object to \code{buildDataFromGraph}  
to obtain the \code{\link{FELLA.USER}} object. 
All the networks are handled with the igraph R package [Csardi, 2006].

Using \code{buildDataFromGraph} is the second step 
to use the \code{\link[=FELLA]{FELLA}} package. 
The knoledge graph is used to compute other internal variables that are 
required to run any enrichment. 
The main point behind the enrichment is to provide a small 
part of the knowledge graph relevant to the supplied metabolites. 
This is accomplished through diffusion processes and random walks, 
followed by a statistical normalisation, 
as described in [Picart-Armada, 2017].
When building the internal files, 
the user can choose whether to store (i) matrices for each 
provided method, and (ii) vectors derived from such matrices 
to use the parametric approaches. 
These are optional but enable (i) faster permutations and custom 
metabolite backgrounds, and (ii) parametric approaches. 
WARNING: diffusion and PageRank matrices in (i) 
can allocate up to 250MB each. 
On the other hand, the \code{niter} parameter 
controls the amount of trials to approximate the 
distribution of the connected component size under 
uniform node sampling. 
For further info, see the option \code{thresholdConnectedComponent} 
in the details from \code{?generateResultsGraph}. 
Regarding the destination, the user can specify 
the name of the directory. 
Otherwise a name containing the creation date, the organism 
and the KEGG release will be used. 
The database can be stored within the library path or in a 
custom location.

Function \code{loadKEGGdata} returns a 
\code{\link{FELLA.DATA}} object from any of the 
databases generated by \code{\link{FELLA.DATA}}.
This object is the starting point of any enrichment 
using \code{\link{FELLA}}.
In case the user built the matrices for "diffusion" and "pagerank", 
he or she can choose to load them.  
Further detail on the methods can be found in [Picart-Armada, 2017].
The matrices allow a faster computation and the definition 
of a custom background, but use up to 250MB of memory each.
}
\examples{
## Toy example
## In this case, the graph is not built from current KEGG. 
## It is loaded from sample data in FELLA
data("FELLA.sample")
## Graph to build the database (this example is a bit hacky)
g.sample <- FELLA:::getGraph(FELLA.sample)
dir.tmp <- paste0(tempdir(), "/", paste(sample(letters), collapse = ""))
## Build internal files in a temporary directory
buildDataFromGraph(
keggdata.graph = g.sample, 
databaseDir = dir.tmp, 
internalDir = FALSE, 
matrices = NULL, 
normality = NULL, 
dampingFactor = 0.85,
niter = 10)
## Load database
myFELLA.DATA <- loadKEGGdata(
dir.tmp, 
internalDir = FALSE)
myFELLA.DATA

######################

\dontrun{
## Full example

## First step: graph for Mus musculus discarding the mmu01100 pathway
## (an analog example can be built from human using organism = "hsa")
g.mmu <- buildGraphFromKEGGREST(
organism = "mmu", 
filter.path = "mmu01100")
summary(g.mmu)
cat(comment(g.mmu))

## Second step: build internal files for this graph
## (consumes some time and memory, especially if we compute 
"diffusion" and "pagerank" matrices)
buildDataFromGraph(
keggdata.graph = g.mmu, 
databaseDir = "example_db_mmu", 
internalDir = TRUE, 
matrices = c("hypergeom", "diffusion", "pagerank"), 
normality = c("diffusion", "pagerank"), 
dampingFactor = 0.85,
niter = 1e3)
## Third step: load the internal files into a FELLA.DATA object
FELLA.DATA.mmu <- loadKEGGdata(
"example_db_mmu", 
internalDir = TRUE, 
loadMatrix = c("diffusion", "pagerank"))
FELLA.DATA.mmu
}

}
\references{
Kanehisa, M., Furumichi, M., Tanabe, 
M., Sato, Y., & Morishima, K. (2017). 
KEGG: new perspectives on genomes, pathways, diseases and drugs. 
Nucleic acids research, 45(D1), D353-D361.

Karnovsky, A., Weymouth, T., Hull, T., Tarcea, V. G., 
Scardoni, G., Laudanna, C., ... & Athey, B. (2011). 
Metscape 2 bioinformatics tool for the analysis 
and visualization of metabolomics and gene expression data. 
Bioinformatics, 28(3), 373-380.

Tenenbaum, D. (2013). KEGGREST: Client-side REST access 
to KEGG. R package version, 1(1).

Chang, W., Cheng, J., Allaire, JJ., 
Xie, Y., & McPherson, J. (2017).
shiny: Web Application Framework for R. R package version 1.0.5.
https://CRAN.R-project.org/package=shiny

Picart-Armada, S., Fernandez-Albert, F., Vinaixa, 
M., Rodriguez, M. A., Aivio, S., Stracker, 
T. H., Yanes, O., & Perera-Lluna, A. (2017). 
Null diffusion-based enrichment for metabolomics data. 
PLOS ONE, 12(12), e0189012.
}
\seealso{
class \code{\link{FELLA.DATA}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/buildGraphFromKEGGREST.R
\name{largestcc}
\alias{largestcc}
\title{Extract largest CC}
\usage{
largestcc(graph)
}
\arguments{
\item{graph}{Igraph object}
}
\value{
Connected igraph object
}
\description{
Function \code{largestcc} extracts the 
largest connected component of an igraph object
}
\examples{
library(igraph)
g <- barabasi.game(10) + graph.empty(10)
FELLA:::largestcc(g)

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get-.R
\name{getBackground}
\alias{getBackground}
\title{Get compounds in the defined background}
\usage{
getBackground(object)
}
\arguments{
\item{object}{FELLA.USER object}
}
\value{
Vector of compounds in the background. 
If this vector is empty, all 
the compounds are used as background by default.
}
\description{
Extractor function for the compounds defined as background
}
\examples{
data(FELLA.sample)
data(input.sample)
input <- head(input.sample, 12)

## If the background is default, we see an empty vector 
## Note that the number of iterations is really small in the example
obj <- enrich(
compounds = input, 
method = "diffusion", 
approx = "simulation", 
niter = 100, 
data = FELLA.sample)

getBackground(obj)

## Otherwise we see the background compounds that mapped to the graph
obj <- enrich(
compounds = input, 
compoundsBackground = input.sample, 
method = "diffusion", 
approx = "simulation", 
niter = 100, 
data = FELLA.sample)
getBackground(obj)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get-.R
\name{getValid}
\alias{getValid}
\title{Get the slot "valid"}
\usage{
getValid(object, method)
}
\arguments{
\item{object}{FELLA.USER object}

\item{method}{Character, exactly one of: 
\code{"hypergeom"}, \code{"diffusion"}, \code{"pagerank"}}
}
\value{
Slot "valid" (internal usage)
}
\description{
Extractor function for the slot "valid"
}
\examples{
## This function is internal

data(FELLA.sample)
data(input.sample)

obj <- enrich(
compounds = input.sample, 
method = "diffusion", 
data = FELLA.sample)

## If the analysis is valid
FELLA:::getValid(obj, "diffusion")

## Otherwise
FELLA:::getValid(new("FELLA.USER"), "diffusion")
FELLA:::getValid(obj, "pagerank")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/list-.R
\name{listApprox}
\alias{listApprox}
\title{List of approximations}
\usage{
listApprox()
}
\value{
Character vector
}
\description{
Available approximations for the analysis
}
\examples{
listApprox()

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get-.R
\name{getPvaluesSize}
\alias{getPvaluesSize}
\title{Get matrix for the p-value regarding CC size}
\usage{
getPvaluesSize(data)
}
\arguments{
\item{data}{FELLA.DATA object}
}
\value{
Matrix with p-values for CC size (internal usage)
}
\description{
Extractor function for the matrix containing p-value by CC size
that compares to a random selection of nodes in the KEGG graph
}
\examples{
## This function is internal
attach(environment(FELLA:::getPvaluesSize))
data(FELLA.sample)
M <- getPvaluesSize(FELLA.sample)
dim(M)
summary(as.vector(M))
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/doc-data.R
\docType{data}
\name{FELLA.sample}
\alias{FELLA.sample}
\title{FELLA.DATA sample data}
\format{An object of class \code{FELLA.DATA} of length 1.}
\source{
Generated from a mid-2017 KEGG release 
(\url{http://www.genome.jp/kegg/})
}
\usage{
data(FELLA.sample)
}
\value{
A \code{\link[FELLA]{FELLA.DATA}} object
}
\description{
This \code{\link[FELLA]{FELLA.DATA}} object is 
a small KEGG graph object. 
Despite being a small database that only contains 
the two metabolic pathways 
hsa00010 - Glycolysis / Gluconeogenesis, and hsa00640 - 
Propanoate metabolism, 
it is useful to play around with \code{FELLA}'s 
functions. It is also used for internal testing of this package.
}
\examples{
data(FELLA.sample)
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R
\docType{class}
\name{D.keggdata-class}
\alias{D.keggdata-class}
\title{An internal S4 class to represent the KEGG graph and related files}
\description{
An internal S4 class to represent the KEGG graph and related files
}
\section{Slots}{

\describe{
\item{\code{graph}}{KEGG graph}

\item{\code{id2name}}{Mapping list: KEGG ID to KEGG name 
(can contain multiple hits)}

\item{\code{pvalues.size}}{Numeric matrix for the 
evaluation of CC through their size}

\item{\code{id}}{List with character vectors for KEGG categories}

\item{\code{status}}{Character that specifies the 
current status of this S4 class}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R, R/AllMethods.R
\docType{class}
\name{FELLA.DATA-class}
\alias{FELLA.DATA-class}
\alias{FELLA.DATA}
\alias{show,FELLA.DATA-method}
\title{An S4 class to represent all the necessary KEGG data}
\usage{
\S4method{show}{FELLA.DATA}(object)
}
\arguments{
\item{object}{A \code{\link[FELLA]{FELLA.DATA}} object}
}
\value{
\code{show} returns \code{invisible()}
}
\description{
An S4 class to represent all the necessary KEGG data

\code{"show"} is an S4 method to show a FELLA.DATA object
}
\section{Slots}{

\describe{
\item{\code{keggdata}}{A \code{D.keggdata} S4 object}

\item{\code{hypergeom}}{A \code{D.hypergeom} S4 object}

\item{\code{diffusion}}{A \code{D.diffusion} S4 object}

\item{\code{pagerank}}{A \code{D.pagerank} S4 object}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get-.R
\name{getCom}
\alias{getCom}
\title{Get community}
\usage{
getCom(data, level, format = "name")
}
\arguments{
\item{data}{FELLA.DATA object}

\item{level}{Desired level, can be coded as a number or a character: 
1 or "pathway"; 2 or "module"; 3 or "enzyme"; 
4 or "reaction"; 5 or "compound".}

\item{format}{Format of the output, "name" returns KEGG IDs whereas 
"id" returns vertices IDs}
}
\value{
Vector of the names/ids of the desired KEGG graph community
}
\description{
Extractor function for all the nodes from a level/community of KEGG graph
}
\examples{
data(FELLA.sample)
## Pathways
getCom(FELLA.sample, 1, format = "name")
getCom(FELLA.sample, 1, format = "id")
## Modules
getCom(FELLA.sample, 2)
## Enzymes
head(getCom(FELLA.sample, 3))
## Reactions
head(getCom(FELLA.sample, 4))
## Compounds
head(getCom(FELLA.sample, 5))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get-.R
\name{getSums}
\alias{getSums}
\title{Get rowSums/squaredRowSums}
\usage{
getSums(data, method, squared)
}
\arguments{
\item{data}{FELLA.DATA object}

\item{method}{Character, exactly one of: 
\code{"hypergeom"}, \code{"diffusion"}, \code{"pagerank"}}

\item{squared}{Logical, whether to return 
\code{rowSums} (\code{F}) or \code{squaredRowSums} (\code{T})}
}
\value{
Named vector with rowSums/squaredRowSums (internal usage)
}
\description{
Extractor function for rowSums/squaredRowSums
}
\examples{
## This function is internal
attach(environment(FELLA:::getSums))
data(FELLA.sample)
rowsums <- getSums(FELLA.sample, "diffusion", squared = FALSE)
hist(rowsums)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/list-.R
\name{listMethods}
\alias{listMethods}
\title{List of methods}
\usage{
listMethods()
}
\value{
Character vector
}
\description{
Methods available for the analysis
}
\examples{
listMethods()

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/buildGraphFromKEGGREST.R
\name{infere.con2ec}
\alias{infere.con2ec}
\title{Infer connections to EC}
\usage{
infere.con2ec(ids, ent, ent2gene, gene2enzyme)
}
\arguments{
\item{ids}{Character vector of identifiers to map. For example, 
all the KEGG pathways}

\item{ent}{Character, entity that we are mapping 
(one of \code{"pathway"} and one of \code{"module"})}

\item{ent2gene}{Named character vector, names are the entity \code{ent} 
and values are genes}

\item{gene2enyzme}{Named character vector, names are genes and 
values are EC enzyme families
category Character, one of:}
}
\value{
Two-column data frame. Column \code{"from"} contains the 
KEGG enzyme families whereas \code{"to"} contains the entity \code{ent}.
}
\description{
Function \code{infere.con2ec} infers network connections to KEGG EC 
families by passing through genes. This assumes that the category being 
mapped to enzymes is above them.
}
\examples{
ids <- "hsa00010"
ent <- "pathway"
ent2gene <- c("hsa00010" = "hsa:10", "hsa00010" = "hsa:120")
gene2enzyme <- c("hsa:10" = "1.1.1.1", "hsa:120" = "1.2.3.4")
FELLA:::infere.con2ec(ids, ent, ent2gene, gene2enzyme)

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R
\docType{class}
\name{D.pagerank-class}
\alias{D.pagerank-class}
\title{An internal S4 class for the PageRank data}
\description{
An internal S4 class for the PageRank data
}
\section{Slots}{

\describe{
\item{\code{matrix}}{Numeric (dense) matrix [optional]}

\item{\code{rowSums}}{Numeric named vector with rowSums internal data}

\item{\code{squaredRowSums}}{Numeric named vector with 
squaredRowSums internal data}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get-.R
\name{getGraph}
\alias{getGraph}
\title{Get KEGG graph}
\usage{
getGraph(data)
}
\arguments{
\item{data}{FELLA.DATA object}
}
\value{
KEGG graph as an \pkg{igraph} object
}
\description{
Extractor function for the KEGG graph from the FELLA.DATA object
}
\examples{
data(FELLA.sample)
g <- getGraph(FELLA.sample)
class(g)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/is-.R
\name{is.FELLA.DATA}
\alias{is.FELLA.DATA}
\title{Check FELLA.DATA class}
\usage{
is.FELLA.DATA(x = NULL)
}
\arguments{
\item{x}{Object to check}
}
\value{
Logical value stating if \code{x} 
is a \code{\link[FELLA]{FELLA.DATA}} object
}
\description{
Is \code{x} a \code{\link[FELLA]{FELLA.DATA}} object?
}
\examples{
data(FELLA.sample)
is.FELLA.DATA(FELLA.sample)
is.FELLA.DATA(42)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/defineCompounds.R, R/runHypergeom.R,
%   R/runDiffusion.R, R/runPagerank.R, R/enrich.R
\name{enrich-funs}
\alias{enrich-funs}
\alias{defineCompounds}
\alias{runHypergeom}
\alias{runDiffusion}
\alias{runPagerank}
\alias{enrich}
\title{Functions to map and enrich a list of metabolites}
\usage{
defineCompounds(compounds = NULL, compoundsBackground = NULL,
    data = NULL)

runHypergeom(object = NULL, data = NULL, p.adjust = "fdr")

runDiffusion(object = NULL, data = NULL, approx = "normality",
    t.df = 10, niter = 1000)

runPagerank(object = NULL, data = NULL, approx = "normality",
    dampingFactor = 0.85, t.df = 10, niter = 1000)

enrich(compounds = NULL, compoundsBackground = NULL,
    methods = listMethods(), loadMatrix = "none", approx = "normality",
    t.df = 10, niter = 1000, databaseDir = NULL, internalDir = TRUE,
    data = NULL, ...)
}
\arguments{
\item{compounds}{Character vector containing the 
KEGG IDs of the compounds considered as affected}

\item{compoundsBackground}{Character vector containing the KEGG IDs of 
the compounds that belong to the background. Can be \code{NULL} for the 
default background (all compounds)}

\item{data}{FELLA.DATA object}

\item{object}{FELLA.USER object}

\item{p.adjust}{Character passed to the 
\code{\link[stats]{p.adjust}} method}

\item{approx}{Character: "simulation" for Monte Carlo, "normality", 
"gamma" or "t" for parametric approaches}

\item{t.df}{Numeric value; number of degrees of freedom 
of the t distribution 
if the approximation \code{approx = "t"} is used}

\item{niter}{Number of iterations (permutations) 
for Monte Carlo ("simulation"), 
must be a numeric value between 1e2 and 1e5}

\item{dampingFactor}{Numeric value between 0 and 1 (none inclusive), 
damping factor \code{d} for 
PageRank (\code{\link[igraph:page_rank]{page.rank}})}

\item{methods}{Character vector, containing some of: 
\code{"hypergeom"}, \code{"diffusion"}, \code{"pagerank"}}

\item{loadMatrix}{Character vector to choose if 
heavy matrices should be loaded. 
Can contain: \code{"diffusion"}, \code{"pagerank"}}

\item{databaseDir}{Character, path to load the 
\code{\link{FELLA.DATA}} object if
it is not already passed through the argument \code{data}}

\item{internalDir}{Logical, is the directory located 
in the package directory?}

\item{...}{Further arguments for the enrichment function(s) 
\code{runDiffusion}, \code{runPagerank}}
}
\value{
\code{defineCompounds} returns 
the \code{\link{FELLA.USER}} object 
with the mapped metabolites, ready to be enriched.

\code{runHypergeom} returns a 
\code{\link{FELLA.USER}} object 
updated with the hypergeometric test results

\code{runDiffusion} returns a 
\code{\link{FELLA.USER}} object 
updated with the diffusion enrichment results

\code{runPagerank} returns a 
\code{\link[FELLA]{FELLA.USER}} object 
updated with the PageRank enrichment results

\code{enrich} returns a 
\code{\link{FELLA.USER}} object 
updated with the desired enrichment results if 
the \code{\link{FELLA.DATA}} was supplied. 
Otherwise, a list with the freshly loaded  
\code{\link{FELLA.DATA}} object and the 
corresponding enrichment in the 
\code{\link{FELLA.USER}} object.
}
\description{
Function \code{defineCompounds} creates a 
\code{\link{FELLA.USER}} object from a list of 
compounds and a \code{\link{FELLA.DATA}} object.

Functions \code{runHypergeom}, 
\code{runDiffusion} and \code{runPagerank} 
perform an enrichment on a \code{\link{FELLA.USER}} with 
the mapped input metabolites 
(through \code{defineCompounds}) 
and a \code{\link{FELLA.DATA}} object. 
They are based on the hypergeometric test, the heat diffusion model 
and the PageRank algorithm, respectively. 

Function \code{enrich} is a wrapper with 
the following order: 
\code{loadKEGGdata} (optional), 
\code{defineCompounds} and one or more in 
\code{runHypergeom}, \code{runDiffusion} 
and \code{runPagerank}
}
\details{
Function \code{defineCompounds} maps the 
specficied list of KEGG compounds [Kanehisa, 2017], usually from an 
experimental metabolomics study, to the graph contained in the
\code{\link{FELLA.DATA}} object. 
Importantly, the names must be KEGG ids, so other formats 
(common names, HMDB ids, etc) must be mapped to KEGG first. 
For example, through the "Compound ID Conversion" 
tool in MetaboAnalyst [Xia, 2015].
The user can also define a personalised background as a 
list of KEGG compound ids, which should be more extensive than 
the list of input metabolites. 
Once the compounds are mapped, the enrichment 
can be performed through \code{runHypergeom}, 
\code{runDiffusion} and \code{runPagerank}.

Function \code{runHypergeom} performs an over representation analysis 
through the hypergeometric test [Fisher, 1935] on a 
\code{\link{FELLA.USER}} object with mapped metabolites 
and a \code{\link{FELLA.DATA}} object. 
If a custom background was specified, it will be used. 
This approach is included for completeness and it is not the 
main purpose behind the \code{\link{FELLA}} package. 
Importantly, \code{runHypergeom} is not a hypergeometric test using the 
original KEGG pathways. 
Instead, a compound "belongs" to a "pathway" if 
it can reach the original pathway in the 
upwards-directed KEGG graph. 
This is a way to evaluate enrichment including indirect connections 
to a pathway, e.g. through an enzymatic family. 
New "pathways" are expected to be larger than the original pathways
in this analysis and therefore the results can differ from the 
standard over representation.

Function \code{runDiffusion} performs 
the diffusion-based enrichment on a 
\code{\link{FELLA.USER}} object with mapped metabolites 
and a \code{\link{FELLA.DATA}} object [Picart-Armada, 2017]. 
If a custom background was specified, it will be used. 
The idea behind the heat diffusion is the usage of the 
finite difference formulation of the heat equation to 
propagate labels from the metabolites to the rest of the graph.

Following the notation in [Picart-Armada, 2017], 
the temperatures (diffusion scores) 
are computed as:

\deqn{
T = -KI^{-1} \cdot G 
}{
T = -KI^(-1)*G 
}

\code{G} is an indicator vector of the input metabolites 
(\code{1} if input metabolite, \code{0} otherwise).
\code{KI} is the matrix \code{-KI = L + B}, being 
\code{L} the unnormalised graph Laplacian and 
\code{B} the diagonal matrix with \code{B[i,i] = 1} if 
node \code{i} is a pathway and \code{B[i,i] = 0} otherwise.

Equivalently, with the notation in the HotNet approach [Vandin, 2011], 
the stationary temperature is named \code{fs}:

\deqn{
f^s = L_{\gamma}^{-1} \cdot b^s 
}{
fs = Lgamma^(-1)*bs 
}

\code{bs} is the indicator vector \code{G} from above. 
\code{Lgamma}, on the other hand, is found as 
\code{Lgamma = L + gamma*I}, where \code{L} is the unnormalised 
graph Laplacian, \code{gamma} is the first order leaking rate 
and \code{I} is the identity matrix. 
In our formulation, only the pathway nodes are allowed to leak, 
therefore \code{I} is switched to \code{B}. 
The parameter \code{gamma} is set to \code{gamma = 1}.

The input metabolites are forced to stay warm, 
propagating flow to all the nodes in the network. 
However, only pathway nodes are allowed to evacuate 
this flow, so that its directionality is bottom-up. 
Further details on the setup of the diffusion process can be 
found in the supplementary file S2 from [Picart-Armada, 2017].

Finally, the warmest nodes in the graph are reported as 
the relevant sub-network. 
This will probably include some input metabolites and 
also reactions, enzymes, modules and pathways. 
Other metabolites can be suggested as well.

Function \code{runPagerank} performs the random walk 
based enrichment on a 
\code{\link{FELLA.USER}} object with mapped metabolites 
and a \code{\link{FELLA.DATA}} object.
If a custom background was specified, it will be used. 
PageRank was originally conceived as a scoring system for websites 
[Page, 1999]. 
Intuitively, PageRank favours nodes that 
(1) have a large amount of nodes pointing 
at them, and (2) whose pointing nodes also have high scores. 
Classical PageRank is formulated in terms of a random walker -  
the PageRank of a given node is the stationary probability 
of the walker visiting it. 

The walker chooses, in each step, 
whether to continue the random walk with probability 
\code{dampingFactor} or to restart it with probability 
\code{1 - dampingFactor}. 
In the original publication, \code{dampingFactor = 0.85}, 
which is the value used in \code{FELLA} by default. 
If he or she continues, an edge is picked from the outgoing edges 
in the current node with a probability proportional to its weight. 
If he or she restarts it, a node is uniformly picked from the 
whole graph. 
The "personalised PageRank" variant allows a user-defined 
distribution as the source of new random walks. 
The R package \code{igraph} contains such variant in its 
\code{\link[igraph:page_rank]{page.rank}} function [Csardi, 2006].

As described in the supplement S3 from [Picart-Armada, 2017], 
the PageRank \code{PR} can be computed as 
a column vector by imposing a stationary 
state in the probability.
With a damping factor \code{d} and the user-defined 
distribution \code{p} as a column vector:

\deqn{
\textrm{PR} = d\cdot M\cdot \textrm{PR} + (1 - d)\cdot p
}{
PR = d*M*PR + (1 - d)*p
}

\code{M} is the matrix whose element \code{M[i,j]} is the 
probability of transitioning from \code{j} to \code{i}. 
If node \code{j} has outgoing edges, their probability is proportional 
to their weight - all weights must be positive. 
If node \code{j} has no outgoing edges, the probability is 
uniform over all the nodes, i.e. \code{M[i,j] = 1/nrow(M)} 
for every \code{i}. 
Note that all the columns from \code{M} sum up exactly \code{1}.
This leads to an expression to compute PageRank:

\deqn{
\textrm{PR} = (1 - d)p \cdot(I - dM)^{-1}
}{
PR = (1 - d)*p*(I - d*M)^(-1)
}

The idea behind the method \code{"pagerank"} is closely related 
to \code{"diffusion"}. 
Relevant metabolites are the sources of new random walks and 
nodes are scored through their PageRank. 
Specifically, \code{p} is set to a uniform probability on the 
input metabolites. 
More details on the setup can be found in 
the supplementary file S3 from [Picart-Armada, 2017].

There is an important detail for \code{"diffusion"} 
and \code{"pagerank"}: the scores are statistically normalised. 
Omitting this normalisation leads to a systematic bias, 
especially in pathway nodes, as described in [Picart-Armada, 2017]. 

Therefore, in both cases, scores undergo a normalisation 
through permutation analysis. 
The score of a node \code{i} is compared to its null distribution 
under input permutation, leading to their p-scores. 
As described in [Picart-Armada, 2017], two alternatives are offered: 
a parametric and deterministic approach 
and a non-parametric, stochastic one.

Stochastic Monte Carlo trials (\code{"simulation"}) imply 
randomly permuting the input \code{niter} times and counting, 
for each node \code{i}, how many trials 
led to an equally or more extreme value than the original score. 
An empirical p-value is returned [North, 2002].

On the other hand, the parametric 
scores (\code{approx = "normality"}) 
give a z-score for such permutation analysis. 
The expected value and variance of such null distributions 
are known quantities, see supplementary 
file S4 from [Picart-Armada, 2017].
To work in the same range \code{[0,1]}, z-scores are 
transformed using the routine \code{\link[stats:Normal]{pnorm}}. 
The user can also choose the Student's t using 
\code{approx = "t"} and choosing a number of degrees of freedom 
through \code{t.df}. 
This uses the function \code{\link[stats:TDist]{pt}} instead.
Alternatively, a gamma distribution can be used by setting 
\code{approx = "gamma"}. 
The theoretical mean (E) and variance (V) 
are used to define the shape 
(E^2/V) and scale (V/E) of the gamma distribution, and 
\code{\link[stats:GammaDist]{pgamma}} to map to [0,1].

Any sub-network prioritised by \code{"diffusion"} 
and \code{"pagerank"} is selected by applying 
a threshold on the p-scores.

Finally, the function \code{enrich} 
is a wrapper to perform the enrichment analysis. 
If no \code{\link{FELLA.DATA}} object is supplied, 
it loads it, maps the affected compounds and performs 
the desired enrichment(s) with a single call.
Returned is a list with the loaded 
\code{\link{FELLA.DATA}} object 
and the results in a \code{\link{FELLA.USER}} object. 
Conversely, the user can supply the 
\code{\link{FELLA.DATA}} object and the wrapper 
will map the metabolites and run the desired enrichment 
method(s). 
In this case, only the \code{\link{FELLA.USER}} 
will be returned.
}
\examples{
## Load the internal database. 
## This one is a toy example!
## Do not use as a regular database
data(FELLA.sample)
## Load a list of compounds to enrich
data(input.sample)

######################
## Example, step by step

## First, map the compounds
obj <- defineCompounds(
compounds = c(input.sample, "I_dont_map", "me_neither"), 
data = FELLA.sample)
obj
## See the mapped and unmapped compounds
getInput(obj)
getExcluded(obj)
## Compounds are already mapped 
## We can enrich using any method now

## If no compounds are mapped an error is thrown. Example:
\dontrun{
data(FELLA.sample)
obj <- defineCompounds(
compounds = c("C00049", "C00050"), 
data = FELLA.sample)}

## Enrich using hypergeometric test
obj <- runHypergeom(
object = obj, 
data = FELLA.sample)
obj

## Enrich using diffusion
## Note how the results are added;  
## the hypergeometric results are not overwritten
obj <- runDiffusion(
object = obj, 
approx = "normality", 
data = FELLA.sample)
obj

## Enrich using PageRank
## Again, this does not overwrite other methods 
obj <- runPagerank(
object = obj, 
approx = "simulation", 
data = FELLA.sample)
obj

######################
## Example using the "enrich" wrapper

## Only diffusion
obj.wrap <- enrich(
compounds = input.sample, 
method = "diffusion", 
data = FELLA.sample)
obj.wrap

## All the methods
obj.wrap <- enrich(
compounds = input.sample, 
methods = FELLA::listMethods(), 
data = FELLA.sample)
obj.wrap

}
\references{
Kanehisa, M., Furumichi, M., Tanabe, 
M., Sato, Y., & Morishima, K. (2017). 
KEGG: new perspectives on genomes, pathways, diseases and drugs. 
Nucleic acids research, 45(D1), D353-D361.

Xia, J., Sinelnikov, I. V., Han, B., & Wishart, D. S. (2015). 
MetaboAnalyst 3.0 - making metabolomics more meaningful. 
Nucleic acids research, 43(W1), W251-W257.

Fisher, R. A. (1935). The logic of inductive inference.
Journal of the Royal Statistical Society, 98(1), 39-82. 

Picart-Armada, S., Fernandez-Albert, F., Vinaixa, 
M., Rodriguez, M. A., Aivio, S., Stracker, 
T. H., Yanes, O., & Perera-Lluna, A. (2017). 
Null diffusion-based enrichment for metabolomics data. 
PLOS ONE, 12(12), e0189012.

Vandin, F., Upfal, E., & Raphael, B. J. (2011). 
Algorithms for detecting significantly mutated pathways 
in cancer. Journal of Computational Biology, 18(3), 507-522.

Page, L., Brin, S., Motwani, R., & Winograd, T. (1999). 
The PageRank citation ranking: Bringing order to the web. 
Stanford InfoLab.

Csardi, G., & Nepusz, T. (2006). The igraph software package 
for complex network research. 
InterJournal, Complex Systems, 1695(5), 1-9.

North, B. V., Curtis, D., & Sham, P. C. (2002). 
A note on the calculation of empirical P values 
from Monte Carlo procedures. 
American journal of human genetics, 71(2), 439.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/list-.R
\name{listCategories}
\alias{listCategories}
\title{List of node categories}
\usage{
listCategories()
}
\value{
Character vector
}
\description{
Node categories used in the internal representations
}
\examples{
listCategories()

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R
\docType{class}
\name{U.diffusion-class}
\alias{U.diffusion-class}
\title{An internal S4 class for the user data 
of the diffusion enrichment analysis}
\description{
An internal S4 class for the user data 
of the diffusion enrichment analysis
}
\section{Slots}{

\describe{
\item{\code{valid}}{Logical value; is the analysis valid?}

\item{\code{pscores}}{Named numeric vector with p-scores}

\item{\code{approx}}{Character; which approximation was used? 
Can be "simulation" for Monte Carlo; 
"normality", "gamma" or "t" for parametric approaches}

\item{\code{niter}}{Numeric value, number of iterations 
for the simulated approach}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/launchApp.R
\name{launchApp}
\alias{launchApp}
\title{Launch a shiny app with FELLA}
\usage{
launchApp(...)
}
\arguments{
\item{...}{Parameters passed to \code{\link[shiny]{runApp}}}
}
\value{
\code{invisible()}, but as a side effect the app will be launched
}
\description{
\code{\link[FELLA]{launchApp}} deploys a shiny application 
to perform the metabolomics data enrichment. 
Although this app does not provide all the options available in 
\code{\link[FELLA]{FELLA}}, it is easily accessible for the lay user.
}
\details{
The graphical interface allows to: (1) upload the data and 
check if the KEGG ids have successfully mapped, 
(2) select database, set analysis and graphical parameters, 
(3) interactively browse the resulting sub-network as a graph or 
as a table, and (4) export such results as a table or a network. 
At least one database is needed before deploying the app. 
See \code{?buildDataFromGraph} for further details.
}
\examples{
\dontrun{
r <- try(launchApp())
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get-.R
\name{getInfo}
\alias{getInfo}
\title{Get KEGG version info}
\usage{
getInfo(data)
}
\arguments{
\item{data}{FELLA.DATA object}
}
\value{
Character containing the KEGG release details
}
\description{
Extractor function for the info about the KEGG version used to 
build the FELLA.DATA object
}
\examples{
data(FELLA.sample)
getInfo(FELLA.sample)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get-.R
\name{getExcluded}
\alias{getExcluded}
\title{Get excluded compounds}
\usage{
getExcluded(object)
}
\arguments{
\item{object}{FELLA.USER object}
}
\value{
Vector of the excluded compounds
}
\description{
Extractor function for the compounds in the input 
that were not mapped to the KEGG graph
}
\examples{
data(FELLA.sample)
data(input.sample)

## No excluded compounds
obj <- defineCompounds(
compounds = input.sample, 
data = FELLA.sample)
getExcluded(obj)

## One compound does not map
## The user gets a warning as well
obj <- defineCompounds(
compounds = c(input.sample, "intruder"), 
data = FELLA.sample)
getExcluded(obj)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generateResultsTable.R,
%   R/generateEnzymesTable.R, R/generateResultsGraph.R, R/exportResults.R,
%   R/addGOToGraph.R, R/plotGraph.R
\name{export-funs}
\alias{export-funs}
\alias{generateResultsTable}
\alias{generateEnzymesTable}
\alias{generateResultsGraph}
\alias{exportResults}
\alias{addGOToGraph}
\alias{plotGraph}
\title{Generate and manipulate tables and sub-networks from an enrichment}
\usage{
generateResultsTable(method = "diffusion", threshold = 0.05,
    plimit = 15, nlimit = 250, LabelLengthAtPlot = 45,
    capPscores = 1e-06, object = NULL, data = NULL, ...)

generateEnzymesTable(method = "diffusion", threshold = 0.05,
    nlimit = 250, LabelLengthAtPlot = 45, capPscores = 1e-06,
    mart.options = list(biomart = "ensembl", dataset =
    "hsapiens_gene_ensembl"), object = NULL, data = NULL, ...)

generateResultsGraph(method = "diffusion", threshold = 0.05,
    plimit = 15, nlimit = 250, thresholdConnectedComponent = 0.05,
    LabelLengthAtPlot = 22, object = NULL, data = NULL, ...)

exportResults(format = "csv", file = "myOutput",
    method = "diffusion", object = NULL, data = NULL, ...)

addGOToGraph(graph = NULL, GOterm = NULL, godata.options = list(OrgDb
    = "org.Hs.eg.db", ont = "CC"), mart.options = list(biomart = "ensembl",
    dataset = "hsapiens_gene_ensembl"))

plotGraph(graph = NULL, layout = FALSE, graph.layout = NULL,
    plotLegend = TRUE, plot.fun = "plot.igraph", NamesAsLabels = TRUE,
    ...)
}
\arguments{
\item{method}{one in \code{"diffusion"}, \code{"pagerank"}}

\item{threshold}{Numeric value between 0 and 1. 
\code{p.score} threshold applied when filtering KEGG nodes. 
Lower thresholds are more stringent.}

\item{plimit}{Pathway limit, must be a numeric value between 1 and 50. 
Limits the amount of pathways in \code{method = "hypergeom"}}

\item{nlimit}{Node limit, must be a numeric value between 1 and 1000. 
Limits the order of the solution sub-graph when 
in \code{method = "diffusion"} and \code{method = "pagerank"}}

\item{LabelLengthAtPlot}{Numeric value between 10 and 50. 
Maximum length that a label can reach when plotting the graph. 
The remaining characters will be truncated using "..."}

\item{capPscores}{Numeric value, minimum p-score 
admitted for the readable 
formatting. Smaller p-scores will be displayed 
as \code{< capPscores}}

\item{object}{FELLA.USER object}

\item{data}{FELLA.DATA object}

\item{...}{Optional arguments for the plotting function 
in \code{plotGraph}. Arguments passed to the exporting function 
in \code{exportResults}. Ignored otherwise.}

\item{mart.options}{List, options for the \code{biomaRt} function
\code{\link[biomaRt]{getBM}}. Importantly, this defines the organism, 
see \code{\link[biomaRt]{listDatasets}} for possibilities. 
If calling \code{generateEnzymesTable}, the user can set 
\code{mart.options = NULL} to avoid adding GO labels to enzymes.}

\item{thresholdConnectedComponent}{Numeric value between 0 and 1. 
Connected components that are below the threshold are kept, 
while the ones exceeding it (because they are too small) are discarded.}

\item{format}{Character, one of: \code{"csv"} for regular 
results table, \code{"enzyme"} for table with enzyme data, 
\code{"igraph"} for igraph format. 
Alternatively, any format supported by igraph, 
see \code{\link[igraph]{write_graph}}}

\item{file}{Character specifying the output file name}

\item{graph}{An \pkg{igraph} object, 
typically a small one, 
coming from an enrichment through \code{"diffusion"} or \code{"pagerank"}.}

\item{GOterm}{Character, GO entry to draw 
semantic similarity in the solution graph. 
If \code{NULL}, the GO labels will be appended without similarities.}

\item{godata.options}{List, options for the database creator 
\code{\link[GOSemSim]{godata}}}

\item{layout}{Logical, should the plot be returned as a layout?}

\item{graph.layout}{Two-column numeric matrix, 
if this argument is not null 
then it is used as graph layout}

\item{plotLegend}{Logical, should the legend be plotted as well?}

\item{plot.fun}{Character, can be either 
\code{plot.igraph} or \code{tkplot}}

\item{NamesAsLabels}{Logical, should KEGG names be displayed 
as labels instead of KEGG identifiers?}
}
\value{
\code{generateResultsTable} returns a 
data.frame that contains the nodes below the \code{p.score} threshold 
from an enrichment analysis

\code{generateEnzymesTable} returns a 
data.frame that contains the enzymes below the \code{p.score} threshold,
along with their genes and GO labels

\code{generateResultsGraph} returns 
an \pkg{igraph}
object: a sub-network from the whole 
KEGG knowledge model under the specified thresholds 
(\code{threshold} and \code{thresholdConnectedComponent})

\code{exportResults} returns \code{invisible()}, 
but as a side effect the specified \code{file} is created.

\code{addGOToGraph} returns 
an \pkg{igraph} object, 
which is the input \code{graph} with 
extra attributes: GO labels in \code{V(graph)$GO}, and 
semantic similarities in \code{V(graph)$GO.simil} if 
\code{GOterm != NULL}

\code{plotGraph} returns 
\code{invisible()} if \code{layout = F} and 
the plotting layout as a data.frame otherwise.
}
\description{
In general, \code{generateResultsTable}, \code{generateEnzymesTable} 
and \code{generateResultsGraph} provide the results of an enrichment 
in several formats. 

Function \code{generateResultsTable} returns a table 
that contains the best hits from
a \code{\link{FELLA.USER}} object 
with a successful enrichment analysis.
Similarly, \code{generateEnzymesTable} returns 
a data frame with the best scoring enzyme families and their 
annotated genes.

Function \code{generateResultsGraph} 
gives a sub-network, plottable through 
\code{plotGraph}, witht the nodes with 
the lowest \code{p.score} from an enrichment analysis. 
Function \code{addGOToGraph} can be applied to such 
sub-networks to overlay GO labels and 
similarity to a user-defined GO term.

Function \code{exportResults} 
is a wrapper around \code{generateResultsTable}, 
\code{generateEnzymesTable} and \code{generateResultsGraph} 
to write the results to files.
}
\details{
Functions \code{generateResultsTable} and 
\code{generateEnzymesTable} need a 
\code{\link{FELLA.DATA}} object and a 
\code{\link{FELLA.USER}} object with a successful enrichment.
\code{generateResultsTable} provides the entries 
whose p-score is below the chosen \code{threshold} in a tabular format. 
\code{generateEnzymesTable} returns a table 
that contains (1) the enzymes that are below the user-defined 
p-score threshold, along with (2) the genes that belong to 
the enzymatic families in the organism defined in the database, 
and (3) GO labels of such enzymes, if \code{mart.options} is 
not \code{NULL} and points to the right database.

Function \code{generateResultsGraph} returns an 
\pkg{igraph} 
object with a relevant sub-network 
for manual examination. 
A \code{\link{FELLA.USER}} 
object with a successful enrichment analysis and the corresponding 
\code{\link{FELLA.DATA}} must be supplied. 
Graph nodes are prioritised by \code{p.score} and selected through 
the most stringent between (1) p.score \code{threshold} and 
(2) maximum number of nodes \code{nlimit}. 

There is an additional filtering feature for tiny connected components, 
controllable through \code{thresholdConnectedComponent} 
(smaller is stricter). 
The user can choose to turn off this filter by setting 
\code{thresholdConnectedComponent = 1}.  
The idea is to discard connected components so small 
that are likely to arise from random selection of nodes. 
Let \code{k} be the order of the current sub-network.
A connected component of order \code{r} will
be kept only if the probability that a 
random subgraph from the whole KEGG knowledge model 
of order \code{k} contains a
connected component of order at least \code{r} 
is smaller than \code{thresholdConnectedComponent}. 
Such probabilities are estimated during 
\code{\link[=data-funs]{buildDataFromGraph}}; the amount of random 
trials can be controlled by its \code{niter} argument.

Function \code{exportResults} writes the enrichment results 
as the specified filetype.
Options are: a csv table (\code{"csv"}), 
an enzyme csv table (\code{"enzyme"}) 
an \pkg{igraph}
object as an \code{RData} file, 
or any format supported by igraph's 
\code{\link[igraph]{write_graph}}.

Function \code{addGOToGraph} takes and returns 
a graph object with class 
\pkg{igraph} 
adding the following attributes: 
GO labels in \code{V(graph)$GO}, and 
semantic similarities in \code{V(graph)$GO.simil} if 
\code{GOterm != NULL}. 

The GO database describes genes in terms of three ontologies: 
molecular function (MF), biological process (BP) and 
cellular component (CC) [Gene Ontology Consortium, 2015].
The user can be interested in finding which enzymatic families 
reported with a low \code{p.score}
are closest to a particular GO term. 
To assess similarity between GO labels, FELLA uses the 
semantic similarity defined in [Yu, 2010] and their implementation 
in the \pkg{GOSemSim} R package. 
The user will obtain, for each enzymatic family, the closest GO 
term to his or her GO query and the semantic similarity between them. 
Exact matches have a similarity of \code{1}. 
Function \code{plotGraph} detects the presence 
of the GO similarity option and plots its magnitude.

Function \code{plotGraph} 
plots a solution graph from the diffusion and pagerank analysis. 
For plotting hypergeom results, please use \code{plot} instead. 
Specific colors and shapes for each KEGG category are used: 
pathways are maroon, modules are violet, enzymes are orange, 
reactions are blue and compounds are green. 
If the graph contains the similarity to a GO term, enzymes will 
be displayed as triangles whose color depicts the strength of 
such measure (yellow: weak, purple: strong). 
At the moment, \code{plotGraph} allows plotting 
throug the static \code{\link[igraph]{plot.igraph}} and the 
interactive \code{\link[igraph]{tkplot}}.
}
\examples{
## First generate a toy enrichment
library(igraph)
data(FELLA.sample)
data(input.sample)
## Enrich input
obj <- enrich(
compounds = input.sample, 
data = FELLA.sample)

######################
## Results table
tab.res <- generateResultsTable(
method = "hypergeom",
threshold = 0.1, 
object = obj, 
data = FELLA.sample)
head(tab.res)

tab.res <- generateResultsTable(
method = "diffusion",
threshold = 0.1, 
object = obj, 
data = FELLA.sample)
head(tab.res)

######################
## Use wrapper to write the table to a file
out.file <- tempfile()
exportResults(
format = "csv", 
threshold = 0.1, 
file = out.file, 
object = obj, 
data = FELLA.sample)
tab.wrap <- read.csv(out.file)
head(tab.wrap)

######################
## Enzymes table
tab.ec <- generateEnzymesTable(
threshold = 0.1, 
object = obj, 
data = FELLA.sample, 
mart.options = NULL)
head(tab.ec)

######################
## Generate graph
g.res <- generateResultsGraph(
method = "pagerank", 
threshold = 0.1, 
object = obj, 
data = FELLA.sample)
g.res

## Plot graph (without GO terms)
plotGraph(g.res)

## Add similarity to the GO CC term "mitochondrion"
\dontrun{
g.cc <- FELLA:::addGOToGraph(
graph = g.res, 
GOterm = "GO:0005739")

## Plot graph (with GO terms)
plotGraph(g.cc)

## Without the CC
any(V(g.res)$GO.simil >= 0)
## With the CC
v.cc <- unlist(V(g.cc)$GO.simil)
sum(v.cc >= 0, na.rm = TRUE)
## Similarity values
table(v.cc)
}

}
\references{
Gene Ontology Consortium. (2015). 
Gene ontology consortium: going forward. 
Nucleic acids research, 43(D1), D1049-D1056.

Yu, G., Li, F., Qin, Y., Bo, X., Wu, Y., & Wang, S. (2010). 
GOSemSim: an R package for measuring semantic similarity 
among GO terms and gene products. Bioinformatics, 26(7), 976-978.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotLegend.R
\name{plotLegend}
\alias{plotLegend}
\title{Internal function to add a legend to a graph plot}
\usage{
plotLegend(GO.annot = FALSE, cex = 0.75)
}
\arguments{
\item{GO.annot}{Logical, should GO annotations be included?}

\item{cex}{Numeric value, \code{cex} parameter for the function 
\code{\link[graphics]{legend}}}
}
\value{
This function is only used for its effect, 
so it returns \code{invisible()}
}
\description{
This function adds a legend to a solution plot. 
It can include the CC similarity.
}
\examples{
## This function is internal

library(igraph)
g <- barabasi.game(20)
plot(g)
FELLA:::plotLegend()
plot(g)
FELLA:::plotLegend(GO.annot = TRUE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotGraph.R
\name{mytriangle}
\alias{mytriangle}
\title{Add triangular shape to igraph plot}
\usage{
mytriangle(coords, v = NULL, params)
}
\arguments{
\item{coords, v, params}{clipping arguments, see 
\code{\link[igraph]{shapes}}}
}
\value{
Plot symbols
}
\description{
This function enables the usage of triangles as shape in 
the function \code{\link[igraph]{plot.igraph}}.
}
\examples{
## This function is internal
library(igraph)

add.vertex.shape(
"triangle", clip = shapes("circle")$clip,
plot = FELLA:::mytriangle)

g <- barabasi.game(10)
plot(
g, vertex.shape = "triangle", 
vertex.color = rainbow(vcount(g)),
vertex.size = seq(10, 20, length = vcount(g)))

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/doc-data.R
\docType{data}
\name{input.sample}
\alias{input.sample}
\title{A randomly generated list of affected metabolites}
\format{An object of class \code{character} of length 30.}
\source{
Generated from a mid-2017 KEGG release 
(\url{http://www.genome.jp/kegg/})
}
\usage{
data(input.sample)
}
\value{
A \code{character} vector containing 30 KEGG IDs
}
\description{
This \code{character} vector object has been 
generated using the 
sample data in the object \code{FELLA.sample}. 
The KEGG compounds have been chosen 
with preference for the hsa00640 pathway, 
so that the enrichment results choose 
pathway hsa00640 over hsa00010.
}
\examples{
data(input.sample)
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get-.R
\name{getName}
\alias{getName}
\title{Map KEGG identifiers to KEGG names}
\usage{
getName(data, id)
}
\arguments{
\item{data}{FELLA.DATA object}

\item{id}{KEGG IDs whose name is desired}
}
\value{
List whose names are KEGG IDs and 
whose entries are the vectors of matches
}
\description{
Map KEGG identifiers to KEGG names, multiple names 
for an ID are reported if annotated. 
The KEGG identifiers may have mixed levels.
}
\examples{
data(FELLA.sample)
getName(FELLA.sample, c("C00002", "C00040"))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/buildGraphFromKEGGREST.R
\name{sanitise}
\alias{sanitise}
\title{ID sanitiser function}
\usage{
sanitise(x, category, organism)
}
\arguments{
\item{x}{Character vector, IDs to sanitise}

\item{category}{Character, one of: 
\code{"pathway"}, \code{"module"}, \code{"enzyme"}, 
\code{"ncbi"}, \code{"reaction"}, \code{"compound"}}
}
\value{
Character vector, sanitised \code{x}
}
\description{
Sanitise KEGG identifiers
}
\examples{
FELLA:::sanitise(c("path:hsa00010", "path:hsa00020"), "pathway", "hsa")

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get-.R
\name{getPscores}
\alias{getPscores}
\title{Get p-scores from the desired methodology}
\usage{
getPscores(object, method)
}
\arguments{
\item{object}{FELLA.USER object}

\item{method}{Character, exactly one of: 
\code{"hypergeom"}, \code{"diffusion"}, \code{"pagerank"}}
}
\value{
Named vector of p-scores
}
\description{
Extractor function for the p-scores using the desired methodology
}
\examples{
data(FELLA.sample)
data(input.sample)
obj <- enrich(
compounds = input.sample, 
data = FELLA.sample)
p <- getPscores(obj, "diffusion")
sum(p < 0.1)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R
\docType{class}
\name{U.userinput-class}
\alias{U.userinput-class}
\title{An internal S4 class for the user input data}
\description{
An internal S4 class for the user input data
}
\section{Slots}{

\describe{
\item{\code{metabolites}}{Character vector containing 
the affected compounds}

\item{\code{metabolitesbackground}}{Character vector containing 
the compounds for the personalised background. 
Optionally, can be \code{NULL} for default background}

\item{\code{excluded}}{Character vector containing 
the compounds that have been 
excluded because they cannot be mapped to KEGG graph compounds}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R
\docType{class}
\name{U.hypergeom-class}
\alias{U.hypergeom-class}
\title{An internal S4 class for the user data 
of the hypergeometric over representation 
analysis}
\description{
An internal S4 class for the user data 
of the hypergeometric over representation 
analysis
}
\section{Slots}{

\describe{
\item{\code{valid}}{Logical value; is the analysis valid?}

\item{\code{pvalues}}{Named numeric vector with p-values}

\item{\code{pathhits}}{Numeric named vector with 
the quantities "sample_success" 
for the hypergeometric distribution (#affected in path)}

\item{\code{pathbackground}}{Numeric named vector with 
the quantities "total_success" 
for the hypergeometric distribution (total in path)}

\item{\code{nbackground}}{Numeric value, number of compoudns in the background. 
Equivalently, number of rows for the hypergeometric binary matrix}

\item{\code{ninput}}{Numeric value, number of affected compounds matched to the 
rownames}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotBipartite.R
\name{plotBipartite}
\alias{plotBipartite}
\title{Internal function to plot a bipartite graph}
\usage{
plotBipartite(graph = NULL, layout = FALSE, ...)
}
\arguments{
\item{graph}{Graph result that must come from the 
hypergeometric test analysis}

\item{layout}{Logical, should the plot be returned as a layout?}

\item{...}{Additional parameters passed to 
\code{\link[igraph]{plot.igraph}}}
}
\value{
If \code{layout = F} then the value 
returned is \code{invisible()}. 
Otherwise, the layout is returned, also in an invisible fashion.
}
\description{
This function plots a bipartite graph, tailored for the hypergeometric 
over representation analysis. As the nodes can only be compounds and 
pathways, the layout is simple and bipartite.
}
\examples{
## This function is internal
data(FELLA.sample)
data(input.sample)
## Enrich input
obj <- enrich(
compounds = input.sample, 
data = FELLA.sample, 
method = "hypergeom")
## Generate the bipartite graph (only in the hypergeometric test)
g <- generateResultsGraph(
method = "hypergeom", 
threshold = 1, 
object = obj, 
data = FELLA.sample)
## Plot it
FELLA:::plotBipartite(g)

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get-.R
\name{getStatus}
\alias{getStatus}
\title{Get the slot "status"}
\usage{
getStatus(data)
}
\arguments{
\item{data}{FELLA.DATA object}
}
\value{
Slot "status" (internal usage)
}
\description{
Extractor function for the slot "status" for the KEGG data
}
\examples{
## This function is internal

data(FELLA.sample)

## Is the object loade?
FELLA:::getStatus(FELLA.sample)
FELLA:::getStatus(new("FELLA.DATA"))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get-.R
\name{getInput}
\alias{getInput}
\title{Get metabolites in the input}
\usage{
getInput(object)
}
\arguments{
\item{object}{FELLA.USER object}
}
\value{
Vector of metabolites in the input
}
\description{
Extractor function for the metabolites 
specified by the user in the input
}
\examples{
data(FELLA.sample)
data(input.sample)

## No excluded compounds: the input is recovered as is
obj <- defineCompounds(
compounds = input.sample, 
data = FELLA.sample)
i1 <- getInput(obj)

## One compound does not map: the input contains only the mapped entities
obj <- defineCompounds(
compounds = c(input.sample, "intruder"), 
data = FELLA.sample)
i2 <- getInput(obj)

identical(sort(i1), sort(i2))
}
